--
-- Aardvark
-- Version: AR 12.14.100005
-- Author: Walkerbo
-- Email: walkerbo.saurfang@gmail.com
-- Date: Tuesday 7 March 2023
--

-- I have tried to name variables, functions, frames, and buttons to be more descriptive

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Metrics, Lists & Variables          ===========================
-- ===================================================================================================
-- ===================================================================================================

local addonName = "Aardvark"
local versionNumber = "AR 12.14.100005"
local playerName = UnitName("player")

-- ===========================           action bar buttons          ===========================
local ActionBarAardvarkButton,
    ActionBarDestroyButton,
    ActionBarDestroyCharacterButton,
    ActionBarDestroyGlobalButton,
    ActionBarProtectCharacterButton,
    ActionBarProtectGlobalButton,
    ActionBarSellButton,
    ActionBarSellCharacterButton,
    ActionBarSellGlobalButton

-- ===========================         table of variables          ===========================
local VariableList = {
    currentItemID = 0,
    destroyedItemCount = 0,
    destroyedSlotCount = 0,
    profitCounter = 0,
    repairAmount = 0,
    repairMessageType = "",
    sellDelay = .5,
    tempCharacterDestroyTable = {},
    tempCharacterProtectTable = {},
    tempCharacterSellTable = {},
    tempGlobalDestroyTable = {},
    tempGlobalProtectTable = {},
    tempGlobalSellTable = {},
    tempSellList = {},
    vendorClosed = true
}

-- ===========================         table of images          ===========================
local ImageList = {
    avkBanner = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkBanner", --  Aardvark Banner
    avkButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButton", --  Aardvark Buttons
    avkButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButtonHover",
    avkCloseButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButton",
    avkCloseButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButtonHover",
    bulkAddCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\bulkAddCharacter", -- Aardvark Bulk Add Buttons
    bulkAddCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\bulkAddCharacterHover",
    bulkAddGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\bulkAddGlobal",
    bulkAddGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\bulkAddGlobalHover",
    destroyButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButton", -- Aardvark Destroy Buttons
    destroyButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButtonHover",
    destroyCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacter",
    destroyCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacterHover",
    destroyItemDot = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyItemDot",
    destroyFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFilters",
    destroyFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFiltersHover",
    destroyGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobal",
    destroyGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobalHover",
    destroyOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptions",
    destroyOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptionsHover",
    destroySpecialAdd = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroySpecialAdd",
    destroySpecialAddHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroySpecialAddHover",
    infoButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\infoButton", -- Aardvark Info Buttons
    infoButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\infoButtonHover",
    protectButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButton", -- Aardvark Protect Buttons
    protectButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButtonHover",
    protectCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacter",
    protectCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacterHover",
    protectItemDot = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectItemDot",
    protectFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFilters",
    protectFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFiltersHover",
    protectGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobal",
    protectGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobalHover",
    protectOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptions",
    protectOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptionsHover",
    protectSpecialAdd = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectSpecialAdd",
    protectSpecialAddHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectSpecialAddHover",
    repairButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButton", -- Aardvark Repair Buttons
    repairButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButtonHover",
    sellButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButton", -- Aardvark Sell Buttons
    sellButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButtonHover",
    sellCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacter",
    sellCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacterHover",
    sellItemDot = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellItemDot",
    sellFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFilters",
    sellFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFiltersHover",
    sellGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobal",
    sellGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobalHover",
    sellOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptions",
    sellOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptionsHover",
    sellOutOfRange = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOutOfRange",
    sellSpecialAdd = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellSpecialAdd",
    sellSpecialAddHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellSpecialAddHover"
}

-- ===========================         font objects          ===========================
local FontCheckBoxBig = CreateFont("FontCheckBoxBig")
FontCheckBoxBig:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\neuropol.ttf", 29, "")
local FontCheckBox = CreateFont("FontCheckBox")
FontCheckBox:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 17, "")
local FontContent = CreateFont("FontContent")
FontContent:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 14.7, "")
local FontFilter = CreateFont("FontFilter")
FontFilter:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 15, "")
local FontTitleScroll = CreateFont("FontTitleScroll")
FontTitleScroll:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 20, "")
local FontButton = CreateFont("FontButton")
FontButton:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 15, "")

-- ===========================         table of font colours          ===========================
local ColourList = {
    rarityArtifact = "|cffe6cc80", --  Artifact rgb(230, 204, 128)
    rarityCommon = "|cffffffff", -- Common rgb(255, 255, 255)
    rarityEpic = "|cffa335ee", -- Epic rgb(163, 53, 238)
    rarityHeirloom = "|cff00ccff", --  Heirloom rgb(0, 204, 255)
    rarityLegendary = "|cffff8000", --  Legendary rgb(255, 128, 0)
    rarityOther = "|cff00ccff", --  Other rgb(100, 0, 0)
    rarityPoor = "|cff9d9d9d", --  Poor rgb(157, 157, 157)
    rarityRare = "|cff0070dd", --  Rare rgb(0, 112, 221)
    rarityUncommon = "|cff1eff00", --  Uncommon rgb(30, 255, 0)
    textBlue = "|cff00ffff", -- rgb(0,255,255)
    textBluePrefix = "|cff00ffff [" .. addonName .. "]: ", -- rgb(0,255,255)
    textBluePrefixSuffix = "|cff00ffff [" .. addonName .. "]: |r", -- rgb(0,255,255)
    textGreen = "|cff00ff00", -- rgb(0,255,0)
    textOrange = "|cffff8c00", -- rgb(255,140,0)
    textPink = "|cffff00ff", -- rgb(255,0,255)
    textRed = "|cffff0000", -- rgb(255,0,0)
    textYellow = "|cfffffff0" -- rgb(255,255,0)
}

-- ===========================         table of strings          ===========================
local TextList = {
    avkLoad = (ColourList.textBlue .. " *** " .. addonName .. " - " .. versionNumber .. " Loaded *** \n"), -- load message
    avkSlashCommands = ("Slash Commands:\n\n" ..
        ColourList.textBlue ..
            "/avk |r ~  Show/Hide Aardvark frame\n" ..
                ColourList.textBlue ..
                    "/avkdestroy |r ~  Destroy function\n" ..
                        ColourList.textBlue ..
                            "/avkclear |r ~  Clear all lists\n" ..
                                ColourList.textBlue ..
                                    "/avkpos |r ~  Reset Aardvark frame and button positions\n" ..
                                        ColourList.textBlue .. "/avkrsd |r ~  Reset all Aardvark settings to default\n"), -- options text
    avkSellOptions = ("The " ..
        ColourList.textGreen ..
            "Aardvark Sell|r function can sometimes lag depending on the size of your list and the number items you have in your bags.\n\nIf this occurs turn on the  action bar and spam the sell button.\n\nI will continue to tinker with the sell function to try and remove this issue."), -- sell text
    avkDestroyOptions = ("The " ..
        ColourList.textRed ..
            "Aardvark Destroy|r function will destroy|r the items that you have added to your destroy lists regardless of bind, value, rarity or colour.\n\n" ..
                ColourList.textRed ..
                    "Destroyed items CANNOT be recovered.|r\n\nThere are no take backs, no do-overs, no whoops didn't mean to do that, etc.\n\nThe only way to  recover a destroyed item is to go and farm it again.\n\n" ..
                        ColourList.textRed .. "You have been warned!"), -- destroy text
    avkRepairOptions = ("The " ..
        ColourList.textPink ..
            "Aardvark Repair|r function operates after the destroy function and prior to the\n sell function.\n\n Damaged items must\n be repaired before\n they can  be sold."), -- repair text
    avkProtectOptions = ("The " ..
        ColourList.textOrange ..
            "Aardvark Protect|r function was created to protect those special items that you want to ensure are not sold or destroyed even if they are listed in your other sell and/or destroy lists.\n\nThe protect lists have no restrictions which means you can protect any item regardless of colour or value."), -- protect text
    avkMagicButton = ("Drag&Drop/Click&Drop: Add Item to Character List\nDrag&Drop/Click&Drop + Alt: Add Item to Global List\nDrag&Drop/Click&Drop + Ctrl: Add Item to Global Protect List\nDrag&Drop/Click&Drop + Shift: Add Item to Character Protect List\nLeft Click: Show/Hide Aardvark Frame\nMiddle Click + Drag: Move Aardvark Button\nMiddle Click + Drag: Move Aardvark Action Bar\nRight Click: Destroy Listed Items"), -- aardvark button tooltip text
    avkAboutAardvark = ("There once was a little blue Aardvark that grew up in Azeroth.\n\nHe loved to farm, spending all day and half of the night digging up herbs, mining ore, weaving cloth and collecting little treasures.\n\nAfter few years he started to develop RSI in his little paws as he was always clicking to sell items that he didn't want, dragging and dropping items that he couldn't sell and, in a lot of cases, deleting items just to clean out his bags ready to farm again.\n\nOne day after an extremely long day of farming he thought;" ..
        ColourList.textBlue ..
            '\n"What if I could open my bags and have all the stuff I don\'t want just magically disappear?"|r \n\nWith this thought he started to teach his little arthritic paws how to code.\nHis code is very messy, overly long and undoubtedly very inefficient but it does what he wants it to do.\n\nHopefully you can find it useful too.'), -- aardvark text
    avkKeybinds = "Keybinds:\n\nDefault keybinds have now been removed due to conflicts with some blizzard and other addon keybinds.\n\nKeybinds are still enabled for players to set themselves.\n\nYou can set your own keybinds in Key Bindings UI.", -- keybinds Text
    avkSpecialAddRemove = "To add/remove items enter the Item ID  and then click on the desired list button, or, drag/click and drop items on to the desired list button.", -- special add text
    avkBulkAddGlobal = "Add displayed items to your Global list.\nItems with a value will be added your Global Sell List.\nItems with no value will be added to your Global Destroy List.", -- adventure guide global bulk add tooltip text
    avkBulkAddCharacter = "Add displayed items to your Character list.\nItems with a value will be added your Character Sell List.\nItems with no value will be added to your Character Destroy List." -- adventure guide character bulk add tooltip text
}

-- ===========================         table of sizes          ===========================
local SizeList = {
    actionBarButtonGap = 5,
    actionBarContainerLong = 130,
    actionBarSmallButton = 28,
    backdropEdgeSize = 20,
    checkboxBigGapY = 40,
    checkBoxBigSize = 24,
    checkBoxChildGapX = 15,
    checkboxFilterGapX = 177,
    checkboxFilterGapY = 24,
    checkboxFilterSize = 20,
    checkboxGapY = 32,
    checkBoxNormalGapY = 34,
    clearButtonHight = 32,
    closeButtonGap = -8,
    closeButtonSize = 20,
    infoPanelTextBoxHeight = 150,
    infoPanelTextBoxWidth = 525,
    journalButtonTooltipSize = .85,
    mainFrameHeight = 580,
    mainFrameMarginGap = 10,
    mainFrameNavigationButtonSize = 40,
    mainFrameNavigationButtonSpace = 70,
    mainFrameNavigationFrameHeight = 60,
    mainFrameSetPoint = 250,
    mainFrameWidth = 610,
    mainPanelElementGap = 20,
    mainPanelHeight = 343,
    mainPanelWidth = 590,
    optionsButtonSize = 20,
    optionsFrameElementGap = 10,
    optionsFrameWidth = 360,
    scaleButtonGap = 50,
    scaleSliderMax = 1.5,
    scaleSliderMin = .5,
    scaleSliderScale = 1.2,
    scrollButtonHeight = 16,
    scrollButtonNumber = 13,
    scrollButtonWidth = 267,
    scrollFrameHeight = 223,
    scrollFrameWidth = 282,
    scrollTitleHeight = 48,
    scrollTitlePointX = 10,
    scrollTitlePointY = -16,
    textBoxWidthShrink = 35,
    toolTipAnchor = -22
}

-- ===========================         table of naughty vendors          ===========================
local VendorBlacklist = {
    98737, -- Holt Thunderhorn -- Hunter class hall
    97111, -- Illanna Dreadmoore -- Death Knight class hall
    91190, -- Sister Elda -- Paladin class hall
    87302, -- Murg -- Horde garrison inn chef
    79828, -- Murg -- Horde garrison inn chef - Yes, this is a second Murg - No, I have no idea why
    -- 77368, -- Madison Clark -- This NPC can now buy items
    63596, -- Audrey Burnhep
    27914, -- Ethereal Soul Trader
    111741, -- Fjornson Stonecarver -- Warrior class hall
    111740, -- Mile Raitheborne -- Warlock class hall
    111739, -- Gorma Windspeaker -- Shaman class hall
    111738, -- Juvess the Duskwhisperer -- Priest class hall
    111737, -- Celadine the Fatekeeper -- Druid class hall
    111736, -- Vahu the Weathered -- Demon Hunter class hall
    110624, -- Edirah -- Mage class hall
    106942, -- Lorewalker Cho -- Monk class hall
    102641 -- Filius Sparkstache -- Rogue class hall
}

-- ===========================         table of filters          ===========================
local FilterList = {
    armourCloth = true,
    armourLeather = true,
    armourMail = true,
    armourPlate = true,
    bindingNone = true,
    bindOnEquip = true,
    bindOnPickup = true,
    bindOnUse = true,
    bindOnQuest = true,
    otherBags = true,
    otherEnchantments = true,
    otherFoodDrink = true,
    otherGems = true,
    otherMounts = true,
    otherOther = true,
    otherPets = true,
    otherReagents = true,
    otherRecipes = true,
    otherToys = true,
    otherTradeskill = true,
    rarityPoor = true,
    rarityCommon = true,
    rarityUncommon = true,
    rarityRare = true,
    rarityEpic = true,
    rarityLegendary = true,
    rarityArtifact = true,
    rarityHeirloom = true,
    rarityOther = true,
    slotChest = true,
    slotCloak = true,
    slotFeet = true,
    slotHands = true,
    slotHead = true,
    slotLegs = true,
    slotMainHand = true,
    slotNeck = true,
    slotOffHand = true,
    slotRings = true,
    slotShirt = true,
    slotShoulders = true,
    slotTabard = true,
    slotTrinkets = true,
    slotWaist = true,
    slotWrists = true,
    valueValuable = true,
    valueWorthless = true,
    weaponOneHanded = true,
    weaponRanged = true,
    weaponTwoHanded = true
}

-- ===========================         global keybinding names          ===========================
BINDING_HEADER_AARDVARKKEYBINDINGTITLE = "- Aardvark -"
BINDING_NAME_AVKRUNSHOWAARDVARKUIFUNCTION = "Toggle Aardvark UI"
BINDING_NAME_AVKRUNRESETAARDVARKUIFUNCTION = "Reset Aardvark UI"
BINDING_NAME_AVKRUNCLEARALLLISTSFUNCTION = "Clear all lists"
BINDING_NAME_AVKRUNSELLFUNCTION = "Run the sell function"
BINDING_NAME_AVKRUNDESTROYFUNCTION = "Run the destroy function"
BINDING_NAME_AVKRUNADDITEMTOGLOBALLISTFUNCTION = "Add Item to global list"
BINDING_NAME_AVKRUNADDITEMTOCHARACTERLISTFUNCTION = "Add item to character list"
BINDING_NAME_AVKRUNADDITEMTOGLOBALPROTECTLISTFUNCTION = "Add item to global protect list"
BINDING_NAME_AVKRUNADDITEMTOCHARACTERPROTECTLISTFUNCTION = "Add item to character protect list"
-- BINDING_NAME_AVKREMOVEITEMFROMSELLORDESTROYLISTFUNCTION = "Remove item from sell/destroy list" -- debug
-- BINDING_NAME_AVKREMOVEITEMFROMPROTECTLISTFUNCTION = "Remove item from protect list" -- debug

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Functions          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         initialises all settings          ===========================
local function avkInitialiseSettings()
    if not AVKGlobalSettings then -- create aardvark options table if it does not already exist
        AVKGlobalSettings = {
            Aardvark = {
                amfb = true, -- aardvark magic floating button
                amfbt = true, -- aardvark magic floating button tooltip
                afab = true, -- aardvark floating action bar
                afabas = true, -- aardvark floating action bar always show
                afabv = true, -- aardvark floating action bar vertical
                abajb = true, -- aardvark bulk add journal buttons
                abajbt = true -- aardvark bulk add journal buttons tooltip
            },
            Destroy = {
                ded = true, -- destroy enable destroy
                -- dead = true, -- destroy enable auto destroy -- 9.0.2 broke auto destroy  -- debug
                dtdm = true, -- destroy total destroyed messages
                dddm = true, -- destroy detailed destroy messages
                dntdm = true, -- destroy nothing to destroy messages
                dialsm = true, -- destroy item added to list success messages
                dialfm = true, -- destroy item added to list fail messages
                dirlm = true, -- destroy item removed from list messages
                dlit = true -- destroy show listed item tooltips
            },
            Repair = {
                rer = true, -- repair enable repair
                rgr = false, -- repair guild repair
                rtrm = true, -- repair total repaired messages
                rcarm = true, -- repair cannot afford repair messages
                rntrm = true, -- repair nothing to repair messages
                rvcrm = true -- repair vendor cannot repair messages
            },
            Sell = {
                ses = true, -- sell enable sell
                seas = true, -- sell enable auto sell
                seasg = true, -- sell enable auto sell greys
                stil = false, -- sell twelve item limit
                stsm = true, -- sell total sold messages
                sdsm = true, -- sell detailed sell messages
                sntsm = true, -- sell nothing to sell messages
                sialsm = true, -- sell item added to list success messages
                sialfm = true, -- sell item added to list fail messages
                sirlm = true, -- sell item removed from list messages
                slit = true -- sell show listed item tooltips
            },
            Protect = {
                pep = true, -- protect enable protect
                pialsm = true, -- protect item added to list success messages
                pialfm = true, -- protect item added to list fail messages
                pirlm = true, -- protect item removed from list messages
                pdpm = true, -- protect display protected messages
                pcbp = true, -- protect caged battle pets
                plit = true -- protect show listed item tooltips
            },
            FrameScales = {
                amfs = 1, -- aardvark main frame scale
                ambs = 1, -- aardvark magic button scale
                aabs = 1 -- aardvark action bar scale
            }
        }
        AardvarkMainFrame:Show() -- show aardvark frame if the settings list did not already exist
    end
    for k, v in pairs(AVKGlobalSettings) do -- set all checkboxes
        for a, b in pairs(v) do
            if k ~= "FrameScales" then
                checkBoxName = ("CB" .. a)
                _G[checkBoxName]:SetChecked(b)
                if k == "Sell" and a ~= "ses" and AVKGlobalSettings.Sell.ses == false then
                    _G[checkBoxName]:Hide()
                elseif k == "Destroy" and a ~= "ded" and AVKGlobalSettings.Destroy.ded == false then
                    _G[checkBoxName]:Hide()
                elseif k == "Protect" and a ~= "pep" and AVKGlobalSettings.Protect.pep == false then
                    _G[checkBoxName]:Hide()
                elseif k == "Repair" and a ~= "rer" and AVKGlobalSettings.Repair.rer == false then
                    _G[checkBoxName]:Hide()
                end
            end
        end
    end
    if AVKGlobalSettings.Aardvark.amfb then -- show magic button if it is set to show
        AardvarkMagicButton:Show()
    else
        AardvarkAardvarkOptionsPanel.CBamfbt.Text:SetText(ColourList.rarityPoor .. " Aardvark Button Tooltip")
        CBamfbt:Disable()
        AardvarkMagicButton:Hide()
    end
    if AVKGlobalSettings.Aardvark.afab and AVKGlobalSettings.Aardvark.afabas then -- show action bar if always show is checked
        AardvarkActionBar:Show()
    end
    if not AVKGlobalSettings.Aardvark.afab then -- disable show action bar and vertical align checkboxes if action bar is disabled
        AardvarkAardvarkOptionsPanel.CBafabas.Text:SetText(ColourList.rarityPoor .. " Always Show Action Bar")
        AardvarkAardvarkOptionsPanel.CBafabv.Text:SetText(ColourList.rarityPoor .. " Vertical Align Action Bar")
        CBafabas:Disable()
        CBafabv:Disable()
        AardvarkActionBar:Hide()
    end
    if AVKGlobalSettings.Aardvark.afab and AVKGlobalSettings.Aardvark.afabas then -- show action bar if always show is checked
        AardvarkActionBar:Show()
    end
    if not AVKGlobalSettings.Aardvark.abajb then -- disable journal button tooltips if journal buttons are disabled
        AardvarkAardvarkOptionsPanel.CBabajbt.Text:SetText(ColourList.rarityPoor .. " Journal Button Tooltips")
        CBabajbt:Disable()
    end
end

-- ===========================         initialise all lists          ===========================
local function avkInitialiseLists()
    if not AVKGlobalSellTable then -- create empty global sell table if it does not already exist
        AVKGlobalSellTable = {}
    end
    if not AVKGlobalDestroyTable then -- create empty global destroy table if it does not already exist
        AVKGlobalDestroyTable = {}
    end
    if not AVKGlobalProtectTable then -- create empty global protect table if it does not already exist
        AVKGlobalProtectTable = {}
    end
    if not AVKCharacterSellTable then -- create empty character sell table if it does not already exist
        AVKCharacterSellTable = {}
    end
    if not AVKCharacterDestroyTable then -- create empty character destroy table if it does not already exist
        AVKCharacterDestroyTable = {}
    end
    if not AVKCharacterProtectTable then -- create empty character protect table if it does not already exist
        AVKCharacterProtectTable = {}
    end
end

-- ===========================         protect all caged pets          ===========================
local function avkProtectCagedPet()
    if AVKGlobalSettings.Protect.pcbp then
        BattlePetCageListed = false
        for k, v in pairs(AVKGlobalProtectTable) do
            if v.itemID == 82800 then
                BattlePetCageListed = true
                break
            end
        end
        if BattlePetCageListed then
            BattlePetCageListed = false
        else
            BattlePetCageListed = false
            VariableList.tempItemList = {
                itemID = 82800,
                itemName = "Pet Cage",
                itemLink = "|cff0070dd|Hitem:82800::::::::19:256::::::|h[Pet Cage]|h|r",
                itemRarity = 3,
                itemLevel = 20,
                itemMinLevel = 0,
                itemType = "Battle Pets",
                itemSubType = "BattlePet",
                itemStackCount = 1,
                itemEquipLoc = "",
                iconFileDataID = 132599,
                itemSellPrice = 0,
                itemClassID = 17,
                itemSubClassID = 0,
                bindType = 0,
                expacID = 0,
                itemSetID = nil,
                isCraftingReagent = false
            }
            table.insert(AVKGlobalProtectTable, 1, VariableList.tempItemList)
        end
        BattlePetCageListed = false
    end
end

-- ===========================         sell filters          ===========================
local function avkCheckSellFilter(itemID)
    for k, v in pairs(AVKGlobalSellTable) do
        if v.itemID == itemID then
            if
                -- filter by rarity/colour
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                -- filter by equipment slot
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                -- filter by item binding
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                -- filter mounts
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                -- filter pets
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then -- filter bags
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterSellTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
end

-- ===========================         destroy filters          ===========================
local function avkCheckDestroyFilter(itemID)
    for k, v in pairs(AVKGlobalDestroyTable) do
        if v.itemID == itemID then
            if
                -- filter by rarity/colour
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                -- filter by equipment slot
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                -- filter by item binding
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                -- filter mounts
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                -- filter pets
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then -- filter bags
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterDestroyTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
end

-- ===========================         protect filters          ===========================
local function avkCheckProtectFilter(itemID)
    for k, v in pairs(AVKGlobalProtectTable) do
        if v.itemID == itemID then
            if
                -- filter by rarity/colour
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                -- filter by equipment slot
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                -- filter by item binding
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                -- filter mounts
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                -- filter pets
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then -- filter bags
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
    for k, v in pairs(AVKCharacterProtectTable) do
        if v.itemID == itemID then
            if
                (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                    (FilterList.rarityUncommon and v.itemRarity == 2) or
                    (FilterList.rarityRare and v.itemRarity == 3) or
                    (FilterList.rarityEpic and v.itemRarity == 4) or
                    (FilterList.rarityHeirloom and v.itemRarity == 7) or
                    (FilterList.rarityLegendary and v.itemRarity == 5) or
                    (FilterList.rarityArtifact and v.itemRarity == 6)
             then
                return true
            elseif
                (FilterList.slotHead and v.itemEquipLoc == "INVTYPE_HEAD") or
                    (FilterList.slotNeck and v.itemEquipLoc == "INVTYPE_NECK") or
                    (FilterList.slotShoulders and v.itemEquipLoc == "INVTYPE_SHOULDER") or
                    (FilterList.slotCloak and v.itemEquipLoc == "INVTYPE_CLOAK") or
                    (FilterList.slotChest and v.itemEquipLoc == "INVTYPE_CHEST") or
                    (FilterList.slotShirt and v.itemEquipLoc == "INVTYPE_BODY") or
                    (FilterList.slotTabard and v.itemEquipLoc == "INVTYPE_TABARD") or
                    (FilterList.slotWrists and v.itemEquipLoc == "INVTYPE_WRIST") or
                    (FilterList.slotHands and v.itemEquipLoc == "INVTYPE_HAND") or
                    (FilterList.slotWaist and v.itemEquipLoc == "INVTYPE_WAIST") or
                    (FilterList.slotLegs and v.itemEquipLoc == "INVTYPE_LEGS") or
                    (FilterList.slotFeet and v.itemEquipLoc == "INVTYPE_FEET") or
                    (FilterList.slotRings and v.itemEquipLoc == "INVTYPE_FINGER") or
                    (FilterList.slotTrinkets and v.itemEquipLoc == "INVTYPE_TRINKET") or
                    (FilterList.slotMainHand and
                        ((v.itemEquipLoc == "INVTYPE_WEAPON") or (v.itemEquipLoc == "INVTYPE_2HWEAPON") or
                            (v.itemEquipLoc == "INVTYPE_WEAPONMAINHAND") or
                            (v.itemEquipLoc == "INVTYPE_RANGED") or
                            (v.itemEquipLoc == "INVTYPE_THROWN") or
                            (v.itemEquipLoc == "INVTYPE_RANGEDRIGHT"))) or
                    (FilterList.slotOffHand and
                        ((v.itemEquipLoc == "INVTYPE_SHIELD") or (v.itemEquipLoc == "INVTYPE_WEAPONOFFHAND") or
                            (v.itemEquipLoc == "INVTYPE_HOLDABLE")))
             then
                return true
            elseif
                (FilterList.bindingNone and v.bindType == 0) or (FilterList.bindOnPickup and v.bindType == 1) or
                    (FilterList.bindOnEquip and v.bindType == 2) or
                    (FilterList.bindOnUse and v.bindType == 3) or
                    (FilterList.bindOnQuest and v.bindType == 4)
             then
                return true
            elseif
                (FilterList.otherMounts and v.itemSubType == "Mount") or
                    (FilterList.otherMounts and v.itemSubType == "Mount Equipment")
             then
                return true
            elseif
                (FilterList.otherPets and v.itemSubType == "BattlePet") or
                    (FilterList.otherPets and v.itemSubType == "Companion Pets")
             then
                return true
            elseif (FilterList.otherBags and v.itemSubType == "Bag") then
                return true
            end
        end
    end
end

-- ===========================         update list functions          ===========================
local function avkUpdateGlobalSellList()
    -- clean temp table
    wipe(VariableList.tempGlobalSellTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKGlobalSellTable do
        if avkCheckSellFilter(AVKGlobalSellTable[index].itemID) then
            table.insert(VariableList.tempGlobalSellTable, AVKGlobalSellTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkSellPanelGlobalPanelScrollFrame,
        #VariableList.tempGlobalSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkSellPanelGlobalPanelScrollFrame)
        button = AardvarkSellPanelGlobalPanelScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalSellTable then
            button:SetText(VariableList.tempGlobalSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end
local function avkUpdateCharacterSellList()
    -- clean temp table
    wipe(VariableList.tempCharacterSellTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKCharacterSellTable do
        if avkCheckSellFilter(AVKCharacterSellTable[index].itemID) then
            table.insert(VariableList.tempCharacterSellTable, AVKCharacterSellTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkSellPanelCharacterPanelScrollFrame,
        #VariableList.tempCharacterSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkSellPanelCharacterPanelScrollFrame)
        button = AardvarkSellPanelCharacterPanelScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterSellTable then
            button:SetText(VariableList.tempCharacterSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end
local function avkUpdateGlobalDestroyList()
    -- clean temp table
    wipe(VariableList.tempGlobalDestroyTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKGlobalDestroyTable do
        if avkCheckDestroyFilter(AVKGlobalDestroyTable[index].itemID) then
            table.insert(VariableList.tempGlobalDestroyTable, AVKGlobalDestroyTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkDestroyGlobalScrollFrame,
        #VariableList.tempGlobalDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyGlobalScrollFrame)
        button = AardvarkDestroyGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalDestroyTable then
            button:SetText(VariableList.tempGlobalDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end
local function avkUpdateCharacterDestroyList()
    -- clean destroy temp table
    wipe(VariableList.tempCharacterDestroyTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKCharacterDestroyTable do
        if avkCheckDestroyFilter(AVKCharacterDestroyTable[index].itemID) then
            table.insert(VariableList.tempCharacterDestroyTable, AVKCharacterDestroyTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkDestroyCharacterScrollFrame,
        #VariableList.tempCharacterDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyCharacterScrollFrame)
        button = AardvarkDestroyCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterDestroyTable then
            button:SetText(VariableList.tempCharacterDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end
local function avkUpdateGlobalProtectList()
    avkProtectCagedPet()
    -- clean temp table
    wipe(VariableList.tempGlobalProtectTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKGlobalProtectTable do
        if avkCheckProtectFilter(AVKGlobalProtectTable[index].itemID) then
            table.insert(VariableList.tempGlobalProtectTable, AVKGlobalProtectTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkProtectPanelGlobalPanelScrollFrame,
        #VariableList.tempGlobalProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkProtectPanelGlobalPanelScrollFrame)
        button = AardvarkProtectPanelGlobalPanelScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempGlobalProtectTable then
            button:SetText(VariableList.tempGlobalProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    avkProtectCagedPet()
end
local function avkUpdateCharacterProtectList()
    -- clean temp table
    wipe(VariableList.tempCharacterProtectTable)
    -- populate temp table with the filtered items
    for index = 1, #AVKCharacterProtectTable do
        if avkCheckProtectFilter(AVKCharacterProtectTable[index].itemID) then
            table.insert(VariableList.tempCharacterProtectTable, AVKCharacterProtectTable[index]["itemLink"])
        end
    end
    -- update scroll frame
    FauxScrollFrame_Update(
        AardvarkProtectPanelCharacterPanelScrollFrame,
        #VariableList.tempCharacterProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(AardvarkProtectPanelCharacterPanelScrollFrame)
        button = AardvarkProtectPanelCharacterPanelScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.tempCharacterProtectTable then
            button:SetText(VariableList.tempCharacterProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end
-- ===========================         update list based visable panel          ===========================
local function updateListBasedOnPanel()
    if AardvarkDestroyPanel:IsVisible() then
        avkUpdateGlobalDestroyList()
        avkUpdateCharacterDestroyList()
    elseif AardvarkProtectPanel:IsVisible() then
        avkUpdateGlobalProtectList()
        avkUpdateCharacterProtectList()
    elseif AardvarkSellPanel:IsVisible() then
        avkUpdateGlobalSellList()
        avkUpdateCharacterSellList()
    end
end

-- ===========================         multiple buttons function          ===========================
local function toggleAVKPanels(buttonName)
    if buttonName == AardvarkMainFrameCloseButton then
        AardvarkMainFrame:Hide()
        AardvarkScalePanel:Hide()
        AardvarkSideFrame:Hide()
    elseif buttonName == AardvarkNavigationPanelAardvarkButton then
        AardvarkSellPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkSideFrame:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkAardvarkOptionsPanel:Show()
    elseif buttonName == AardvarkNavigationPanelSellButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkSellPanel:Show()
        if AardvarkDestroyOptionsPanel:IsVisible() or AardvarkProtectOptionsPanel:IsVisible() then
            AardvarkDestroyOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Hide()
            AardvarkSellOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationPanelDestroyButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkDestroyPanel:Show()
        if AardvarkSellOptionsPanel:IsVisible() or AardvarkProtectOptionsPanel:IsVisible() then
            AardvarkSellOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Hide()
            AardvarkDestroyOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationPanelProtectButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkProtectPanel:Show()
        if AardvarkSellOptionsPanel:IsVisible() or AardvarkDestroyOptionsPanel:IsVisible() then
            AardvarkSellOptionsPanel:Hide()
            AardvarkDestroyOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Show()
        end
        updateListBasedOnPanel()
    elseif buttonName == AardvarkNavigationPanelRepairButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideFrame:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkRepairOptionsPanel:Show()
    elseif buttonName == AardvarkNavigationPanelInfoButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideFrame:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkInfoPanel:Show()
    elseif buttonName == AardvarkNavigationPanelSillyButton then
        AardvarkAardvarkOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideFrame:Hide()
        AardvarkInfoPanel:Hide()
        AardvarkSillyPanel:Show()
    elseif buttonName == AardvarkAardvarkPanelScaleFrameButton then
        if AardvarkScalePanel:IsVisible() then
            AardvarkScalePanel:Hide()
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint("BOTTOMLEFT", AardvarkMainFrame, "BOTTOMRIGHT", 0, 0)
        else
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint("BOTTOMLEFT", AardvarkMainFrame, "BOTTOMRIGHT", 0, 0)
            AardvarkScalePanel:Show()
            AardvarkScalePanel:ClearAllPoints()
        end
    elseif buttonName == AardvarkScaleFrameCloseButton then
        AardvarkScalePanel:Hide()
    elseif buttonName == AardvarkFiltersButton then
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkSpecialRemovePanel:Hide()
        AardvarkFilterOptionsPanel:Show()
        AardvarkSideFrame:Show()
        updateListBasedOnPanel()
    elseif buttonName == AardvarkDestroyPanelOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkSpecialRemovePanel:Hide()
        AardvarkDestroyOptionsPanel:Show()
        AardvarkSideFrame:Show()
    elseif buttonName == AardvarkSellPanelOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkSpecialRemovePanel:Hide()
        AardvarkSellOptionsPanel:Show()
        AardvarkSideFrame:Show()
    elseif buttonName == AardvarkProtectPanelOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkSpecialAddPanel:Hide()
        AardvarkSpecialRemovePanel:Hide()
        AardvarkProtectOptionsPanel:Show()
        AardvarkSideFrame:Show()
    elseif buttonName == AardvarkSideFrameCloseButton then
        AardvarkSideFrame:Hide()
    elseif buttonName == AardvarkMagicButton then
        if AardvarkMainFrame:IsVisible() then
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
        end
    elseif buttonName == AardvarkFilterOptionsPanelCheckAllButton then
        CB_rarity_poor:SetChecked(true)
        CB_rarity_common:SetChecked(true)
        CB_rarity_uncommon:SetChecked(true)
        CB_rarity_rare:SetChecked(true)
        CB_rarity_epic:SetChecked(true)
        CB_rarity_legendary:SetChecked(true)
        CB_rarity_artifact:SetChecked(true)
        CB_rarity_heirloom:SetChecked(true)
        CB_slot_head:SetChecked(true)
        CB_slot_neck:SetChecked(true)
        CB_slot_shoulders:SetChecked(true)
        CB_slot_cloak:SetChecked(true)
        CB_slot_chest:SetChecked(true)
        CB_slot_shirt:SetChecked(true)
        CB_slot_tabard:SetChecked(true)
        CB_slot_wrists:SetChecked(true)
        CB_slot_hands:SetChecked(true)
        CB_slot_waist:SetChecked(true)
        CB_slot_legs:SetChecked(true)
        CB_slot_feet:SetChecked(true)
        CB_slot_rings:SetChecked(true)
        CB_slot_trinkets:SetChecked(true)
        CB_slot_mainHand:SetChecked(true)
        CB_slot_offHand:SetChecked(true)
        CB_bind_none:SetChecked(true)
        CB_bind_bop:SetChecked(true)
        CB_bind_boe:SetChecked(true)
        CB_bind_use:SetChecked(true)
        CB_bind_quest:SetChecked(true)
        CB_otherMounts:SetChecked(true)
        CB_otherPets:SetChecked(true)
        CB_otherBags:SetChecked(true)

        FilterList.armourCloth = true
        FilterList.armourLeather = true
        FilterList.armourMail = true
        FilterList.armourPlate = true
        FilterList.bindingNone = true
        FilterList.bindOnEquip = true
        FilterList.bindOnPickup = true
        FilterList.bindOnUse = true
        FilterList.bindOnQuest = true
        FilterList.otherBags = true
        FilterList.otherEnchantments = true
        FilterList.otherFoodDrink = true
        FilterList.otherGems = true
        FilterList.otherMounts = true
        FilterList.otherOther = true
        FilterList.otherPets = true
        FilterList.otherReagents = true
        FilterList.otherRecipes = true
        FilterList.otherToys = true
        FilterList.otherTradeskill = true
        FilterList.rarityPoor = true
        FilterList.rarityCommon = true
        FilterList.rarityUncommon = true
        FilterList.rarityRare = true
        FilterList.rarityEpic = true
        FilterList.rarityLegendary = true
        FilterList.rarityArtifact = true
        FilterList.rarityHeirloom = true
        FilterList.rarityOther = true
        FilterList.slotChest = true
        FilterList.slotCloak = true
        FilterList.slotFeet = true
        FilterList.slotHands = true
        FilterList.slotHead = true
        FilterList.slotLegs = true
        FilterList.slotMainHand = true
        FilterList.slotNeck = true
        FilterList.slotOffHand = true
        FilterList.slotRings = true
        FilterList.slotShirt = true
        FilterList.slotShoulders = true
        FilterList.slotTabard = true
        FilterList.slotTrinkets = true
        FilterList.slotWaist = true
        FilterList.slotWrists = true
        FilterList.valueValuable = true
        FilterList.valueWorthless = true
        FilterList.weaponOneHanded = true
        FilterList.weaponRanged = true
        FilterList.weaponTwoHanded = true

        updateListBasedOnPanel()
    elseif buttonName == AardvarkFilterUncheckAll then
        CB_rarity_poor:SetChecked(false)
        CB_rarity_common:SetChecked(false)
        CB_rarity_uncommon:SetChecked(false)
        CB_rarity_rare:SetChecked(false)
        CB_rarity_epic:SetChecked(false)
        CB_rarity_legendary:SetChecked(false)
        CB_rarity_artifact:SetChecked(false)
        CB_rarity_heirloom:SetChecked(false)
        CB_slot_head:SetChecked(false)
        CB_slot_neck:SetChecked(false)
        CB_slot_shoulders:SetChecked(false)
        CB_slot_cloak:SetChecked(false)
        CB_slot_chest:SetChecked(false)
        CB_slot_shirt:SetChecked(false)
        CB_slot_tabard:SetChecked(false)
        CB_slot_wrists:SetChecked(false)
        CB_slot_hands:SetChecked(false)
        CB_slot_waist:SetChecked(false)
        CB_slot_legs:SetChecked(false)
        CB_slot_feet:SetChecked(false)
        CB_slot_rings:SetChecked(false)
        CB_slot_trinkets:SetChecked(false)
        CB_slot_mainHand:SetChecked(false)
        CB_slot_offHand:SetChecked(false)
        CB_bind_none:SetChecked(false)
        CB_bind_bop:SetChecked(false)
        CB_bind_boe:SetChecked(false)
        CB_bind_use:SetChecked(false)
        CB_bind_quest:SetChecked(false)
        CB_otherMounts:SetChecked(false)
        CB_otherPets:SetChecked(false)
        CB_otherBags:SetChecked(false)

        FilterList.armourCloth = false
        FilterList.armourLeather = false
        FilterList.armourMail = false
        FilterList.armourPlate = false
        FilterList.bindingNone = false
        FilterList.bindOnEquip = false
        FilterList.bindOnPickup = false
        FilterList.bindOnUse = false
        FilterList.bindOnQuest = false
        FilterList.otherBags = false
        FilterList.otherEnchantments = false
        FilterList.otherFoodDrink = false
        FilterList.otherGems = false
        FilterList.otherMounts = false
        FilterList.otherOther = false
        FilterList.otherPets = false
        FilterList.otherReagents = false
        FilterList.otherRecipes = false
        FilterList.otherToys = false
        FilterList.otherTradeskill = false
        FilterList.rarityPoor = false
        FilterList.rarityCommon = false
        FilterList.rarityUncommon = false
        FilterList.rarityRare = false
        FilterList.rarityEpic = false
        FilterList.rarityLegendary = false
        FilterList.rarityArtifact = false
        FilterList.rarityHeirloom = false
        FilterList.rarityOther = false
        FilterList.slotChest = false
        FilterList.slotCloak = false
        FilterList.slotFeet = false
        FilterList.slotHands = false
        FilterList.slotHead = false
        FilterList.slotLegs = false
        FilterList.slotMainHand = false
        FilterList.slotNeck = false
        FilterList.slotOffHand = false
        FilterList.slotRings = false
        FilterList.slotShirt = false
        FilterList.slotShoulders = false
        FilterList.slotTabard = false
        FilterList.slotTrinkets = false
        FilterList.slotWaist = false
        FilterList.slotWrists = false
        FilterList.valueValuable = false
        FilterList.valueWorthless = false
        FilterList.weaponOneHanded = false
        FilterList.weaponRanged = false
        FilterList.weaponTwoHanded = false

        updateListBasedOnPanel()
    else
        print("FAILED", buttonName) -- If button does not exist
    end
end

-- ===========================         special add button function          ===========================
-- I had to split it from the multiple button function as the hierarchy kept breaking
local function specialAddPanel()
    AardvarkDestroyOptionsPanel:Hide()
    AardvarkProtectOptionsPanel:Hide()
    AardvarkSellOptionsPanel:Hide()
    AardvarkFilterOptionsPanel:Hide()
    AardvarkSpecialAddPanel:Show()
    AardvarkSpecialRemovePanel:Show()
    AardvarkSideFrame:Show()
    updateListBasedOnPanel()
end

-- ===========================         action bar layout          ===========================
local function toggleVerticalActionBar()
    if AVKGlobalSettings.Aardvark.afabv then
        AardvarkActionBar:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.actionBarContainerLong)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint("TOP")
        ActionBarDestroyButton:SetPoint("CENTER")
        ActionBarSellButton:SetPoint("BOTTOM")
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint("LEFT", ActionBarAardvarkButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            "LEFT",
            ActionBarProtectGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint("LEFT", ActionBarDestroyButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            "LEFT",
            ActionBarDestroyGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint("LEFT", ActionBarSellButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            "LEFT",
            ActionBarSellGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
    else
        AardvarkActionBar:SetSize(SizeList.actionBarContainerLong, SizeList.mainFrameNavigationButtonSize)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint("LEFT")
        ActionBarDestroyButton:SetPoint("CENTER")
        ActionBarSellButton:SetPoint("RIGHT")
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint("TOP", ActionBarAardvarkButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            "TOP",
            ActionBarProtectGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint("TOP", ActionBarDestroyButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            "TOP",
            ActionBarDestroyGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint("TOP", ActionBarSellButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            "TOP",
            ActionBarSellGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
    end
end

-- ===========================         check item on list functions          ===========================
local function checkItemOnGlobalSellList(searchItemID)
    for k, v in pairs(AVKGlobalSellTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
local function checkItemOnCharacterSellList(searchItemID)
    for k, v in pairs(AVKCharacterSellTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
local function checkItemOnGlobalDestroyList(searchItemID)
    for k, v in pairs(AVKGlobalDestroyTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
local function checkItemOnCharacterDestroyList(searchItemID)
    for k, v in pairs(AVKCharacterDestroyTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
local function checkItemOnGlobalProtectList(searchItemID)
    for k, v in pairs(AVKGlobalProtectTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end
local function checkItemOnCharacterProtectList(searchItemID)
    for k, v in pairs(AVKCharacterProtectTable) do
        if v.itemID == searchItemID then
            return true
        end
    end
end

-- ===========================         check item value          ===========================
local function checkItemValue(checkItemID)
    _, _, _, _, _, _, _, _, _, _, itemSellPrice = GetItemInfo(checkItemID)
    if itemSellPrice ~= 0 then
        return true
    end
end

-- ===========================         not an item printer          ===========================
local function notAnItemMessages()
    print(ColourList.textBluePrefixSuffix .. " That was not an item.") -- cannot be disabled as we have to learn
end

-- ===========================         repair messages printer          ===========================
local function repairMessages()
    -- repair print chunk
    if VariableList.repairMessageType == 1 then
        if AVKGlobalSettings.Repair.rtrm then
            print(
                ColourList.textBluePrefixSuffix ..
                    ColourList.textPink ..
                        "Repairs paid with guild funds :- |r" .. GetCoinTextureString(VariableList.repairAmount)
            ) -- repair message 1
        end
    elseif VariableList.repairMessageType == 2 then
        if AVKGlobalSettings.Repair.rtrm then
            print(
                ColourList.textBluePrefixSuffix ..
                    ColourList.textPink ..
                        "Repairs funded by you :- |r" .. GetCoinTextureString(VariableList.repairAmount)
            ) -- repair message 2
        end
    elseif VariableList.repairMessageType == 3 then
        if AVKGlobalSettings.Repair.rcarm then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Guild won't pay and you can't afford it!") -- Repair message 3
        end
    elseif VariableList.repairMessageType == 4 then
        if AVKGlobalSettings.Repair.rntrm then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Nothing to repair.") -- Repair message 4
        end
    elseif VariableList.repairMessageType == 5 then
        if AVKGlobalSettings.Repair.rvcrm then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "This vendor cannot repair.") -- Repair message 5
        end
    end
    -- reset the repair values
    VariableList.repairAmount = 0
    VariableList.repairMessageType = 0
end

-- ===========================         already listed printer          ===========================
-- print already listed messages if enabled
local function alreadyListedMessages(alreadyTableName, alreadyItemLink)
    if alreadyTableName == AVKGlobalSellTable and AVKGlobalSettings.Sell.sialfm then
        print(ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on your global sell list.")
    elseif alreadyTableName == AVKCharacterSellTable and AVKGlobalSettings.Sell.sialfm then
        print(ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on " .. playerName .. "'s sell list.")
    elseif alreadyTableName == AVKGlobalDestroyTable and AVKGlobalSettings.Destroy.dialfm then
        print(ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on your global destroy list.")
    elseif alreadyTableName == AVKCharacterDestroyTable and AVKGlobalSettings.Destroy.dialfm then
        print(
            ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on " .. playerName .. "'s destroy list."
        )
    elseif alreadyTableName == AVKGlobalProtectTable and AVKGlobalSettings.Protect.pialfm then
        print(ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on your global protect list.")
    elseif alreadyTableName == AVKCharacterProtectTable and AVKGlobalSettings.Protect.pialfm then
        print(
            ColourList.textBluePrefixSuffix .. alreadyItemLink .. " is already on " .. playerName .. "'s protect list."
        )
    end
end

-- ===========================         textbox error message printers          ===========================
local function textBoxAddInvalidMessages()
    AardvarkSpecialAddTextBox:SetNumeric(false)
    AardvarkSpecialAddTextBox:SetText("Invalid Item ID")
    AardvarkSpecialAddTextBox:HighlightText()
    AardvarkSpecialAddTextBox:SetNumeric(true)
end
local function textBoxRemoveInvalidMessages()
    AardvarkSpecialRemoveTextBox:SetNumeric(false)
    AardvarkSpecialRemoveTextBox:SetText("Invalid Item ID")
    AardvarkSpecialRemoveTextBox:HighlightText()
    AardvarkSpecialRemoveTextBox:SetNumeric(true)
end
local function textBoxRemoveNotListedMessages()
    AardvarkSpecialRemoveTextBox:SetNumeric(false)
    AardvarkSpecialRemoveTextBox:SetText("Item Not Listed")
    AardvarkSpecialRemoveTextBox:HighlightText()
    AardvarkSpecialRemoveTextBox:SetNumeric(true)
end
local function clearTextBox()
    AardvarkSpecialAddTextBox:SetText("")
    AardvarkSpecialRemoveTextBox:SetText("")
end

-- ===========================         switch panels on add/remove function          ===========================
local function switchPanelsOnAddOrRemoveItem(switchTableName)
    if switchTableName == AVKGlobalSellTable or switchTableName == AVKCharacterSellTable then
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
    elseif switchTableName == AVKGlobalDestroyTable or switchTableName == AVKCharacterDestroyTable then
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
    elseif switchTableName == AVKGlobalProtectTable or switchTableName == AVKCharacterProtectTable then
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
    end
end

-- ===========================         remove item from list          ===========================
-- for some reason when trying to remove heirlooms only the itemID works so we run 2 seperate remove functions
local function removeItemFromList(removeTableName, removeItemLink)
    for k, v in pairs(removeTableName) do
        if v.itemID == tonumber(string.match(removeItemLink, "item:(%d+):")) then -- strip the itemID out of the itemLink
            table.remove(removeTableName, k)
        end
    end
    for k, v in pairs(removeTableName) do
        if v.itemLink == removeItemLink then
            table.remove(removeTableName, k)
        end
    end
    -- print item removed message if enabled
    if removeTableName == AVKGlobalSellTable and AVKGlobalSettings.Sell.sirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from your global sell list.")
        avkUpdateGlobalSellList()
    elseif removeTableName == AVKCharacterSellTable and AVKGlobalSettings.Sell.sirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from " .. playerName .. "'s sell list.")
        avkUpdateCharacterSellList()
    elseif removeTableName == AVKGlobalDestroyTable and AVKGlobalSettings.Destroy.dirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from your global destroy list.")
        avkUpdateGlobalDestroyList()
    elseif removeTableName == AVKCharacterDestroyTable and AVKGlobalSettings.Destroy.dirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from " .. playerName .. "'s destroy list.")
        avkUpdateCharacterDestroyList()
    elseif removeTableName == AVKGlobalProtectTable and AVKGlobalSettings.Protect.pirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from your global protect list.")
        avkUpdateGlobalProtectList()
    elseif removeTableName == AVKCharacterProtectTable and AVKGlobalSettings.Protect.pirlm then
        print(ColourList.textBluePrefixSuffix .. removeItemLink .. " removed from " .. playerName .. "'s protect list.")
        avkUpdateCharacterProtectList()
    end
    switchPanelsOnAddOrRemoveItem(removeTableName)
    clearTextBox()
end

-- ===========================         add item to list          ===========================
local function addItemToList(addTableName, addItemID)
    itemName,
        itemLink,
        itemRarity,
        itemLevel,
        itemMinLevel,
        itemType,
        itemSubType,
        itemStackCount,
        itemEquipLoc,
        iconFileDataID,
        itemSellPrice,
        itemClassID,
        itemSubClassID,
        bindType,
        expacID,
        itemSetID,
        isCraftingReagent = GetItemInfo(addItemID)

    VariableList.tempItemList = {
        itemID = addItemID,
        itemName = itemName,
        itemLink = itemLink,
        itemRarity = itemRarity,
        itemLevel = itemLevel,
        itemMinLevel = itemMinLevel,
        itemType = itemType,
        itemSubType = itemSubType,
        itemStackCount = itemStackCount,
        itemEquipLoc = itemEquipLoc,
        iconFileDataID = iconFileDataID,
        itemSellPrice = itemSellPrice,
        itemClassID = itemClassID,
        itemSubClassID = itemSubClassID,
        bindType = bindType,
        expacID = expacID,
        itemSetID = itemSetID,
        isCraftingReagent = isCraftingReagent
    }
    -- add item to correct list & print out message if enabled
    table.insert(addTableName, 1, VariableList.tempItemList)
    if addTableName == AVKGlobalSellTable and AVKGlobalSettings.Sell.sialsm then
        print(ColourList.textBluePrefixSuffix .. itemLink .. ColourList.textGreen .. " added to your global sell list.")
        avkUpdateGlobalSellList()
    elseif addTableName == AVKCharacterSellTable and AVKGlobalSettings.Sell.sialsm then
        print(
            ColourList.textBluePrefixSuffix ..
                itemLink .. ColourList.textGreen .. " added to " .. playerName .. "'s sell list."
        )
        avkUpdateCharacterSellList()
    elseif addTableName == AVKGlobalDestroyTable and AVKGlobalSettings.Destroy.dialsm then
        print(
            ColourList.textBluePrefixSuffix .. itemLink .. ColourList.textRed .. " added to your global destroy list."
        )
        avkUpdateGlobalDestroyList()
    elseif addTableName == AVKCharacterDestroyTable and AVKGlobalSettings.Destroy.dialsm then
        print(
            ColourList.textBluePrefixSuffix ..
                itemLink .. ColourList.textRed .. " added to " .. playerName .. "'s destroy list."
        )
        avkUpdateCharacterDestroyList()
    elseif addTableName == AVKGlobalProtectTable and AVKGlobalSettings.Protect.pialsm then
        print(
            ColourList.textBluePrefixSuffix ..
                itemLink .. ColourList.textOrange .. " added to your global protect list."
        )
        avkUpdateGlobalProtectList()
    elseif addTableName == AVKCharacterProtectTable and AVKGlobalSettings.Protect.pialsm then
        print(
            ColourList.textBluePrefixSuffix ..
                itemLink .. ColourList.textOrange .. " added to " .. playerName .. "'s protect list."
        )
        avkUpdateCharacterProtectList()
    end
    switchPanelsOnAddOrRemoveItem(addTableName)
    clearTextBox()
end

--[[
    local function consolidateLists -- debug
--]]
-- ===========================         validate vendor          ===========================
local function checkVendorBlacklist(currentVendorID)
    for k, v in pairs(VendorBlacklist) do
        if v == currentVendorID then
            return true
        end
    end
    return false
end

-- ===========================         sell function          ===========================
local AardvarkTooltipFrame = CreateFrame("GameTooltip", "Tooltip", nil, "GameTooltipTemplate") -- tooltip frame

local function isTradeable(itemLocation) -- scan tooltip to see if item is on a cooldown
    local itemLink = C_Item.GetItemLink(itemLocation)
    AardvarkTooltipFrame:SetOwner(UIParent, "ANCHOR_NONE")
    AardvarkTooltipFrame:SetBagItem(itemLocation:GetBagAndSlot())
    AardvarkTooltipFrame:Show()
    for index = 1, AardvarkTooltipFrame:NumLines() do -- step through item tooltip
        if (string.find(_G["TooltipTextLeft" .. index]:GetText(), string.format(BIND_TRADE_TIME_REMAINING, ".*"))) then -- trade to player true
            return true
        end
    end
end
-- build a list of items to be sold
local function avkSellList()
    for index = #VariableList.tempSellList, 1, -1 do -- process backwards so we can remove items from list safely
        local bag, slot, itemLink, itemValue, itemCount = unpack(VariableList.tempSellList[index])
        local itemID = C_Container.GetContainerItemID(bag, slot)
        if itemID and itemValue ~= 0 then -- Item still needs to be sold
            C_Container.UseContainerItem(bag, slot)
        else -- Item has been sold
            table.remove(VariableList.tempSellList, index)
            local value = itemValue * itemCount
            if AVKGlobalSettings.Sell.sdsm then -- If messages are on
                print((" - Sold: %s %s for %s"):format(itemCount, itemLink, GetCoinTextureString(value)))
            end
            VariableList.profitCounter = VariableList.profitCounter + value -- Add sale value to profit counter
        end
    end
    if #VariableList.tempSellList == 0 or VariableList.vendorClosed then -- All items sold
        if VariableList.profitCounter ~= 0 then -- If items were sold print out total
            if AVKGlobalSettings.Sell.stsm then
                print(
                    ("%s%sTotal Profit :-|r %s"):format(
                        ColourList.textBluePrefixSuffix,
                        ColourList.textGreen,
                        GetCoinTextureString(VariableList.profitCounter)
                    )
                )
            end
            repairMessages()
        elseif AVKGlobalSettings.Sell.sntsm then -- If no items sell print out grind message
            print(
                ("%s%sNothing to sell. Better grind some more."):format(
                    ColourList.textBluePrefixSuffix,
                    ColourList.textGreen
                )
            )
            repairMessages()
        end
    else -- Try to sell remaining items in half a second
        C_Timer.After(VariableList.sellDelay, avkSellList)
    end
end
-- the core sell function
local function avkSell()
    local vendorGUID = UnitGUID("target")
    if not vendorGUID then -- catches engineer repair anvils
        return
    end
    local _, _, _, _, _, npcID, _ = strsplit("-", vendorGUID)
    local vendorID = tonumber(npcID)
    if checkVendorBlacklist(vendorID) then -- check if vendor ID is on blacklist
        print(
            ColourList.textBluePrefixSuffix ..
                ColourList.textGreen .. UnitName("target") .. " refuses to buy your items."
        )
    else
        wipe(VariableList.tempSellList)
        VariableList.profitCounter = 0
        local numListed = 0
        for bag = 0, 5 do -- check each bag
            for slot = 0, C_Container.GetContainerNumSlots(bag) do -- check each bag slot
                local itemID = C_Container.GetContainerItemID(bag, slot)
                if itemID then -- if current bag slot has an item then get the item info
                    local _, itemLink, itemQuality, _, _, _, _, _, _, _, itemValue = GetItemInfo(itemID)
                    local money, itemCount, refundSec = C_Container.GetContainerItemPurchaseInfo(bag, slot, false)
                    local itemLocation = ItemLocation:CreateFromBagAndSlot(bag, slot) -- get item location, needed for the tooltip test
                    if
                        ((checkItemOnGlobalProtectList(itemID) or checkItemOnCharacterProtectList(itemID)) and
                            (itemValue ~= 0) and
                            itemLink) or
                            isTradeable(itemLocation) or
                            refundSec
                     then
                        if AVKGlobalSettings.Sell.sdsm and AVKGlobalSettings.Protect.pdpm then
                            if isTradeable(itemLocation) or refundSec then
                                print(" - On Cooldown: ", itemLink, " not sold.")
                            else
                                print(" - Protected: ", itemLink, " not sold.")
                            end
                        end
                    elseif
                        checkItemOnGlobalSellList(itemID) or checkItemOnCharacterSellList(itemID) or
                            (AVKGlobalSettings.Sell.seasg and itemQuality == 0)
                     then
                        local itemTable = C_Container.GetContainerItemInfo(bag, slot)
                        local itemCount = itemTable.stackCount
                        numListed = numListed + 1
                        VariableList.tempSellList[numListed] = {bag, slot, itemLink, itemValue, itemCount} -- debug -- itemCount
                        if numListed == 12 and AVKGlobalSettings.Sell.stil then -- if twelve item limit
                            break
                        end
                    end
                end
            end
        end
        avkSellList()
    end
end

-- ===========================         destroy function         ===========================
local function avkDestroy()
    for destroyBag = 0, 5 do -- check each bag
        destroyBagSlot = C_Container.GetContainerNumSlots(destroyBag)
        for destroySlot = 0, destroyBagSlot do -- check each bag slot
            currentItemID = C_Container.GetContainerItemID(destroyBag, destroySlot)
            if currentItemID then -- if current bag slot has an item then get the item info
                local _, itemLink = GetItemInfo(currentItemID)

                local itemTable = C_Container.GetContainerItemInfo(destroyBag, destroySlot)
                local itemCount = itemTable.stackCount

                if itemLink then
                    if checkItemOnGlobalProtectList(currentItemID) or checkItemOnCharacterProtectList(currentItemID) then
                        if AVKGlobalSettings.Destroy.dddm and AVKGlobalSettings.Protect.pdpm then -- print protected item
                            if itemLink then
                                print(" - Protected: " .. itemLink .. " not destroyed.")
                            end
                        end
                    elseif checkItemOnGlobalDestroyList(currentItemID) or checkItemOnCharacterDestroyList(currentItemID) then
                        if AVKGlobalSettings.Destroy.dddm then -- if item destroy messages are on print
                            print(" - Destroyed: " .. itemCount .. " " .. itemLink)
                        end
                        C_Container.PickupContainerItem(destroyBag, destroySlot)
                        DeleteCursorItem() -- destroy current item
                        ClearCursor()
                        VariableList.destroyedItemCount = VariableList.destroyedItemCount + itemCount -- increase the destroy count variables
                        VariableList.destroyedSlotCount = VariableList.destroyedSlotCount + 1
                        return
                    end
                end
            end
        end
    end
    if VariableList.destroyedItemCount ~= 0 then -- if items were destroyed print out total -- if no items destroyed print out bag space message
        if AVKGlobalSettings.Destroy.dtdm then
            print(
                ColourList.textBluePrefixSuffix ..
                    ColourList.textRed ..
                        "Items destroyed :-|r " ..
                            VariableList.destroyedItemCount ..
                                ColourList.textRed .. "  ~  Bagslots cleared :-|r " .. VariableList.destroyedSlotCount
            )
        end
    elseif AVKGlobalSettings.Destroy.dntdm then
        print(ColourList.textBluePrefixSuffix .. ColourList.textRed .. "Nothing destroyed. No bag space saved.")
    end
    VariableList.destroyedItemCount = 0 -- reset destroy count varaibles to zero
    VariableList.destroyedSlotCount = 0
end

-- ===========================         repair function          ===========================
local function avkRepair()
    if CanMerchantRepair() then
        local repairAllCost, _ = GetRepairAllCost()
        if repairAllCost ~= 0 then
            if CanGuildBankRepair() and AVKGlobalSettings.Repair.rgr then
                RepairAllItems(1)
                -- set the repair variables
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 1
            elseif GetMoney() >= repairAllCost then
                RepairAllItems()
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 2
            elseif GetMoney() < repairAllCost then
                RepairAllItems()
                if AVKGlobalSettings.Repair.rcarm then
                    VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 3
                end
            end
        else
            if AVKGlobalSettings.Repair.rntrm then
                VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 4
            end
        end
    else
        if AVKGlobalSettings.Repair.rvcrm then
            VariableList.repairAmount, VariableList.repairMessageType = repairAllCost, 5
        end
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         discordgregory rocks          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         global export function          ===========================
local function AVKGlobalLootExport()
    local idTable = {} -- temp table
    for i = 1, EJ_GetNumLoot() do -- loop over the currently displayed items
        table.insert(idTable, C_EncounterJournal.GetLootInfoByIndex(i).itemID) -- add them to the temp table
    end
    for _, v in ipairs(idTable) do -- loop over the temp table
        local _, itemLink = GetItemInfo(v) -- get current item link
        if checkItemValue(v) then -- if current item has a value
            if checkItemOnGlobalSellList(v) then -- check current item is already listed
                alreadyListedMessages(AVKGlobalSellTable, itemLink) -- if it is print already listed message
            else
                addItemToList(AVKGlobalSellTable, v) -- if unknown known add to sell list
            end
        else -- if has value
            if checkItemOnGlobalDestroyList(v) then -- check if already known
                alreadyListedMessages(AVKGlobalDestroyTable, itemLink) -- if is print already listed message
            else
                addItemToList(AVKGlobalDestroyTable, v) -- if unknown add to destroy list
            end
        end
    end
end

-- ===========================         character export function          ===========================
local function AVKCharacterLootExport()
    local idTable = {}
    for i = 1, EJ_GetNumLoot() do
        table.insert(idTable, C_EncounterJournal.GetLootInfoByIndex(i).itemID)
    end
    for _, v in ipairs(idTable) do
        local _, itemLink = GetItemInfo(v)
        if checkItemValue(v) then
            if checkItemOnGlobalSellList(v) then
                alreadyListedMessages(AVKGlobalSellTable, itemLink)
            elseif checkItemOnCharacterSellList(v) then
                alreadyListedMessages(AVKCharacterSellTable, itemLink)
            else
                addItemToList(AVKCharacterSellTable, v)
            end
        else
            if checkItemOnGlobalDestroyList(v) then
                alreadyListedMessages(AVKGlobalDestroyTable, itemLink)
            elseif checkItemOnCharacterDestroyList(v) then
                alreadyListedMessages(AVKCharacterDestroyTable, itemLink)
            else
                addItemToList(AVKCharacterDestroyTable, v)
            end
        end
    end
end

-- ===========================         toggle journal buttons          ===========================
local function toggleJournalButtons()
    if AVKGlobalSettings.Aardvark.abajb then
        CLEButton:Show()
        GLEButton:Show()
    else
        CLEButton:Hide()
        GLEButton:Hide()
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         global functions for keybinds       ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================        toggle aardvark UI          ===========================
function AVKRUNSHOWAARDVARKUIFUNCTION()
    if AardvarkMainFrame:IsVisible() then
        AardvarkMainFrame:Hide()
    else
        AardvarkMainFrame:Show()
        updateListBasedOnPanel()
    end
end

-- ===========================         reset aardvark UI          ===========================
function AVKRUNRESETAARDVARKUIFUNCTION()
    AardvarkMainFrame:ClearAllPoints()
    AardvarkMainFrame:SetPoint("LEFT", SizeList.mainFrameSetPoint, 0)
    AVKGlobalSettings.FrameScales.amfs = 1
    AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    AardvarkMainFrame:Show()
    AardvarkMagicButton:ClearAllPoints()
    AardvarkMagicButton:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "TOPRIGHT", 0, 20)
    AVKGlobalSettings.FrameScales.ambs = 1
    AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    AardvarkMagicButton:Show()
    AardvarkActionBar:ClearAllPoints()
    AardvarkActionBar:SetPoint("TOPLEFT", AardvarkMainFrame, "TOPRIGHT", 0, 0)
    AVKGlobalSettings.FrameScales.aabs = 1
    AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    AardvarkActionBar:Show()
end

-- ===========================         run the sell function          ===========================
function AVKRUNSELLFUNCTION()
    avkSell()
end

-- ===========================         run the destroy function          ===========================
function AVKRUNDESTROYFUNCTION()
    avkDestroy()
end

-- ===========================         add hover item to global list          ===========================
function AVKRUNADDITEMTOGLOBALLISTFUNCTION()
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" or not GameTooltip:GetItem() then
            notAnItemMessages()
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" or not GetItemInfoFromHyperlink(keybindingItemLink) then
                notAnItemMessages()
            elseif checkItemValue(keybindingItemID) then
                if checkItemOnGlobalSellList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, keybindingItemLink)
                else
                    addItemToList(AVKGlobalSellTable, keybindingItemID)
                end
            else
                if checkItemOnGlobalDestroyList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, keybindingItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, keybindingItemID)
                end
            end
        end
    end
end

-- ===========================         add hover item to character list          ===========================
function AVKRUNADDITEMTOCHARACTERLISTFUNCTION()
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" or not GameTooltip:GetItem() then
            notAnItemMessages()
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" or not GetItemInfoFromHyperlink(keybindingItemLink) then
                notAnItemMessages()
            elseif checkItemValue(keybindingItemID) then
                if checkItemOnGlobalSellList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, keybindingItemLink)
                elseif checkItemOnCharacterSellList(keybindingItemID) then
                    alreadyListedMessages(AVKCharacterSellTable, keybindingItemLink)
                else
                    addItemToList(AVKCharacterSellTable, keybindingItemID)
                end
            else
                if checkItemOnGlobalDestroyList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, keybindingItemLink)
                elseif checkItemOnCharacterDestroyList(keybindingItemID) then
                    alreadyListedMessages(AVKCharacterDestroyTable, keybindingItemLink)
                else
                    addItemToList(AVKCharacterDestroyTable, keybindingItemID)
                end
            end
        end
    end
end

-- ===========================         add hover item to global protect list           ===========================
function AVKRUNADDITEMTOGLOBALPROTECTLISTFUNCTION()
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" or not GameTooltip:GetItem() then
            notAnItemMessages()
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" or not GetItemInfoFromHyperlink(keybindingItemLink) then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, keybindingItemLink)
                else
                    addItemToList(AVKGlobalProtectTable, keybindingItemID)
                end
            end
        end
    end
end

-- ===========================         add hover item to character protect list          ===========================
function AVKRUNADDITEMTOCHARACTERPROTECTLISTFUNCTION()
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" or not GameTooltip:GetItem() then
            notAnItemMessages()
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" or not GetItemInfoFromHyperlink(keybindingItemLink) then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(keybindingItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, keybindingItemLink)
                elseif checkItemOnCharacterProtectList(keybindingItemID) then
                    alreadyListedMessages(AVKCharacterProtectTable, keybindingItemLink)
                else
                    addItemToList(AVKCharacterProtectTable, keybindingItemID)
                end
            end
        end
    end
end

-- ===========================         remove hover from sell/destroy lists          ===========================
--[[ -- debug
function AVKREMOVEITEMFROMSELLORDESTROYLISTFUNCTION()
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" then
            print("no item found")
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" then
                print("no item found")
            else
                if checkItemOnGlobalSellList(keybindingItemID) then
                    removeItemFromList(AVKGlobalSellTable, keybindingItemLink)
                end
                if checkItemOnCharacterSellList(keybindingItemID) then
                    removeItemFromList(AVKCharacterSellTable, keybindingItemLink)
                end
                if checkItemOnGlobalDestroyList(keybindingItemID) then
                    removeItemFromList(AVKGlobalDestroyTable, keybindingItemLink)
                end
                if checkItemOnCharacterDestroyList(keybindingItemID) then
                    removeItemFromList(AVKCharacterDestroyTable, keybindingItemLink)
                end
            end
        end
    end
end
--]]
--[[
-- ===========================         remove hover from protect lists          ===========================
function AVKREMOVEITEMFROMPROTECTLISTFUNCTION() -- debug --
    if GameTooltip:IsShown() then
        _, keybindingItemLink = GameTooltip:GetItem()
        if keybindingItemLink == "" then
            print("no item found")
        else
            keybindingItemID = GetItemInfoFromHyperlink(keybindingItemLink)
            if keybindingItemID == "" then
                print("no item found")
            else
                if checkItemOnGlobalProtectList(keybindingItemID) then
                    removeItemFromList(AVKGlobalProtectTable, keybindingItemLink)
                end
                if checkItemOnCharacterProtectList(keybindingItemID) then
                    removeItemFromList(AVKCharacterProtectTable, keybindingItemLink)
                end
            end
        end
    end
end
--]]
-- ===========================         reset all settings          ===========================
function AVKRESETALLSETTINGSFUNCTION()
    AVKGlobalSettings = nil
    ReloadUI()
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         slash commands          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         show aardvark frame          ===========================
SLASH_AARDVARK1 = "/avk"
function SlashCmdList.AARDVARK(msg, editbox)
    AVKRUNSHOWAARDVARKUIFUNCTION()
end
-- ===========================         reset frame scales and layouts          ===========================
SLASH_AARDVARKRFP1 = "/avkpos"
function SlashCmdList.AARDVARKRFP(msg, editbox)
    AVKRUNRESETAARDVARKUIFUNCTION()
end
-- ===========================         run destroy function          ===========================
SLASH_AARDVARKD1 = "/avkdestroy"
function SlashCmdList.AARDVARKD(msg, editbox)
    avkDestroy()
end
-- ===========================         clear all item lists          ===========================
SLASH_AARDVARKCB1 = "/avkclear"
function SlashCmdList.AARDVARKCB(msg, editbox)
    wipe(AVKGlobalSellTable)
    wipe(AVKGlobalDestroyTable)
    wipe(AVKGlobalProtectTable)
    wipe(AVKCharacterSellTable)
    wipe(AVKCharacterDestroyTable)
    wipe(AVKCharacterProtectTable)
    updateListBasedOnPanel()
    print(ColourList.textBluePrefix .. "All Lists Cleared")
end
-- ===========================         reset all settings          ===========================
SLASH_AARDVARKRSD1 = "/avkrsd"
function SlashCmdList.AARDVARKRSD(msg, editbox)
    AVKRESETALLSETTINGSFUNCTION()
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark frames          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         main frame          ===========================
local AardvarkMainFrame =
    CreateFrame("Frame", "AardvarkMainFrame", UIParent, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkMainFrame:SetBackdrop(
    {
        bgFile = "Interface\\Buttons\\WHITE8X8",
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkMainFrame:SetBackdropColor(0, 0, 0, 1)
AardvarkMainFrame:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkMainFrame:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameHeight)
AardvarkMainFrame:ClearAllPoints()
AardvarkMainFrame:SetPoint("LEFT", SizeList.mainFrameSetPoint, 0)
AardvarkMainFrame:EnableMouse(true)
AardvarkMainFrame:SetMovable(true)
AardvarkMainFrame:SetClampedToScreen(true)
AardvarkMainFrame:RegisterForDrag("RightButton", "LeftButton")
AardvarkMainFrame:SetScript("OnDragStart", AardvarkMainFrame.StartMoving)
AardvarkMainFrame:SetScript("OnDragStop", AardvarkMainFrame.StopMovingOrSizing)
AardvarkMainFrame:SetToplevel(true)
AardvarkMainFrame:SetScript(
    "OnEvent",
    function(self, event, arg1) -- triggers when a registered event fires
        if event == "PLAYER_LOGIN" then
            print(TextList.avkLoad)
            avkInitialiseSettings()
            avkInitialiseLists()
            toggleVerticalActionBar()
        elseif arg1 == "Blizzard_EncounterJournal" then -- when the addon loaded event fires check the first argument
            EncounterJournalEncounterFrameInfoFilterToggle:SetWidth(50) -- shrink the gear filter button
            EncounterJournalEncounterFrameInfoSlotFilterToggle:SetWidth(50) -- shrink the gear slot filter button
            -- set the slot filter button position
            EncounterJournalEncounterFrameInfoSlotFilterToggle:SetPoint(
                "TOPLEFT",
                EncounterJournalEncounterFrameInfoFilterToggle,
                "TOPRIGHT",
                30,
                0
            )

            GLEButton =
                CreateFrame("Button", "AVKGlobalLootExportButton", EncounterJournalEncounterFrameInfo.LootContainer) -- create global button
            GLEButton:SetPoint("LEFT", EncounterJournalEncounterFrameInfoSlotFilterToggle, "RIGHT", 27, 2) -- set the buutton position
            GLEButton:SetSize(26, 26) -- set button size
            GLEButton:SetNormalTexture(ImageList.bulkAddGlobal) -- buton image
            GLEButton:SetHighlightTexture(ImageList.bulkAddGlobalHover, "BLEND")
            GLEButton:SetScript("OnClick", AVKGlobalLootExport) -- on click run export function
            GLEButton:SetScript(
                "OnEnter",
                function(self)
                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 5, 5)
                    GameTooltip:SetScale(SizeList.journalButtonTooltipSize)
                    GameTooltip:AddLine(TextList.avkBulkAddGlobal)
                    if AVKGlobalSettings.Aardvark.abajbt then
                        GameTooltip:Show()
                    else
                        GameTooltip:Hide()
                    end
                end
            )
            GLEButton:SetScript(
                "OnLeave",
                function(self)
                    GameTooltip:Hide()
                    GameTooltip:SetScale(1)
                end
            )

            CLEButton =
                CreateFrame("Button", "AVKCharacterLootExportButton", EncounterJournalEncounterFrameInfo.LootContainer) -- create character button
            CLEButton:SetPoint("LEFT", AVKGlobalLootExportButton, "RIGHT", 11, 0)
            CLEButton:SetSize(26, 26)
            CLEButton:SetNormalTexture(ImageList.bulkAddCharacter)
            CLEButton:SetHighlightTexture(ImageList.bulkAddCharacterHover, "BLEND")
            CLEButton:SetScript("OnClick", AVKCharacterLootExport)
            CLEButton:SetScript(
                "OnEnter",
                function(self)
                    GameTooltip:SetOwner(self, "ANCHOR_TOP", 5, 5)
                    GameTooltip:SetScale(SizeList.journalButtonTooltipSize)
                    GameTooltip:AddLine(TextList.avkBulkAddCharacter)
                    if AVKGlobalSettings.Aardvark.abajbt then
                        GameTooltip:Show()
                    else
                        GameTooltip:Hide()
                    end
                end
            )
            CLEButton:SetScript(
                "OnLeave",
                function(self)
                    GameTooltip:Hide()
                    GameTooltip:SetScale(1)
                end
            )

            toggleJournalButtons()
        elseif event == "MERCHANT_SHOW" then
            VariableList.vendorClosed = false
            --[[ blizz broke auto destroy in retail -- debug --
            if AVKGlobalSettings.Destroy.ded and AVKGlobalSettings.Destroy.dead then
                avkDestroy()
            end
            --]]
            if AVKGlobalSettings.Repair.rer then
                avkRepair()
            end
            if AVKGlobalSettings.Sell.ses and AVKGlobalSettings.Sell.seas then
                avkSell()
            end
            if AVKGlobalSettings.Aardvark.afab then
                ActionBarSellButton:Enable()
                AardvarkActionBar:Show()
            else
                AardvarkActionBar:Hide()
            end
        elseif event == "MERCHANT_CLOSED" then
            ActionBarSellButton:Disable()
            if not AVKGlobalSettings.Aardvark.afabas then
                AardvarkActionBar:Hide()
            end
            VariableList.vendorClosed = true
        end
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)
AardvarkMainFrame:RegisterEvent("PLAYER_LOGIN") -- Register events to track
AardvarkMainFrame:RegisterEvent("MERCHANT_SHOW")
AardvarkMainFrame:RegisterEvent("MERCHANT_CLOSED")
AardvarkMainFrame:RegisterEvent("ADDON_LOADED") -- debug -- not sure if really needed anymore
AardvarkMainFrame:Hide()

AardvarkMainFrame.CloseButton = CreateFrame("Button", "AardvarkMainFrameCloseButton", AardvarkMainFrame)
AardvarkMainFrame.CloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkMainFrame.CloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkMainFrame.CloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkMainFrame.CloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkMainFrame.CloseButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkMainFrameCloseButton)
    end
)

AardvarkMainFrame.Banner = CreateFrame("Frame", "AardvarkMainFrameBanner", AardvarkMainFrame)
AardvarkMainFrame.Banner:SetSize(590, 90)
AardvarkMainFrame.Banner:SetPoint("TOP", 0, -29)
AardvarkMainFrame.Banner.Texture = AardvarkMainFrameBanner:CreateTexture(nil, "BACKGROUND")
AardvarkMainFrame.Banner.Texture:SetPoint("TOP", 0, 0)
AardvarkMainFrame.Banner.Texture:SetTexture(ImageList.avkBanner)

-- ===========================         navigation buttons panel          ===========================
local AardvarkNavigationPanel = CreateFrame("Frame", "AardvarkNavigationPanel", AardvarkMainFrame)
AardvarkNavigationPanel:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameNavigationFrameHeight)
AardvarkNavigationPanel:SetPoint("TOP", 0, -140)

AardvarkNavigationPanel.ProtectButton =
    CreateFrame("Button", "AardvarkNavigationPanelProtectButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.ProtectButton:SetPoint("CENTER", AardvarkNavigationPanel, 0, 0)
AardvarkNavigationPanel.ProtectButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.ProtectButton:SetNormalTexture(ImageList.protectButton)
AardvarkNavigationPanel.ProtectButton:SetHighlightTexture(ImageList.protectButtonHover, "BLEND")
AardvarkNavigationPanel.ProtectButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelProtectButton)
    end
)

AardvarkNavigationPanel.DestroyButton =
    CreateFrame("Button", "AardvarkNavigationPanelDestroyButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.DestroyButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelProtectButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.DestroyButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.DestroyButton:SetNormalTexture(ImageList.destroyButton)
AardvarkNavigationPanel.DestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, "BLEND")
AardvarkNavigationPanel.DestroyButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
    end
)

AardvarkNavigationPanel.SellButton = CreateFrame("Button", "AardvarkNavigationPanelSellButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.SellButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelDestroyButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.SellButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.SellButton:SetNormalTexture(ImageList.sellButton)
AardvarkNavigationPanel.SellButton:SetHighlightTexture(ImageList.sellButtonHover, "BLEND")
AardvarkNavigationPanel.SellButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelSellButton)
    end
)

AardvarkNavigationPanel.AardvarkButton =
    CreateFrame("Button", "AardvarkNavigationPanelAardvarkButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.AardvarkButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelSellButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.AardvarkButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.AardvarkButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationPanel.AardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkNavigationPanel.AardvarkButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelAardvarkButton)
    end
)

AardvarkNavigationPanel.RepairButton =
    CreateFrame("Button", "AardvarkNavigationPanelRepairButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.RepairButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelProtectButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.RepairButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.RepairButton:SetNormalTexture(ImageList.repairButton)
AardvarkNavigationPanel.RepairButton:SetHighlightTexture(ImageList.repairButtonHover, "BLEND")
AardvarkNavigationPanel.RepairButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelRepairButton)
    end
)

AardvarkNavigationPanel.InfoButton = CreateFrame("Button", "AardvarkNavigationPanelInfoButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.InfoButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelRepairButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.InfoButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.InfoButton:SetNormalTexture(ImageList.infoButton)
AardvarkNavigationPanel.InfoButton:SetHighlightTexture(ImageList.infoButtonHover, "BLEND")
AardvarkNavigationPanel.InfoButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelInfoButton)
    end
)

AardvarkNavigationPanel.SillyButton =
    CreateFrame("Button", "AardvarkNavigationPanelSillyButton", AardvarkNavigationPanel)
AardvarkNavigationPanel.SillyButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelInfoButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationPanel.SillyButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkNavigationPanel.SillyButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationPanel.SillyButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkNavigationPanel.SillyButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationPanelSillyButton)
    end
)

-- ===========================         aardvark options panel          ===========================
local AardvarkAardvarkOptionsPanel =
    CreateFrame(
    "Frame",
    "AardvarkAardvarkOptionsPanel",
    AardvarkMainFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkAardvarkOptionsPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkAardvarkOptionsPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkAardvarkOptionsPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkAardvarkOptionsPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkAardvarkOptionsPanel:Show()

AardvarkAardvarkOptionsPanel.CBamfb =
    CreateFrame("CheckButton", "CBamfb", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBamfb:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBamfb:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
AardvarkAardvarkOptionsPanel.CBamfb:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBamfb.Text:SetText(ColourList.textBlue .. " Aardvark Button")
AardvarkAardvarkOptionsPanel.CBamfb.Text:SetFontObject(FontCheckBoxBig)
AardvarkAardvarkOptionsPanel.CBamfb:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.amfb then
            AVKGlobalSettings.Aardvark.amfb = false
            AardvarkAardvarkOptionsPanel.CBamfbt.Text:SetText(ColourList.rarityPoor .. " Aardvark Button Tooltip")
            CBamfbt:Disable()
            AardvarkMagicButton:Hide()
        else
            AVKGlobalSettings.Aardvark.amfb = true
            AardvarkAardvarkOptionsPanel.CBamfbt.Text:SetText(" Aardvark Button Tooltip")
            CBamfbt:Enable()
            AardvarkMagicButton:Show()
        end
    end
)

AardvarkAardvarkOptionsPanel.CBamfbt =
    CreateFrame("CheckButton", "CBamfbt", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBamfbt:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBamfbt:SetPoint(
    "TOPLEFT",
    CBamfb,
    SizeList.checkBoxChildGapX,
    -SizeList.checkBoxNormalGapY
)
AardvarkAardvarkOptionsPanel.CBamfbt:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBamfbt.Text:SetText(" Aardvark Button Tooltip")
AardvarkAardvarkOptionsPanel.CBamfbt.Text:SetFontObject(FontCheckBox)
AardvarkAardvarkOptionsPanel.CBamfbt:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.amfbt then
            AVKGlobalSettings.Aardvark.amfbt = false
        else
            AVKGlobalSettings.Aardvark.amfbt = true
        end
    end
)

AardvarkAardvarkOptionsPanel.CBafab =
    CreateFrame("CheckButton", "CBafab", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBafab:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBafab:SetPoint("TOPLEFT", CBamfbt, -SizeList.checkBoxChildGapX, -SizeList.checkboxBigGapY)
AardvarkAardvarkOptionsPanel.CBafab:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBafab.Text:SetText(ColourList.textBlue .. " Aardvark Action Bar")
AardvarkAardvarkOptionsPanel.CBafab.Text:SetFontObject(FontCheckBoxBig)
AardvarkAardvarkOptionsPanel.CBafab:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afab then
            AVKGlobalSettings.Aardvark.afab = false
            AardvarkAardvarkOptionsPanel.CBafabas.Text:SetText(ColourList.rarityPoor .. " Always Show Action Bar")
            AardvarkAardvarkOptionsPanel.CBafabv.Text:SetText(ColourList.rarityPoor .. " Vertical Align Action Bar")
            CBafabas:Disable()
            CBafabv:Disable()
            AardvarkActionBar:Hide()
        else
            AVKGlobalSettings.Aardvark.afab = true
            AardvarkAardvarkOptionsPanel.CBafabas.Text:SetText(" Always Show Action Bar")
            AardvarkAardvarkOptionsPanel.CBafabv.Text:SetText(" Vertical Align Action Bar")
            CBafabas:Enable()
            CBafabv:Enable()
            if AVKGlobalSettings.Aardvark.afabas then
                AardvarkActionBar:Show()
            elseif not VariableList.vendorClosed then
                AardvarkActionBar:Show()
            else
                AardvarkActionBar:Hide()
            end
        end
    end
)

AardvarkAardvarkOptionsPanel.CBafabas =
    CreateFrame("CheckButton", "CBafabas", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBafabas:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBafabas:SetPoint(
    "TOPLEFT",
    CBafab,
    SizeList.checkBoxChildGapX,
    -SizeList.checkBoxNormalGapY
)
AardvarkAardvarkOptionsPanel.CBafabas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBafabas.Text:SetText(" Always Show Action Bar")
AardvarkAardvarkOptionsPanel.CBafabas.Text:SetFontObject(FontCheckBox)
AardvarkAardvarkOptionsPanel.CBafabas:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afabas then
            AVKGlobalSettings.Aardvark.afabas = false
            AardvarkActionBar:Hide()
        else
            AVKGlobalSettings.Aardvark.afabas = true
            AardvarkActionBar:Show()
        end
    end
)

AardvarkAardvarkOptionsPanel.CBafabv =
    CreateFrame("CheckButton", "CBafabv", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBafabv:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBafabv:SetPoint("TOPLEFT", CBafabas, 0, -SizeList.checkBoxNormalGapY)
AardvarkAardvarkOptionsPanel.CBafabv:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBafabv.Text:SetText(" Vertical Align Action Bar")
AardvarkAardvarkOptionsPanel.CBafabv.Text:SetFontObject(FontCheckBox)
AardvarkAardvarkOptionsPanel.CBafabv:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afabv then
            AVKGlobalSettings.Aardvark.afabv = false
            toggleVerticalActionBar()
        else
            AVKGlobalSettings.Aardvark.afabv = true
            toggleVerticalActionBar()
        end
    end
)

AardvarkAardvarkOptionsPanel.CBabajb =
    CreateFrame("CheckButton", "CBabajb", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBabajb:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBabajb:SetPoint(
    "TOPLEFT",
    CBafabv,
    -SizeList.checkBoxChildGapX,
    -SizeList.checkboxBigGapY
)
AardvarkAardvarkOptionsPanel.CBabajb:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBabajb.Text:SetText(ColourList.textBlue .. " Adventure Guide Buttons")
AardvarkAardvarkOptionsPanel.CBabajb.Text:SetFontObject(FontCheckBoxBig)
AardvarkAardvarkOptionsPanel.CBabajb:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.abajb then
            AVKGlobalSettings.Aardvark.abajb = false
            AardvarkAardvarkOptionsPanel.CBabajbt.Text:SetText(
                ColourList.rarityPoor .. " Adventure Guide Button Tooltips"
            )
            CBabajbt:Disable()
            toggleJournalButtons()
        else
            AVKGlobalSettings.Aardvark.abajb = true
            AardvarkAardvarkOptionsPanel.CBabajbt.Text:SetText(" Adventure Guide Button Tooltips")
            CBabajbt:Enable()
            toggleJournalButtons()
        end
    end
)

AardvarkAardvarkOptionsPanel.CBabajbt =
    CreateFrame("CheckButton", "CBabajbt", AardvarkAardvarkOptionsPanel, "UICheckButtonTemplate")
AardvarkAardvarkOptionsPanel.CBabajbt:ClearAllPoints()
AardvarkAardvarkOptionsPanel.CBabajbt:SetPoint(
    "TOPLEFT",
    CBabajb,
    SizeList.checkBoxChildGapX,
    -SizeList.checkBoxNormalGapY
)
AardvarkAardvarkOptionsPanel.CBabajbt:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkAardvarkOptionsPanel.CBabajbt.Text:SetText(" Adventure Guide Button Tooltips")
AardvarkAardvarkOptionsPanel.CBabajbt.Text:SetFontObject(FontCheckBox)
AardvarkAardvarkOptionsPanel.CBabajbt:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.abajbt then
            AVKGlobalSettings.Aardvark.abajbt = false
            AardvarkActionBar:Hide()
        else
            AVKGlobalSettings.Aardvark.abajbt = true
            AardvarkActionBar:Show()
        end
    end
)

AardvarkAardvarkOptionsPanel.TextBox =
    CreateFrame("Frame", "AardvarkAardvarkPanelTextBox", AardvarkAardvarkOptionsPanel)
AardvarkAardvarkOptionsPanel.TextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkAardvarkOptionsPanel.TextBox:SetPoint("BOTTOMLEFT", SizeList.mainPanelElementGap, SizeList.mainPanelElementGap)

AardvarkAardvarkOptionsPanel.TextBox.Text = AardvarkAardvarkPanelTextBox:CreateFontString("AardvarkAardvarkPanelText")
AardvarkAardvarkOptionsPanel.TextBox.Text:SetJustifyH("CENTER")
AardvarkAardvarkOptionsPanel.TextBox.Text:SetJustifyV("BOTTOM")
AardvarkAardvarkOptionsPanel.TextBox.Text:SetAllPoints(AardvarkAardvarkPanelTextBox)
AardvarkAardvarkOptionsPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkAardvarkOptionsPanel.TextBox.Text:SetText(TextList.avkLoad)

AardvarkAardvarkOptionsPanel.ScaleFrameButton =
    CreateFrame(
    "Button",
    "AardvarkAardvarkPanelScaleFrameButton",
    AardvarkAardvarkOptionsPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)

AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetSize(SizeList.scrollFrameWidth * .25, SizeList.clearButtonHight)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetPoint("BOTTOMRIGHT", -10, 10)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetNormalFontObject(FontButton)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetHighlightFontObject(FontButton)
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetFormattedText("Scale")
AardvarkAardvarkOptionsPanel.ScaleFrameButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkAardvarkPanelScaleFrameButton)
    end
)

-- ===========================         side frame          ===========================
local AardvarkSideFrame =
    CreateFrame("Frame", "AardvarkSideFrame", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkSideFrame:SetBackdrop(
    {
        bgFile = "Interface\\Buttons\\WHITE8X8",
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSideFrame:SetBackdropColor(0, 0, 0, 1)
AardvarkSideFrame:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSideFrame:SetPoint("TOPLEFT", AardvarkMainFrame, "TOPRIGHT", SizeList.mainFrameMarginGap)
AardvarkSideFrame:SetSize(SizeList.optionsFrameWidth, SizeList.mainFrameHeight)
AardvarkSideFrame:SetParent(AardvarkMainFrame)
AardvarkSideFrame:SetToplevel(true)
AardvarkSideFrame:Hide()

AardvarkSideFrame.CloseButton = CreateFrame("Button", "AardvarkSideFrameCloseButton", AardvarkSideFrame)
AardvarkSideFrame.CloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkSideFrame.CloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkSideFrame.CloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkSideFrame.CloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkSideFrame.CloseButton:SetScript(
    "OnClick",
    function(self)
        AardvarkSideFrame:Hide()
    end
)

-- ===========================         sell options panel          ===========================
local AardvarkSellOptionsPanel = CreateFrame("Frame", "AardvarkSellOptionsPanel", AardvarkSideFrame)
AardvarkSellOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkSellOptionsPanel:SetPoint("TOP", AardvarkSideFrame, "TOP", SizeList.mainFrameMarginGap)
AardvarkSellOptionsPanel:Hide()

AardvarkSellOptionsPanel.CBses = CreateFrame("CheckButton", "CBses", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBses:ClearAllPoints()
AardvarkSellOptionsPanel.CBses:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
AardvarkSellOptionsPanel.CBses:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBses.Text:SetText(ColourList.textGreen .. " Aardvark Sell")
AardvarkSellOptionsPanel.CBses.Text:SetFontObject(FontCheckBoxBig)
AardvarkSellOptionsPanel.CBses:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.ses then
            AVKGlobalSettings.Sell.ses = false
            CBseas:Hide()
            CBseasg:Hide()
            CBstil:Hide()
            CBstsm:Hide()
            CBsdsm:Hide()
            CBsntsm:Hide()
            CBsialsm:Hide()
            CBsialfm:Hide()
            CBsirlm:Hide()
            CBslit:Hide()
        else
            AVKGlobalSettings.Sell.ses = true
            CBseas:Show()
            CBseasg:Show()
            CBstil:Show()
            CBstsm:Show()
            CBsdsm:Show()
            CBsntsm:Show()
            CBsialsm:Show()
            CBsialfm:Show()
            CBsirlm:Show()
            CBslit:Show()
        end
    end
)

AardvarkSellOptionsPanel.CBseas =
    CreateFrame("CheckButton", "CBseas", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBseas:ClearAllPoints()
AardvarkSellOptionsPanel.CBseas:SetPoint("TOPLEFT", CBses, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
AardvarkSellOptionsPanel.CBseas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBseas.Text:SetText(" Auto Sell")
AardvarkSellOptionsPanel.CBseas.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBseas:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.seas then
            AVKGlobalSettings.Sell.seas = false
        else
            AVKGlobalSettings.Sell.seas = true
        end
    end
)

AardvarkSellOptionsPanel.CBseasg =
    CreateFrame("CheckButton", "CBseasg", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBseasg:ClearAllPoints()
AardvarkSellOptionsPanel.CBseasg:SetPoint("TOPLEFT", CBseas, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBseasg:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBseasg.Text:SetText(" Auto Sell Greys")
AardvarkSellOptionsPanel.CBseasg.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBseasg:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.seasg then
            AVKGlobalSettings.Sell.seasg = false
        else
            AVKGlobalSettings.Sell.seasg = true
        end
    end
)

AardvarkSellOptionsPanel.CBstil =
    CreateFrame("CheckButton", "CBstil", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBstil:ClearAllPoints()
AardvarkSellOptionsPanel.CBstil:SetPoint("TOPLEFT", CBseasg, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBstil:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBstil.Text:SetText(" Sell 12 Items At A Time")
AardvarkSellOptionsPanel.CBstil.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBstil:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.stil then
            AVKGlobalSettings.Sell.stil = false
        else
            AVKGlobalSettings.Sell.stil = true
        end
    end
)

AardvarkSellOptionsPanel.CBstsm =
    CreateFrame("CheckButton", "CBstsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBstsm:ClearAllPoints()
AardvarkSellOptionsPanel.CBstsm:SetPoint("TOPLEFT", CBstil, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBstsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBstsm.Text:SetText(" Total Sold Messages")
AardvarkSellOptionsPanel.CBstsm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBstsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.stsm then
            AVKGlobalSettings.Sell.stsm = false
        else
            AVKGlobalSettings.Sell.stsm = true
        end
    end
)

AardvarkSellOptionsPanel.CBsdsm =
    CreateFrame("CheckButton", "CBsdsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBsdsm:ClearAllPoints()
AardvarkSellOptionsPanel.CBsdsm:SetPoint("TOPLEFT", CBstsm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBsdsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBsdsm.Text:SetText(" Detailed Sell Messages")
AardvarkSellOptionsPanel.CBsdsm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBsdsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sdsm then
            AVKGlobalSettings.Sell.sdsm = false
        else
            AVKGlobalSettings.Sell.sdsm = true
        end
    end
)

AardvarkSellOptionsPanel.CBsntsm =
    CreateFrame("CheckButton", "CBsntsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBsntsm:ClearAllPoints()
AardvarkSellOptionsPanel.CBsntsm:SetPoint("TOPLEFT", CBsdsm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBsntsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBsntsm.Text:SetText(" Nothing To Sell Messages")
AardvarkSellOptionsPanel.CBsntsm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBsntsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sntsm then
            AVKGlobalSettings.Sell.sntsm = false
        else
            AVKGlobalSettings.Sell.sntsm = true
        end
    end
)

AardvarkSellOptionsPanel.CBsialsm =
    CreateFrame("CheckButton", "CBsialsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBsialsm:ClearAllPoints()
AardvarkSellOptionsPanel.CBsialsm:SetPoint("TOPLEFT", CBsntsm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBsialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBsialsm.Text:SetText(" Item Added Messages")
AardvarkSellOptionsPanel.CBsialsm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBsialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sialsm then
            AVKGlobalSettings.Sell.sialsm = false
        else
            AVKGlobalSettings.Sell.sialsm = true
        end
    end
)

AardvarkSellOptionsPanel.CBsialfm =
    CreateFrame("CheckButton", "CBsialfm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBsialfm:ClearAllPoints()
AardvarkSellOptionsPanel.CBsialfm:SetPoint("TOPLEFT", CBsialsm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBsialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBsialfm.Text:SetText(" Item Not Added Messages")
AardvarkSellOptionsPanel.CBsialfm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBsialfm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sialfm then
            AVKGlobalSettings.Sell.sialfm = false
        else
            AVKGlobalSettings.Sell.sialfm = true
        end
    end
)

AardvarkSellOptionsPanel.CBsirlm =
    CreateFrame("CheckButton", "CBsirlm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBsirlm:ClearAllPoints()
AardvarkSellOptionsPanel.CBsirlm:SetPoint("TOPLEFT", CBsialfm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBsirlm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBsirlm.Text:SetText(" Item Removed Messages")
AardvarkSellOptionsPanel.CBsirlm.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBsirlm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sirlm then
            AVKGlobalSettings.Sell.sirlm = false
        else
            AVKGlobalSettings.Sell.sirlm = true
        end
    end
)

AardvarkSellOptionsPanel.CBslit =
    CreateFrame("CheckButton", "CBslit", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
AardvarkSellOptionsPanel.CBslit:ClearAllPoints()
AardvarkSellOptionsPanel.CBslit:SetPoint("TOPLEFT", CBsirlm, 0, -SizeList.checkboxGapY)
AardvarkSellOptionsPanel.CBslit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkSellOptionsPanel.CBslit.Text:SetText(" Show Listed Item Tooltips")
AardvarkSellOptionsPanel.CBslit.Text:SetFontObject(FontCheckBox)
AardvarkSellOptionsPanel.CBslit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.slit then
            AVKGlobalSettings.Sell.slit = false
        else
            AVKGlobalSettings.Sell.slit = true
        end
    end
)

AardvarkSellOptionsPanel.TextBox = CreateFrame("Frame", "AardvarkSellOptionsPanelTextBox", AardvarkSellOptionsPanel)
AardvarkSellOptionsPanel.TextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSellOptionsPanel.TextBox:SetPoint("BOTTOM", AardvarkSideFrame, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkSellOptionsPanel.TextBox.Text = AardvarkSellOptionsPanelTextBox:CreateFontString("AardvarkSellOptionsPanelText")
AardvarkSellOptionsPanel.TextBox.Text:SetJustifyH("BOTTOM")
AardvarkSellOptionsPanel.TextBox.Text:SetJustifyV("BOTTOM")
AardvarkSellOptionsPanel.TextBox.Text:SetAllPoints(AardvarkSellOptionsPanelTextBox)
AardvarkSellOptionsPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkSellOptionsPanel.TextBox.Text:SetText(TextList.avkSellOptions)

-- ===========================         main sell panel          ===========================
local AardvarkSellPanel =
    CreateFrame("Frame", "AardvarkSellPanel", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkSellPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanel:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSellPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkSellPanel:Hide()

AardvarkSellPanel.OptionsButton = CreateFrame("Button", "AardvarkSellPanelOptionsButton", AardvarkSellPanel)
AardvarkSellPanel.OptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellPanel.OptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelSillyButton,
    "CENTER",
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkSellPanel.OptionsButton:SetNormalTexture(ImageList.sellOptions)
AardvarkSellPanel.OptionsButton:SetHighlightTexture(ImageList.sellOptionsHover)
AardvarkSellPanel.OptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkSellPanelOptionsButton)
    end
)

AardvarkSellPanel.FiltersButton = CreateFrame("Button", "AardvarkSellPanelFiltersButton", AardvarkSellPanel)
AardvarkSellPanel.FiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellPanel.FiltersButton:SetPoint("CENTER", AardvarkSellPanelOptionsButton, "TOP", 0, 15)
AardvarkSellPanel.FiltersButton:SetNormalTexture(ImageList.sellFilters)
AardvarkSellPanel.FiltersButton:SetHighlightTexture(ImageList.sellFiltersHover)
AardvarkSellPanel.FiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)
AardvarkSellPanel.SpecialAddButton = CreateFrame("Button", "AardvarkSellPanelSpecialAddButton", AardvarkSellPanel)
AardvarkSellPanel.SpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellPanel.SpecialAddButton:SetPoint("CENTER", AardvarkSellPanelOptionsButton, "BOTTOM", 0, -15)
AardvarkSellPanel.SpecialAddButton:SetNormalTexture(ImageList.sellSpecialAdd)
AardvarkSellPanel.SpecialAddButton:SetHighlightTexture(ImageList.sellSpecialAddHover)
AardvarkSellPanel.SpecialAddButton:SetScript(
    "OnClick",
    function()
        specialAddPanel()
    end
)

-- ===========================         global sell list panel          ===========================
local AardvarkSellPanelGlobalPanel = CreateFrame("Frame", "AardvarkSellPanelGlobalPanel", AardvarkSellPanel)
AardvarkSellPanelGlobalPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellPanelGlobalPanel:SetPoint(
    "TOPLEFT",
    AardvarkSellPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkSellPanelGlobalPanel.TitleText =
    AardvarkSellPanelGlobalPanel:CreateFontString("AardvarkSellPanelGlobalPanelTitleText")
AardvarkSellPanelGlobalPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkSellPanelGlobalPanel.TitleText:SetJustifyH("CENTER")
AardvarkSellPanelGlobalPanel.TitleText:SetJustifyV("CENTER")
AardvarkSellPanelGlobalPanel.TitleText:SetAllPoints(AardvarkSellPanelGlobalPanel)
AardvarkSellPanelGlobalPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkSellPanelGlobalPanel.TitleText:SetText("Global Sell List")

AardvarkSellPanelGlobalPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkSellPanelGlobalPanelScrollParent",
    AardvarkSellPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkSellPanelGlobalPanelScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanelGlobalPanel.ScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanelGlobalPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellPanelGlobalPanel.ScrollParent:SetPoint("TOP", AardvarkSellPanelGlobalPanel, "BOTTOM", 0, -8)
AardvarkSellPanelGlobalPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemValue(dragItemID) then
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                else
                    addItemToList(AVKGlobalSellTable, dragItemID)
                end
            else
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkSellPanelGlobalPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemValue(clickItemID) then
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalSellTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalDestroyTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)
AardvarkSellPanelGlobalPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkSellPanelGlobalPanelScrollFrame",
    AardvarkSellPanelGlobalPanelScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkSellPanelGlobalPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkSellPanelGlobalPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkSellPanelGlobalPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalSellList)
    end
)

AardvarkSellPanelGlobalPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellPanelGlobalPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "sglb" .. i, AardvarkSellPanelGlobalPanelScrollParent)
    local button = AardvarkSellPanelGlobalPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempGlobalSellTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Sell.slit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if checkItemValue(clickItemID) then
                                if checkItemOnGlobalSellList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                else
                                    addItemToList(AVKGlobalSellTable, clickItemID)
                                end
                            else
                                if checkItemOnGlobalDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                else
                                    addItemToList(AVKGlobalDestroyTable, clickItemID)
                                end
                            end
                        end
                    else
                        removeItemFromList(AVKGlobalSellTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if checkItemValue(dragItemID) then
                            if checkItemOnGlobalSellList(dragItemID) then
                                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                            else
                                addItemToList(AVKGlobalSellTable, dragItemID)
                            end
                        else
                            if checkItemOnGlobalDestroyList(dragItemID) then
                                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                            else
                                addItemToList(AVKGlobalDestroyTable, dragItemID)
                            end
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkSellPanelGlobalPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkSellPanelGlobalPanelClearListButton",
    AardvarkSellPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)

AardvarkSellPanelGlobalPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellPanelGlobalPanel.ClearListButton:SetPoint("TOP", AardvarkSellPanelGlobalPanelScrollParent, "BOTTOM", 0, -5)
AardvarkSellPanelGlobalPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanelGlobalPanel.ClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanelGlobalPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkSellPanelGlobalPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellPanelGlobalPanel.ClearListButton:SetFormattedText("Clear Global Sell List")
AardvarkSellPanelGlobalPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkSellPanelGlobalPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalSellTable)
        avkUpdateGlobalSellList()
    end
)

-- ===========================         character sell list panel          ===========================
local AardvarkSellPanelCharacterPanel = CreateFrame("Frame", "AardvarkSellPanelCharacterPanel", AardvarkSellPanel)
AardvarkSellPanelCharacterPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellPanelCharacterPanel:SetPoint(
    "TOPRIGHT",
    AardvarkSellPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkSellPanelCharacterPanel.TitleText =
    AardvarkSellPanelCharacterPanel:CreateFontString("AardvarkSellPanelCharacterPanelTitleText")
AardvarkSellPanelCharacterPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkSellPanelCharacterPanel.TitleText:SetJustifyH("CENTER")
AardvarkSellPanelCharacterPanel.TitleText:SetJustifyV("CENTER")
AardvarkSellPanelCharacterPanel.TitleText:SetAllPoints(AardvarkSellPanelCharacterPanel)
AardvarkSellPanelCharacterPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkSellPanelCharacterPanel.TitleText:SetText(playerName .. "'s\nSell List")

AardvarkSellPanelCharacterPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkSellPanelCharacterPanelScrollParent",
    AardvarkSellPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)

AardvarkSellPanelCharacterPanel.ScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanelCharacterPanel.ScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanelCharacterPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellPanelCharacterPanel.ScrollParent:SetPoint("TOP", AardvarkSellPanelCharacterPanel, "BOTTOM", 0, -8)
AardvarkSellPanelCharacterPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemValue(dragItemID) then
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                elseif checkItemOnCharacterSellList(dragItemID) then
                    alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                else
                    addItemToList(AVKCharacterSellTable, dragItemID)
                end
            else
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                elseif checkItemOnCharacterDestroyList(dragItemID) then
                    alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                else
                    addItemToList(AVKCharacterDestroyTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkSellPanelCharacterPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemValue(clickItemID) then
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    elseif checkItemOnCharacterSellList(clickItemID) then
                        alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterSellTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    elseif checkItemOnCharacterDestroyList(clickItemID) then
                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterDestroyTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)
AardvarkSellPanelCharacterPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkSellPanelCharacterPanelScrollFrame",
    AardvarkSellPanelCharacterPanel.ScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkSellPanelCharacterPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkSellPanelCharacterPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkSellPanelCharacterPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterSellList)
    end
)

AardvarkSellPanelCharacterPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellPanelCharacterPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "sclb" .. i, AardvarkSellPanelCharacterPanel.ScrollParent)
    local button = AardvarkSellPanelCharacterPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempCharacterSellTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Sell.slit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if checkItemValue(clickItemID) then
                                if checkItemOnGlobalSellList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                elseif checkItemOnCharacterSellList(clickItemID) then
                                    alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                                else
                                    addItemToList(AVKCharacterSellTable, clickItemID)
                                end
                            else
                                if checkItemOnGlobalDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                elseif checkItemOnCharacterDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                                else
                                    addItemToList(AVKCharacterDestroyTable, clickItemID)
                                end
                            end
                        end
                    else
                        removeItemFromList(AVKCharacterSellTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if checkItemValue(dragItemID) then
                            if checkItemOnGlobalSellList(dragItemID) then
                                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                            elseif checkItemOnCharacterSellList(dragItemID) then
                                alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                            else
                                addItemToList(AVKCharacterSellTable, dragItemID)
                            end
                        else
                            if checkItemOnGlobalDestroyList(dragItemID) then
                                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                            elseif checkItemOnCharacterDestroyList(dragItemID) then
                                alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                            else
                                addItemToList(AVKCharacterDestroyTable, dragItemID)
                            end
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkSellPanelCharacterPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkSellPanelCharacterPanelClearListButton",
    AardvarkSellPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkSellPanelCharacterPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellPanelCharacterPanel.ClearListButton:SetPoint(
    "TOP",
    AardvarkSellPanelCharacterPanel.ScrollParent,
    "BOTTOM",
    0,
    -5
)
AardvarkSellPanelCharacterPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanelCharacterPanel.ClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanelCharacterPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkSellPanelCharacterPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellPanelCharacterPanel.ClearListButton:SetFormattedText("Clear " .. playerName .. "'s Sell List")
AardvarkSellPanelCharacterPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkSellPanelCharacterPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterSellTable)
        avkUpdateCharacterSellList()
    end
)

-- ===========================         destroy options panel          ===========================
local AardvarkDestroyOptionsPanel = CreateFrame("Frame", "AardvarkDestroyOptionsPanel", AardvarkSideFrame)
AardvarkDestroyOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkDestroyOptionsPanel:SetPoint("TOP", AardvarkSideFrame, "TOP", SizeList.mainFrameMarginGap)
AardvarkDestroyOptionsPanel:Hide()

AardvarkDestroyOptionsPanel.CBded =
    CreateFrame("CheckButton", "CBded", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBded:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBded:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
AardvarkDestroyOptionsPanel.CBded:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBded.Text:SetText(ColourList.textRed .. " Aardvark Destroy")
AardvarkDestroyOptionsPanel.CBded.Text:SetFontObject(FontCheckBoxBig)
AardvarkDestroyOptionsPanel.CBded:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.ded then
            AVKGlobalSettings.Destroy.ded = false
            CBdtdm:Hide()
            CBdddm:Hide()
            CBdntdm:Hide()
            CBdialsm:Hide()
            CBdialfm:Hide()
            CBdirlm:Hide()
            CBdlit:Hide()
        else
            AVKGlobalSettings.Destroy.ded = true
            CBdtdm:Show()
            CBdddm:Show()
            CBdntdm:Show()
            CBdialsm:Show()
            CBdialfm:Show()
            CBdirlm:Show()
            CBdlit:Show()
        end
    end
)

AardvarkDestroyOptionsPanel.CBdtdm =
    CreateFrame("CheckButton", "CBdtdm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdtdm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdtdm:SetPoint("TOPLEFT", CBded, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
AardvarkDestroyOptionsPanel.CBdtdm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdtdm.Text:SetText(" Total Destroyed Messages")
AardvarkDestroyOptionsPanel.CBdtdm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdtdm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dtdm then
            AVKGlobalSettings.Destroy.dtdm = false
        else
            AVKGlobalSettings.Destroy.dtdm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdddm =
    CreateFrame("CheckButton", "CBdddm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdddm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdddm:SetPoint("TOPLEFT", CBdtdm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdddm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdddm.Text:SetText(" Detailed Destroy Messages")
AardvarkDestroyOptionsPanel.CBdddm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdddm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dddm then
            AVKGlobalSettings.Destroy.dddm = false
        else
            AVKGlobalSettings.Destroy.dddm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdntdm =
    CreateFrame("CheckButton", "CBdntdm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdntdm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdntdm:SetPoint("TOPLEFT", CBdddm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdntdm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdntdm.Text:SetText(" Nothing To Destroy Messages")
AardvarkDestroyOptionsPanel.CBdntdm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdntdm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dntdm then
            AVKGlobalSettings.Destroy.dntdm = false
        else
            AVKGlobalSettings.Destroy.dntdm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdialsm =
    CreateFrame("CheckButton", "CBdialsm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdialsm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdialsm:SetPoint("TOPLEFT", CBdntdm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdialsm.Text:SetText(" Item Added Messages")
AardvarkDestroyOptionsPanel.CBdialsm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dialsm then
            AVKGlobalSettings.Destroy.dialsm = false
        else
            AVKGlobalSettings.Destroy.dialsm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdialfm =
    CreateFrame("CheckButton", "CBdialfm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdialfm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdialfm:SetPoint("TOPLEFT", CBdialsm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdialfm.Text:SetText(" Item Not Added Messages")
AardvarkDestroyOptionsPanel.CBdialfm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdialfm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dialfm then
            AVKGlobalSettings.Destroy.dialfm = false
        else
            AVKGlobalSettings.Destroy.dialfm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdirlm =
    CreateFrame("CheckButton", "CBdirlm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdirlm:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdirlm:SetPoint("TOPLEFT", CBdialfm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdirlm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdirlm.Text:SetText(" Item Removed Messages")
AardvarkDestroyOptionsPanel.CBdirlm.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdirlm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dirlm then
            AVKGlobalSettings.Destroy.dirlm = false
        else
            AVKGlobalSettings.Destroy.dirlm = true
        end
    end
)

AardvarkDestroyOptionsPanel.CBdlit =
    CreateFrame("CheckButton", "CBdlit", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
AardvarkDestroyOptionsPanel.CBdlit:ClearAllPoints()
AardvarkDestroyOptionsPanel.CBdlit:SetPoint("TOPLEFT", CBdirlm, 0, -SizeList.checkboxGapY)
AardvarkDestroyOptionsPanel.CBdlit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkDestroyOptionsPanel.CBdlit.Text:SetText(" Show Listed Item Tooltips")
AardvarkDestroyOptionsPanel.CBdlit.Text:SetFontObject(FontCheckBox)
AardvarkDestroyOptionsPanel.CBdlit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dlit then
            AVKGlobalSettings.Destroy.dlit = false
        else
            AVKGlobalSettings.Destroy.dlit = true
        end
    end
)

AardvarkDestroyOptionsPanel.TextBox =
    CreateFrame("Frame", "AardvarkDestroyOptionsPanelTextBox", AardvarkDestroyOptionsPanel)
AardvarkDestroyOptionsPanelTextBox:SetSize(
    SizeList.optionsFrameWidth - SizeList.optionsFrameElementGap * 4,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkDestroyOptionsPanel.TextBox:SetPoint("BOTTOM", AardvarkSideFrame, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkDestroyOptionsPanel.TextBox.Text =
    AardvarkDestroyOptionsPanelTextBox:CreateFontString("AardvarkDestroyOptionsPanelText")
AardvarkDestroyOptionsPanel.TextBox.Text:SetJustifyH("BOTTOM")
AardvarkDestroyOptionsPanel.TextBox.Text:SetJustifyV("BOTTOM")
AardvarkDestroyOptionsPanel.TextBox.Text:SetAllPoints(AardvarkDestroyOptionsPanelTextBox)
AardvarkDestroyOptionsPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkDestroyOptionsPanel.TextBox.Text:SetText(TextList.avkDestroyOptions)

-- ===========================         main destroy list panel          ===========================
local AardvarkDestroyPanel =
    CreateFrame("Frame", "AardvarkDestroyPanel", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkDestroyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanel:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkDestroyPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkDestroyPanel:Hide()

AardvarkDestroyPanel.OptionsButton = CreateFrame("Button", "AardvarkDestroyPanelOptionsButton", AardvarkDestroyPanel)
AardvarkDestroyPanel.OptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyPanel.OptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelSillyButton,
    "CENTER",
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkDestroyPanel.OptionsButton:SetNormalTexture(ImageList.destroyOptions)
AardvarkDestroyPanel.OptionsButton:SetHighlightTexture(ImageList.destroyOptionsHover)
AardvarkDestroyPanel.OptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkDestroyPanelOptionsButton)
    end
)

AardvarkDestroyPanel.FiltersButton = CreateFrame("Button", "AardvarkDestroyPanelFiltersButton", AardvarkDestroyPanel)
AardvarkDestroyPanel.FiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyPanel.FiltersButton:SetPoint("CENTER", AardvarkDestroyPanelOptionsButton, "TOP", 0, 15)
AardvarkDestroyPanel.FiltersButton:SetNormalTexture(ImageList.destroyFilters)
AardvarkDestroyPanel.FiltersButton:SetHighlightTexture(ImageList.destroyFiltersHover)
AardvarkDestroyPanel.FiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)

AardvarkDestroyPanel.SpecialAddButton =
    CreateFrame("Button", "AardvarkDestroyPanelSpecialAddButton", AardvarkDestroyPanel)
AardvarkDestroyPanel.SpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyPanel.SpecialAddButton:SetPoint("CENTER", AardvarkDestroyPanelOptionsButton, "BOTTOM", 0, -15)
AardvarkDestroyPanel.SpecialAddButton:SetNormalTexture(ImageList.destroySpecialAdd)
AardvarkDestroyPanel.SpecialAddButton:SetHighlightTexture(ImageList.destroySpecialAddHover)
AardvarkDestroyPanel.SpecialAddButton:SetScript(
    "OnClick",
    function()
        specialAddPanel()
    end
)

-- ===========================         global destroy list panel          ===========================
local AardvarkDestroyPanelGlobalPanel = CreateFrame("Frame", "AardvarkDestroyPanelGlobalPanel", AardvarkDestroyPanel)
AardvarkDestroyPanelGlobalPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyPanelGlobalPanel:SetPoint(
    "TOPLEFT",
    AardvarkDestroyPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyPanelGlobalPanel.TitleText =
    AardvarkDestroyPanelGlobalPanel:CreateFontString("AardvarkDestroyPanelGlobalPanelTitleText")
AardvarkDestroyPanelGlobalPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkDestroyPanelGlobalPanel.TitleText:SetJustifyH("CENTER")
AardvarkDestroyPanelGlobalPanel.TitleText:SetJustifyV("CENTER")
AardvarkDestroyPanelGlobalPanel.TitleText:SetAllPoints(AardvarkDestroyPanelGlobalPanel)
AardvarkDestroyPanelGlobalPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyPanelGlobalPanel.TitleText:SetText("Global Destroy List")

AardvarkDestroyPanelGlobalPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkDestroyPanelGlobalPanelScrollParent",
    AardvarkDestroyPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetPoint("TOP", AardvarkDestroyPanelGlobalPanel, "BOTTOM", 0, -8)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if not checkItemValue(dragItemID) then
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, dragItemID)
                end
            else
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                else
                    addItemToList(AVKGlobalSellTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkDestroyPanelGlobalPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
        if clickItemType ~= "item" then
            notAnItemMessages()
        else
            if not checkItemValue(clickItemID) then
                if checkItemOnGlobalDestroyList(clickItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, clickItemID)
                end
            else
                if checkItemOnGlobalSellList(clickItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                else
                    addItemToList(AVKGlobalSellTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkDestroyPanelGlobalPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkDestroyGlobalScrollFrame",
    AardvarkDestroyPanelGlobalPanelScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkDestroyPanelGlobalPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkDestroyPanelGlobalPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkDestroyPanelGlobalPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalDestroyList)
    end
)

AardvarkDestroyPanelGlobalPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyPanelGlobalPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "dglb" .. i, AardvarkDestroyPanelGlobalPanelScrollParent)
    local button = AardvarkDestroyPanelGlobalPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempGlobalDestroyTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Destroy.dlit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if not checkItemValue(clickItemID) then
                                if checkItemOnGlobalDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                else
                                    addItemToList(AVKGlobalDestroyTable, clickItemID)
                                end
                            else
                                if checkItemOnGlobalSellList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                else
                                    addItemToList(AVKGlobalSellTable, clickItemID)
                                end
                            end
                        end
                    else
                        removeItemFromList(AVKGlobalDestroyTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if not checkItemValue(dragItemID) then
                            if checkItemOnGlobalDestroyList(dragItemID) then
                                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                            else
                                addItemToList(AVKGlobalDestroyTable, dragItemID)
                            end
                        else
                            if checkItemOnGlobalSellList(dragItemID) then
                                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                            else
                                addItemToList(AVKGlobalSellTable, dragItemID)
                            end
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkDestroyPanelGlobalPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkDestroyPanelGlobalPanelClearListButton",
    AardvarkDestroyPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetPoint(
    "TOP",
    AardvarkDestroyPanelGlobalPanelScrollParent,
    "BOTTOM",
    0,
    -5
)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetFormattedText("Clear Global Destroy List")
AardvarkDestroyPanelGlobalPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkDestroyPanelGlobalPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalDestroyTable)
        avkUpdateGlobalDestroyList()
    end
)

-- ===========================         character destroy list panel          ===========================
local AardvarkDestroyPanelCharacterPanel =
    CreateFrame("Frame", "AardvarkDestroyPanelCharacterPanel", AardvarkDestroyPanel)
AardvarkDestroyPanelCharacterPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyPanelCharacterPanel:SetPoint(
    "TOPRIGHT",
    AardvarkDestroyPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyPanelCharacterPanel.TitleText =
    AardvarkDestroyPanelCharacterPanel:CreateFontString("AardvarkDestroyPanelCharacterPanelTitleText")
AardvarkDestroyPanelCharacterPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkDestroyPanelCharacterPanel.TitleText:SetJustifyH("CENTER")
AardvarkDestroyPanelCharacterPanel.TitleText:SetJustifyV("CENTER")
AardvarkDestroyPanelCharacterPanel.TitleText:SetAllPoints(AardvarkDestroyPanelCharacterPanel)
AardvarkDestroyPanelCharacterPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyPanelCharacterPanel.TitleText:SetText(playerName .. "'s\nDestroy List")

AardvarkDestroyPanelCharacterPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkDestroyPanelCharacterPanelScrollParent",
    AardvarkDestroyPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetPoint("TOP", AardvarkDestroyPanelCharacterPanel, "BOTTOM", 0, -8)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if not checkItemValue(dragItemID) then
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                elseif checkItemOnCharacterDestroyList(dragItemID) then
                    alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                else
                    addItemToList(AVKCharacterDestroyTable, dragItemID)
                end
            else
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                elseif checkItemOnCharacterSellList(dragItemID) then
                    alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                else
                    addItemToList(AVKCharacterSellTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkDestroyPanelCharacterPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if not checkItemValue(clickItemID) then
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    elseif checkItemOnCharacterDestroyList(clickItemID) then
                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterDestroyTable, clickItemID)
                    end
                else
                    addItemToList(AVKCharacterSellTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)
AardvarkDestroyPanelCharacterPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkDestroyCharacterScrollFrame",
    AardvarkDestroyPanelCharacterPanelScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkDestroyPanelCharacterPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkDestroyPanelCharacterPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkDestroyPanelCharacterPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterDestroyList)
    end
)

AardvarkDestroyPanelCharacterPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyPanelCharacterPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "dclb" .. i, AardvarkDestroyPanelCharacterPanelScrollParent)
    local button = AardvarkDestroyPanelCharacterPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempCharacterDestroyTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Destroy.dlit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if not checkItemValue(clickItemID) then
                                if checkItemOnGlobalDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                elseif checkItemOnCharacterDestroyList(clickItemID) then
                                    alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                                else
                                    addItemToList(AVKCharacterDestroyTable, clickItemID)
                                end
                            else
                                if checkItemOnGlobalSellList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                elseif checkItemOnCharacterSellList(clickItemID) then
                                    alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                                else
                                    addItemToList(AVKCharacterSellTable, clickItemID)
                                end
                            end
                        end
                    else
                        removeItemFromList(AVKCharacterDestroyTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if not checkItemValue(dragItemID) then
                            if checkItemOnGlobalDestroyList(dragItemID) then
                                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                            elseif checkItemOnCharacterDestroyList(dragItemID) then
                                alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                            else
                                addItemToList(AVKCharacterDestroyTable, dragItemID)
                            end
                        else
                            if checkItemOnGlobalSellList(dragItemID) then
                                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                            elseif checkItemOnCharacterSellList(dragItemID) then
                                alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                            else
                                addItemToList(AVKCharacterSellTable, dragItemID)
                            end
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkDestroyPanelCharacterPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkDestroyPanelCharacterPanelClearListButton",
    AardvarkDestroyPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetPoint(
    "TOP",
    AardvarkDestroyPanelCharacterPanelScrollParent,
    "BOTTOM",
    0,
    -5
)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetFormattedText("Clear " .. playerName .. "'s Destroy List")
AardvarkDestroyPanelCharacterPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkDestroyPanelCharacterPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterDestroyTable)
        avkUpdateCharacterDestroyList()
    end
)

-- ===========================         protect options panel          ===========================
local AardvarkProtectOptionsPanel = CreateFrame("Frame", "AardvarkProtectOptionsPanel", AardvarkSideFrame)
AardvarkProtectOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkProtectOptionsPanel:SetPoint("TOP", AardvarkSideFrame, "TOP", SizeList.mainFrameMarginGap)
AardvarkProtectOptionsPanel:Hide()

AardvarkProtectOptionsPanel.CBpep =
    CreateFrame("CheckButton", "CBpep", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpep:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpep:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
AardvarkProtectOptionsPanel.CBpep:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpep.Text:SetText(ColourList.textOrange .. " Aardvark Protect")
AardvarkProtectOptionsPanel.CBpep.Text:SetFontObject(FontCheckBoxBig)
AardvarkProtectOptionsPanel.CBpep:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pep then
            AVKGlobalSettings.Protect.pep = false
            CBpialsm:Hide()
            CBpialfm:Hide()
            CBpirlm:Hide()
            CBpdpm:Hide()
            CBpcbp:Hide()
            CBplit:Hide()
        else
            AVKGlobalSettings.Protect.pep = true
            CBpialsm:Show()
            CBpialfm:Show()
            CBpirlm:Show()
            CBpdpm:Show()
            CBpcbp:Show()
            CBplit:Show()
        end
    end
)

AardvarkProtectOptionsPanel.CBpialsm =
    CreateFrame("CheckButton", "CBpialsm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpialsm:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpialsm:SetPoint(
    "TOPLEFT",
    CBpep,
    SizeList.checkBoxChildGapX * 1.5,
    -SizeList.checkboxGapY * 1.2
)
AardvarkProtectOptionsPanel.CBpialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpialsm.Text:SetText(" Item Added Messages")
AardvarkProtectOptionsPanel.CBpialsm.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBpialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pialsm then
            AVKGlobalSettings.Protect.pialsm = false
        else
            AVKGlobalSettings.Protect.pialsm = true
        end
    end
)

AardvarkProtectOptionsPanel.CBpialfm =
    CreateFrame("CheckButton", "CBpialfm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpialfm:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpialfm:SetPoint("TOPLEFT", CBpialsm, 0, -SizeList.checkboxGapY)
AardvarkProtectOptionsPanel.CBpialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpialfm.Text:SetText(" Item Not Added Messages")
AardvarkProtectOptionsPanel.CBpialfm.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBpialfm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pialfm then
            AVKGlobalSettings.Protect.pialfm = false
        else
            AVKGlobalSettings.Protect.pialfm = true
        end
    end
)

AardvarkProtectOptionsPanel.CBpirlm =
    CreateFrame("CheckButton", "CBpirlm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpirlm:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpirlm:SetPoint("TOPLEFT", CBpialfm, 0, -SizeList.checkboxGapY)
AardvarkProtectOptionsPanel.CBpirlm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpirlm.Text:SetText(" Item Removed Messages")
AardvarkProtectOptionsPanel.CBpirlm.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBpirlm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pirlm then
            AVKGlobalSettings.Protect.pirlm = false
        else
            AVKGlobalSettings.Protect.pirlm = true
        end
    end
)

AardvarkProtectOptionsPanel.CBpdpm =
    CreateFrame("CheckButton", "CBpdpm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpdpm:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpdpm:SetPoint("TOPLEFT", CBpirlm, 0, -SizeList.checkboxGapY)
AardvarkProtectOptionsPanel.CBpdpm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpdpm.Text:SetText(" Protected Item Messages")
AardvarkProtectOptionsPanel.CBpdpm.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBpdpm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pdpm then
            AVKGlobalSettings.Protect.pdpm = false
        else
            AVKGlobalSettings.Protect.pdpm = true
        end
    end
)

AardvarkProtectOptionsPanel.CBpcbp =
    CreateFrame("CheckButton", "CBpcbp", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBpcbp:ClearAllPoints()
AardvarkProtectOptionsPanel.CBpcbp:SetPoint("TOPLEFT", CBpdpm, 0, -SizeList.checkboxGapY)
AardvarkProtectOptionsPanel.CBpcbp:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBpcbp.Text:SetText(" Protect Caged Battle Pets")
AardvarkProtectOptionsPanel.CBpcbp.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBpcbp:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pcbp then
            AVKGlobalSettings.Protect.pcbp = false
        else
            AVKGlobalSettings.Protect.pcbp = true
        end
        avkUpdateGlobalProtectList()
    end
)

AardvarkProtectOptionsPanel.CBplit =
    CreateFrame("CheckButton", "CBplit", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
AardvarkProtectOptionsPanel.CBplit:ClearAllPoints()
AardvarkProtectOptionsPanel.CBplit:SetPoint("TOPLEFT", CBpcbp, 0, -SizeList.checkboxGapY)
AardvarkProtectOptionsPanel.CBplit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkProtectOptionsPanel.CBplit.Text:SetText(" Show Listed Item Tooltips")
AardvarkProtectOptionsPanel.CBplit.Text:SetFontObject(FontCheckBox)
AardvarkProtectOptionsPanel.CBplit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.plit then
            AVKGlobalSettings.Protect.plit = false
        else
            AVKGlobalSettings.Protect.plit = true
        end
    end
)

AardvarkProtectOptionsPanel.TextBox =
    CreateFrame("Frame", "AardvarkProtectOptionsPanelTextBox", AardvarkProtectOptionsPanel)
AardvarkProtectOptionsPanel.TextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkProtectOptionsPanel.TextBox:SetPoint("BOTTOM", AardvarkSideFrame, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkProtectOptionsPanel.TextBox.Text =
    AardvarkProtectOptionsPanel.TextBox:CreateFontString("AardvarkProtectOptionsPanelTextBoxText")
AardvarkProtectOptionsPanel.TextBox.Text:SetJustifyH("BOTTOM")
AardvarkProtectOptionsPanel.TextBox.Text:SetJustifyV("BOTTOM")
AardvarkProtectOptionsPanel.TextBox.Text:SetAllPoints(AardvarkProtectOptionsPanel.TextBox)
AardvarkProtectOptionsPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkProtectOptionsPanel.TextBox.Text:SetText(TextList.avkProtectOptions)

-- ===========================         main protect panel          ===========================
local AardvarkProtectPanel =
    CreateFrame("Frame", "AardvarkProtectPanel", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkProtectPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanel:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkProtectPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkProtectPanel:Hide()

AardvarkProtectPanel.OptionsButton = CreateFrame("Button", "AardvarkProtectPanelOptionsButton", AardvarkProtectPanel)
AardvarkProtectPanel.OptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectPanel.OptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationPanelSillyButton,
    "CENTER",
    SizeList.mainFrameNavigationButtonSpace * .6 + SizeList.optionsButtonSize,
    0
)
AardvarkProtectPanel.OptionsButton:SetNormalTexture(ImageList.protectOptions)
AardvarkProtectPanel.OptionsButton:SetHighlightTexture(ImageList.protectOptionsHover)
AardvarkProtectPanel.OptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkProtectPanelOptionsButton)
    end
)

AardvarkProtectPanel.FiltersButton = CreateFrame("Button", "AardvarkProtectPanelFiltersButton", AardvarkProtectPanel)
AardvarkProtectPanel.FiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectPanel.FiltersButton:SetPoint("CENTER", AardvarkProtectPanelOptionsButton, "TOP", 0, 15)
AardvarkProtectPanel.FiltersButton:SetNormalTexture(ImageList.protectFilters)
AardvarkProtectPanel.FiltersButton:SetHighlightTexture(ImageList.protectFiltersHover)
AardvarkProtectPanel.FiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkFiltersButton)
    end
)

AardvarkProtectPanel.SpecialAddButton =
    CreateFrame("Button", "AardvarkProtectPanelSpecialAddButton", AardvarkProtectPanel)
AardvarkProtectPanel.SpecialAddButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectPanel.SpecialAddButton:SetPoint("CENTER", AardvarkProtectPanelOptionsButton, "BOTTOM", 0, -15)
AardvarkProtectPanel.SpecialAddButton:SetNormalTexture(ImageList.protectSpecialAdd)
AardvarkProtectPanel.SpecialAddButton:SetHighlightTexture(ImageList.protectSpecialAddHover)
AardvarkProtectPanel.SpecialAddButton:SetScript(
    "OnClick",
    function()
        specialAddPanel()
    end
)

-- ===========================         global protect list panel          ===========================
local AardvarkProtectPanelGlobalPanel = CreateFrame("Frame", "AardvarkProtectPanelGlobalPanel", AardvarkProtectPanel)
AardvarkProtectPanelGlobalPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectPanelGlobalPanel:SetPoint(
    "TOPLEFT",
    AardvarkProtectPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectPanelGlobalPanel.TitleText =
    AardvarkProtectPanelGlobalPanel:CreateFontString("AardvarkProtectPanelGlobalPanelTitleText")
AardvarkProtectPanelGlobalPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkProtectPanelGlobalPanel.TitleText:SetJustifyH("CENTER")
AardvarkProtectPanelGlobalPanel.TitleText:SetJustifyV("CENTER")
AardvarkProtectPanelGlobalPanel.TitleText:SetAllPoints(AardvarkProtectPanelGlobalPanel)
AardvarkProtectPanelGlobalPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkProtectPanelGlobalPanel.TitleText:SetText("Global Protect List")

AardvarkProtectPanelGlobalPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkProtectPanelGlobalPanelScrollParent",
    AardvarkProtectPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetPoint("TOP", AardvarkProtectPanelGlobalPanel, "BOTTOM", 0, -8)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            else
                addItemToList(AVKGlobalProtectTable, dragItemID)
            end
        end
        ClearCursor()
    end
)
AardvarkProtectPanelGlobalPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(clickItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                else
                    addItemToList(AVKGlobalProtectTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)

AardvarkProtectPanelGlobalPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkProtectPanelGlobalPanelScrollFrame",
    AardvarkProtectPanelGlobalPanelScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkProtectPanelGlobalPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkProtectPanelGlobalPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkProtectPanelGlobalPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateGlobalProtectList)
    end
)

AardvarkProtectPanelGlobalPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectPanelGlobalPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "pglb" .. i, AardvarkProtectPanelGlobalPanelScrollParent)
    local button = AardvarkProtectPanelGlobalPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempGlobalProtectTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if checkItemOnGlobalProtectList(clickItemID) then
                                alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                            else
                                addItemToList(AVKGlobalProtectTable, clickItemID)
                            end
                        end
                    else
                        removeItemFromList(AVKGlobalProtectTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if checkItemOnGlobalProtectList(dragItemID) then
                            alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
                        else
                            addItemToList(AVKGlobalProtectTable, dragItemID)
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkProtectPanelGlobalPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkProtectPanelGlobalPanelClearListButton",
    AardvarkProtectPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetPoint(
    "TOP",
    AardvarkProtectPanelGlobalPanelScrollParent,
    "BOTTOM",
    0,
    -5
)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectPanelGlobalPanel.ClearListButton:SetFormattedText("Clear Global Protect List")
AardvarkProtectPanelGlobalPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkProtectPanelGlobalPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalProtectTable)
        avkUpdateGlobalProtectList()
    end
)

-- ===========================         character protect list panel          ===========================
local AardvarkProtectPanelCharacterPanel =
    CreateFrame("Frame", "AardvarkProtectPanelCharacterPanel", AardvarkProtectPanel)
AardvarkProtectPanelCharacterPanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectPanelCharacterPanel:SetPoint(
    "TOPRIGHT",
    AardvarkProtectPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectPanelCharacterPanel.TitleText =
    AardvarkProtectPanelCharacterPanel:CreateFontString("AardvarkProtectPanelCharacterPanelTitleText")
AardvarkProtectPanelCharacterPanel.TitleText:SetPoint("CENTER", 0, 0)
AardvarkProtectPanelCharacterPanel.TitleText:SetJustifyH("CENTER")
AardvarkProtectPanelCharacterPanel.TitleText:SetJustifyV("CENTER")
AardvarkProtectPanelCharacterPanel.TitleText:SetAllPoints(AardvarkProtectPanelCharacterPanel)
AardvarkProtectPanelCharacterPanel.TitleText:SetFontObject(FontTitleScroll)
AardvarkProtectPanelCharacterPanel.TitleText:SetText(playerName .. "'s\nProtect List")

AardvarkProtectPanelCharacterPanel.ScrollParent =
    CreateFrame(
    "Button",
    "AardvarkProtectPanelCharacterPanelScrollParent",
    AardvarkProtectPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetPoint("TOP", AardvarkProtectPanelCharacterPanel, "BOTTOM", 0, -8)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            elseif checkItemOnCharacterProtectList(dragItemID) then
                alreadyListedMessages(AVKCharacterProtectTable, dragItemLink)
            else
                addItemToList(AVKCharacterProtectTable, dragItemID)
            end
        end
        ClearCursor()
    end
)
AardvarkProtectPanelCharacterPanel.ScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(clickItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                elseif checkItemOnCharacterProtectList(clickItemID) then
                    alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
                else
                    addItemToList(AVKCharacterProtectTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)

AardvarkProtectPanelCharacterPanel.ScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkProtectPanelCharacterPanelScrollFrame",
    AardvarkProtectPanelCharacterPanelScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkProtectPanelCharacterPanel.ScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkProtectPanelCharacterPanel.ScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkProtectPanelCharacterPanel.ScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateCharacterProtectList)
    end
)

AardvarkProtectPanelCharacterPanel.ScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectPanelCharacterPanel.ScrollFrame.buttons[i] =
        CreateFrame("Button", "pclb" .. i, AardvarkProtectPanelCharacterPanelScrollParent)
    local button = AardvarkProtectPanelCharacterPanel.ScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = VariableList.tempCharacterProtectTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if checkItemOnGlobalProtectList(clickItemID) then
                                alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                            elseif checkItemOnCharacterProtectList(clickItemID) then
                                alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
                            else
                                addItemToList(AVKCharacterProtectTable, clickItemID)
                            end
                        end
                    else
                        removeItemFromList(AVKCharacterProtectTable, itemLink)
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if checkItemOnGlobalProtectList(dragItemID) then
                            alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
                        elseif checkItemOnCharacterProtectList(dragItemID) then
                            alreadyListedMessages(AVKCharacterProtectTable, dragItemLink)
                        else
                            addItemToList(AVKCharacterProtectTable, dragItemID)
                        end
                        GameTooltip:Hide()
                    end
                    ClearCursor()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

AardvarkProtectPanelCharacterPanel.ClearListButton =
    CreateFrame(
    "Button",
    "AardvarkProtectPanelCharacterPanelClearListButton",
    AardvarkProtectPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetPoint(
    "TOP",
    AardvarkProtectPanelCharacterPanelScrollParent,
    "BOTTOM",
    0,
    -5
)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectPanelCharacterPanel.ClearListButton:SetFormattedText("Clear " .. playerName .. "'s Protect List")
AardvarkProtectPanelCharacterPanel.ClearListButton:RegisterForClicks("RightButtonUp")
AardvarkProtectPanelCharacterPanel.ClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterProtectTable)
        avkUpdateCharacterProtectList()
    end
)

-- ===========================         repair options panel          ===========================
local AardvarkRepairOptionsPanel =
    CreateFrame(
    "Frame",
    "AardvarkRepairOptionsPanel",
    AardvarkMainFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkRepairOptionsPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkRepairOptionsPanel:SetBackdropBorderColor(1, 0, 1, 1)
AardvarkRepairOptionsPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkRepairOptionsPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkRepairOptionsPanel:Hide()

AardvarkRepairOptionsPanel.CBrer =
    CreateFrame("CheckButton", "CBrer", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrer:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrer:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
AardvarkRepairOptionsPanel.CBrer:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrer.Text:SetText(ColourList.textPink .. " Aardvark Repair")
AardvarkRepairOptionsPanel.CBrer.Text:SetFontObject(FontCheckBoxBig)
AardvarkRepairOptionsPanel.CBrer:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rer then
            AVKGlobalSettings.Repair.rer = false
            CBrgr:Hide()
            CBrtrm:Hide()
            CBrcarm:Hide()
            CBrntrm:Hide()
            CBrvcrm:Hide()
        else
            AVKGlobalSettings.Repair.rer = true
            CBrgr:Show()
            CBrtrm:Show()
            CBrcarm:Show()
            CBrntrm:Show()
            CBrvcrm:Show()
        end
    end
)

AardvarkRepairOptionsPanel.CBrgr =
    CreateFrame("CheckButton", "CBrgr", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrgr:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrgr:SetPoint("TOPLEFT", CBrer, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
AardvarkRepairOptionsPanel.CBrgr:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrgr.Text:SetText(" Guild Repair")
AardvarkRepairOptionsPanel.CBrgr.Text:SetFontObject(FontCheckBox)
AardvarkRepairOptionsPanel.CBrgr:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rgr then
            AVKGlobalSettings.Repair.rgr = false
        else
            AVKGlobalSettings.Repair.rgr = true
        end
    end
)

AardvarkRepairOptionsPanel.CBrtrm =
    CreateFrame("CheckButton", "CBrtrm", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrtrm:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrtrm:SetPoint("TOPLEFT", CBrgr, 0, -SizeList.checkboxGapY)
AardvarkRepairOptionsPanel.CBrtrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrtrm.Text:SetText(" Total Repaired Messages")
AardvarkRepairOptionsPanel.CBrtrm.Text:SetFontObject(FontCheckBox)
AardvarkRepairOptionsPanel.CBrtrm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rtrm then
            AVKGlobalSettings.Repair.rtrm = false
        else
            AVKGlobalSettings.Repair.rtrm = true
        end
    end
)

AardvarkRepairOptionsPanel.CBrcarm =
    CreateFrame("CheckButton", "CBrcarm", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrcarm:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrcarm:SetPoint("TOPLEFT", CBrtrm, 0, -SizeList.checkboxGapY)
AardvarkRepairOptionsPanel.CBrcarm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrcarm.Text:SetText(" Cannot Afford Repair Messages")
AardvarkRepairOptionsPanel.CBrcarm.Text:SetFontObject(FontCheckBox)
AardvarkRepairOptionsPanel.CBrcarm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rcarm then
            AVKGlobalSettings.Repair.rcarm = false
        else
            AVKGlobalSettings.Repair.rcarm = true
        end
    end
)

AardvarkRepairOptionsPanel.CBrntrm =
    CreateFrame("CheckButton", "CBrntrm", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrntrm:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrntrm:SetPoint("TOPLEFT", CBrcarm, 0, -SizeList.checkboxGapY)
AardvarkRepairOptionsPanel.CBrntrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrntrm.Text:SetText(" Nothing To Repair Messages")
AardvarkRepairOptionsPanel.CBrntrm.Text:SetFontObject(FontCheckBox)
AardvarkRepairOptionsPanel.CBrntrm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rntrm then
            AVKGlobalSettings.Repair.rntrm = false
        else
            AVKGlobalSettings.Repair.rntrm = true
        end
    end
)

AardvarkRepairOptionsPanel.CBrvcrm =
    CreateFrame("CheckButton", "CBrvcrm", AardvarkRepairOptionsPanel, "UICheckButtonTemplate")
AardvarkRepairOptionsPanel.CBrvcrm:ClearAllPoints()
AardvarkRepairOptionsPanel.CBrvcrm:SetPoint("TOPLEFT", CBrntrm, 0, -SizeList.checkboxGapY)
AardvarkRepairOptionsPanel.CBrvcrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
AardvarkRepairOptionsPanel.CBrvcrm.Text:SetText(" Vendor Cannot Repair Messages")
AardvarkRepairOptionsPanel.CBrvcrm.Text:SetFontObject(FontCheckBox)
AardvarkRepairOptionsPanel.CBrvcrm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rvcrm then
            AVKGlobalSettings.Repair.rvcrm = false
        else
            AVKGlobalSettings.Repair.rvcrm = true
        end
    end
)

AardvarkRepairOptionsPanel.TextBox =
    CreateFrame("Frame", "AardvarkRepairOptionsPanelTextBox", AardvarkRepairOptionsPanel)
AardvarkRepairOptionsPanel.TextBox:SetSize(
    SizeList.scrollFrameWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkRepairOptionsPanel.TextBox:SetPoint("TOPRIGHT", -SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
AardvarkRepairOptionsPanel.TextBox.Text =
    AardvarkRepairOptionsPanel.TextBox:CreateFontString("AardvarkRepairOptionsPanelTextBoxText")
AardvarkRepairOptionsPanel.TextBox.Text:SetJustifyH("CENTER")
AardvarkRepairOptionsPanel.TextBox.Text:SetJustifyV("TOP")
AardvarkRepairOptionsPanel.TextBox.Text:SetAllPoints(AardvarkRepairOptionsPanelTextBox)
AardvarkRepairOptionsPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkRepairOptionsPanel.TextBox.Text:SetText(TextList.avkRepairOptions)

-- ===========================         aardvark info panel          ===========================
local AardvarkInfoPanel =
    CreateFrame("Frame", "AardvarkInfoPanel", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkInfoPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkInfoPanel:SetBackdropBorderColor(1, 1, 0, 1)
AardvarkInfoPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkInfoPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkInfoPanel:Hide()

AardvarkInfoPanel.TextBox1 = CreateFrame("Frame", "AardvarkInfoPanelTextBox1", AardvarkInfoPanel)
AardvarkInfoPanel.TextBox1:SetSize(SizeList.infoPanelTextBoxWidth, SizeList.infoPanelTextBoxHeight)
AardvarkInfoPanel.TextBox1:SetPoint("TOP", AardvarkInfoPanel)
AardvarkInfoPanel.TextBox1.Text = AardvarkInfoPanel.TextBox1:CreateFontString("AardvarkInfoPanelTextBoxText1")
AardvarkInfoPanel.TextBox1.Text:SetJustifyH("LEFT")
AardvarkInfoPanel.TextBox1.Text:SetJustifyV("CENTER")
AardvarkInfoPanel.TextBox1.Text:SetAllPoints(AardvarkInfoPanelTextBox1)
AardvarkInfoPanel.TextBox1.Text:SetFontObject(FontContent)
AardvarkInfoPanel.TextBox1.Text:SetText(TextList.avkKeybinds)

AardvarkInfoPanel.KeybindingsButton =
    CreateFrame(
    "Button",
    "AardvarkInfoPanelKeybindingsButton",
    AardvarkInfoPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkInfoPanel.KeybindingsButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkInfoPanel.KeybindingsButton:SetPoint("TOP", AardvarkInfoPanelTextBox1, "BOTTOM")
AardvarkInfoPanel.KeybindingsButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkInfoPanel.KeybindingsButton:SetBackdropBorderColor(1, 1, 0, 1)
AardvarkInfoPanel.KeybindingsButton:SetNormalFontObject(FontButton)
AardvarkInfoPanel.KeybindingsButton:SetHighlightFontObject(FontButton)
AardvarkInfoPanel.KeybindingsButton:SetFormattedText("Keybinding UI")
AardvarkInfoPanel.KeybindingsButton:SetScript(
    "OnClick",
    function()
        AardvarkMainFrame:Hide()
        GameMenuButtonSettings:Click("RightButton")
        SettingsPanel.GameTab:Click("RightButton")
        for _, v in pairs(KeyBindingFrame.categoryList.buttons) do
            if v:GetText() == "Walkerbo's Addons" or v:GetText() == "WALKERBO" then
                v:Click()
            end
        end
    end
)

AardvarkInfoPanel.TextBox2 = CreateFrame("Frame", "AardvarkInfoPanelTextBox2", AardvarkInfoPanel)
AardvarkInfoPanel.TextBox2:SetSize(SizeList.infoPanelTextBoxWidth, SizeList.infoPanelTextBoxHeight)
AardvarkInfoPanel.TextBox2:SetPoint("BOTTOM", AardvarkInfoPanel)
AardvarkInfoPanel.TextBox2.Text = AardvarkInfoPanel.TextBox2:CreateFontString("AardvarkInfoPanelTextBoxText2")
AardvarkInfoPanel.TextBox2.Text:SetJustifyH("LEFT")
AardvarkInfoPanel.TextBox2.Text:SetJustifyV("CENTER")
AardvarkInfoPanel.TextBox2.Text:SetAllPoints(AardvarkInfoPanelTextBox2)
AardvarkInfoPanel.TextBox2.Text:SetFontObject(FontContent)
AardvarkInfoPanel.TextBox2.Text:SetText(TextList.avkSlashCommands)

-- ===========================         aardvark silly panel          ===========================
local AardvarkSillyPanel =
    CreateFrame("Frame", "AardvarkSillyPanel", AardvarkMainFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkSillyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSillyPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSillyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSillyPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkSillyPanel:Hide()

AardvarkSillyPanel.TextBox = CreateFrame("Frame", "AardvarkSillyPanelTextBox", AardvarkSillyPanel)
AardvarkSillyPanel.TextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.mainPanelElementGap,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSillyPanel.TextBox:SetPoint("TOP", AardvarkSillyPanel, 0, -11)
AardvarkSillyPanel.TextBox.Text = AardvarkSillyPanel.TextBox:CreateFontString("AardvarkSillyText")
AardvarkSillyPanel.TextBox.Text:SetAllPoints(AardvarkSillyPanelTextBox)
AardvarkSillyPanel.TextBox.Text:SetFontObject(FontContent)
AardvarkSillyPanel.TextBox.Text:SetText(TextList.avkAboutAardvark)

-- ===========================         scale panel          ===========================
local AardvarkScalePanel =
    CreateFrame("Frame", "AardvarkScalePanel", UIParent, "BackdropTemplate", "TooltipBorderedFrameTemplate")
AardvarkScalePanel:SetBackdrop(
    {
        bgFile = "Interface\\Buttons\\WHITE8X8",
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkScalePanel:SetBackdropColor(0, 0, 0, 1)
AardvarkScalePanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkScalePanel:ClearAllPoints()
AardvarkScalePanel:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "BOTTOMLEFT", SizeList.mainFrameSetPoint, 0)
AardvarkScalePanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkScalePanel:SetScale(1)
AardvarkScalePanel:SetClampedToScreen(true)
AardvarkScalePanel:EnableMouse(true)
AardvarkScalePanel:SetMovable(true)
AardvarkScalePanel:RegisterForDrag("RightButton", "LeftButton")
AardvarkScalePanel:SetScript("OnDragStart", AardvarkScalePanel.StartMoving)
AardvarkScalePanel:SetScript("OnDragStop", AardvarkScalePanel.StopMovingOrSizing)
AardvarkScalePanel:SetToplevel(true)
AardvarkScalePanel:Hide()

AardvarkScalePanel.CloseButton = CreateFrame("Button", "AardvarkScaleFrameCloseButton", AardvarkScalePanel)
AardvarkScalePanel.CloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkScalePanel.CloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkScalePanel.CloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkScalePanel.CloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkScalePanel.CloseButton:SetScript(
    "OnClick",
    function(self)
        AardvarkScalePanel:Hide()
    end
)

local AardvarkMagicButtonScaler =
    CreateFrame("Slider", "AardvarkMagicButtonScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkMagicButtonScaler:SetPoint("CENTER", 0, 0)
AardvarkMagicButtonScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMagicButtonScaler.textLow = _G["AardvarkMagicButtonScaler" .. "Low"]
AardvarkMagicButtonScaler.textHigh = _G["AardvarkMagicButtonScaler" .. "High"]
AardvarkMagicButtonScaler.text = _G["AardvarkMagicButtonScaler" .. "Text"]
AardvarkMagicButtonScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMagicButtonScaler.minValue, AardvarkMagicButtonScaler.maxValue = AardvarkMagicButtonScaler:GetMinMaxValues()
AardvarkMagicButtonScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkMagicButtonScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkMagicButtonScalerText:SetFontObject(FontButton)
AardvarkMagicButtonScalerText:SetText(ColourList.textBlue .. "Aardvark Button")
AardvarkMagicButtonScaler:SetValue(.5)
AardvarkMagicButtonScaler:SetValueStep(1)
AardvarkMagicButtonScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.ambs = tonumber(event)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    end
)

local AardvarkMainFrameScaler =
    CreateFrame("Slider", "AardvarkMainFrameScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkMainFrameScaler:SetPoint("CENTER", AardvarkMagicButtonScaler, 0, SizeList.scaleButtonGap)
AardvarkMainFrameScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMainFrameScaler.textLow = _G["AardvarkMainFrameScaler" .. "Low"]
AardvarkMainFrameScaler.textHigh = _G["AardvarkMainFrameScaler" .. "High"]
AardvarkMainFrameScaler.text = _G["AardvarkMainFrameScaler" .. "Text"]
AardvarkMainFrameScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMainFrameScaler.minValue, AardvarkMainFrameScaler.maxValue = AardvarkMainFrameScaler:GetMinMaxValues()
AardvarkMainFrameScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkMainFrameScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkMainFrameScalerText:SetFontObject(FontButton)
AardvarkMainFrameScalerText:SetText(ColourList.textBlue .. "Aardvark Frame")
AardvarkMainFrameScaler:SetValue(.5)
AardvarkMainFrameScaler:SetValueStep(1)
AardvarkMainFrameScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.amfs = tonumber(event)
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    end
)

local AardvarkActionBarScaler =
    CreateFrame("Slider", "AardvarkActionBarScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkActionBarScaler:SetPoint("CENTER", AardvarkMagicButtonScaler, 0, -SizeList.scaleButtonGap)
AardvarkActionBarScaler:SetScale(SizeList.scaleSliderScale)
AardvarkActionBarScaler.textLow = _G["AardvarkActionBarScaler" .. "Low"]
AardvarkActionBarScaler.textHigh = _G["AardvarkActionBarScaler" .. "High"]
AardvarkActionBarScaler.text = _G["AardvarkActionBarScaler" .. "Text"]
AardvarkActionBarScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkActionBarScaler.minValue, AardvarkActionBarScaler.maxValue = AardvarkActionBarScaler:GetMinMaxValues()
AardvarkActionBarScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkActionBarScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkActionBarScalerText:SetFontObject(FontButton)
AardvarkActionBarScalerText:SetText(ColourList.textBlue .. "Aardvark Action Bar")
AardvarkActionBarScaler:SetValue(1)
AardvarkActionBarScaler:SetValueStep(1)
AardvarkActionBarScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.aabs = tonumber(event)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark magic button          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkMagicButton = CreateFrame("Button", "AardvarkMagicButton", UIParent)
AardvarkMagicButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkMagicButton:ClearAllPoints()
AardvarkMagicButton:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "TOPRIGHT", 0, 20)
AardvarkMagicButton:SetNormalTexture(ImageList.avkButton)
AardvarkMagicButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkMagicButton:SetMovable(true)
AardvarkMagicButton:SetClampedToScreen(true)
AardvarkMagicButton:RegisterForDrag("MiddleButton")
AardvarkMagicButton:SetScript("OnDragStart", AardvarkMagicButton.StartMoving)
AardvarkMagicButton:SetScript("OnDragStop", AardvarkMagicButton.StopMovingOrSizing)
AardvarkMagicButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
AardvarkMagicButton:SetToplevel(true)
AardvarkMagicButton:SetScript(
    "OnEnter",
    function(self)
        GameTooltip:SetOwner(self, "ANCHOR_TOP", 5, 5)
        GameTooltip:AddDoubleLine(addonName, versionNumber, 0, 1, 1, 0, 1, 1)
        GameTooltip:AddLine(TextList.avkMagicButton)
        if AVKGlobalSettings.Aardvark.amfbt then
            GameTooltip:Show()
        else
            GameTooltip:Hide()
        end
        AardvarkMagicButton:SetScript(
            "OnReceiveDrag",
            function()
                if GetCursorInfo() then
                    dragItemType, dragItemID, dragItemLink = GetCursorInfo()
                    if dragItemType ~= "item" then
                        notAnItemMessages()
                    else
                        if IsControlKeyDown() then
                            if checkItemOnGlobalProtectList(dragItemID) then
                                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
                            else
                                addItemToList(AVKGlobalProtectTable, dragItemID)
                            end
                        elseif IsShiftKeyDown() then
                            if checkItemOnGlobalProtectList(dragItemID) then
                                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
                            elseif checkItemOnCharacterProtectList(dragItemID) then
                                alreadyListedMessages(AVKCharacterProtectTable, dragItemLink)
                            else
                                addItemToList(AVKCharacterProtectTable, dragItemID)
                            end
                        elseif IsAltKeyDown() then
                            if checkItemValue(dragItemID) then
                                if checkItemOnGlobalSellList(dragItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                                else
                                    addItemToList(AVKGlobalSellTable, dragItemID)
                                end
                            else
                                if checkItemOnGlobalDestroyList(dragItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                                else
                                    addItemToList(AVKGlobalDestroyTable, dragItemID)
                                end
                            end
                        else
                            if checkItemValue(dragItemID) then
                                if checkItemOnGlobalSellList(dragItemID) then
                                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                                elseif checkItemOnCharacterSellList(dragItemID) then
                                    alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                                else
                                    addItemToList(AVKCharacterSellTable, dragItemID)
                                end
                            else
                                if checkItemOnGlobalDestroyList(dragItemID) then
                                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                                elseif checkItemOnCharacterDestroyList(dragItemID) then
                                    alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                                else
                                    addItemToList(AVKCharacterDestroyTable, dragItemID)
                                end
                            end
                        end
                        ClearCursor()
                    end
                end
            end
        )
        AardvarkMagicButton:SetScript(
            "OnClick",
            function(self, button)
                if button == "RightButton" then
                    avkDestroy()
                elseif button == "LeftButton" then
                    if GetCursorInfo() then
                        clickItemType, clickItemID, clickItemLink = GetCursorInfo()
                        if clickItemType ~= "item" then
                            notAnItemMessages()
                        else
                            if IsControlKeyDown() then
                                if checkItemOnGlobalProtectList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                                else
                                    addItemToList(AVKGlobalProtectTable, clickItemID)
                                end
                            elseif IsShiftKeyDown() then
                                if checkItemOnGlobalProtectList(clickItemID) then
                                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                                elseif checkItemOnCharacterProtectList(clickItemID) then
                                    alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
                                else
                                    addItemToList(AVKCharacterProtectTable, clickItemID)
                                end
                            elseif IsAltKeyDown() then
                                if checkItemValue(clickItemID) then
                                    if checkItemOnGlobalSellList(clickItemID) then
                                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                    else
                                        addItemToList(AVKGlobalSellTable, clickItemID)
                                    end
                                else
                                    if checkItemOnGlobalDestroyList(clickItemID) then
                                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                    else
                                        addItemToList(AVKGlobalDestroyTable, clickItemID)
                                    end
                                end
                            else
                                if checkItemValue(clickItemID) then
                                    if checkItemOnGlobalSellList(clickItemID) then
                                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                                    elseif checkItemOnCharacterSellList(clickItemID) then
                                        alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                                    else
                                        addItemToList(AVKCharacterSellTable, clickItemID)
                                    end
                                else
                                    if checkItemOnGlobalDestroyList(clickItemID) then
                                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                                    elseif checkItemOnCharacterDestroyList(clickItemID) then
                                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                                    else
                                        addItemToList(AVKCharacterDestroyTable, clickItemID)
                                    end
                                end
                            end
                            ClearCursor()
                        end
                    else
                        if AardvarkMainFrame:IsVisible() then
                            AardvarkMainFrame:Hide()
                        else
                            AardvarkMainFrame:Show()
                            updateListBasedOnPanel()
                        end
                    end
                end
            end
        )
        AardvarkMagicButton:SetScript(
            "OnLeave",
            function(self)
                GameTooltip:Hide()
            end
        )
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         aardvark action bar          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkActionBar = CreateFrame("Frame", "AardvarkActionBar", UIParent, "BackdropTemplate")
AardvarkActionBar:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkActionBar:SetMovable(true)
AardvarkActionBar:SetClampedToScreen(true)
AardvarkActionBar:SetToplevel(true)
AardvarkActionBar:Hide()

ActionBarAardvarkButton = CreateFrame("Button", "ActionBarAardvarkButton", AardvarkActionBar)
ActionBarAardvarkButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarAardvarkButton:SetNormalTexture(ImageList.avkButton)
ActionBarAardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
ActionBarAardvarkButton:EnableMouse(true)
ActionBarAardvarkButton:SetMovable(true)
ActionBarAardvarkButton:SetClampedToScreen(true)
ActionBarAardvarkButton:RegisterForDrag("MiddleButton")
ActionBarAardvarkButton:SetScript(
    "OnDragStart",
    function()
        ActionBarAardvarkButton:GetParent():StartMoving()
    end
)
ActionBarAardvarkButton:SetScript(
    "OnDragStop",
    function()
        ActionBarAardvarkButton:GetParent():StopMovingOrSizing()
    end
)
ActionBarAardvarkButton:SetScript(
    "OnClick",
    function()
        if AardvarkMainFrame:IsVisible() then
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
            updateListBasedOnPanel()
        end
    end
)

ActionBarDestroyButton = CreateFrame("Button", "ActionBarDestroyButton", AardvarkActionBar)
ActionBarDestroyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarDestroyButton:SetNormalTexture(ImageList.destroyButton)
ActionBarDestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, "BLEND")
ActionBarDestroyButton:RegisterForClicks("RightButtonUp")
ActionBarDestroyButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            avkDestroy()
        end
    end
)

ActionBarSellButton = CreateFrame("Button", "ActionBarSellButton", AardvarkActionBar)
ActionBarSellButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarSellButton:SetNormalTexture(ImageList.sellButton)
ActionBarSellButton:SetHighlightTexture(ImageList.sellButtonHover, "BLEND")
ActionBarSellButton:SetDisabledTexture(ImageList.sellOutOfRange)
ActionBarSellButton:Disable()
ActionBarSellButton:SetScript(
    "OnClick",
    function(self, button)
        avkSell()
    end
)

ActionBarProtectGlobalButton = CreateFrame("Button", "ActionBarProtectGlobalButton", AardvarkActionBar)
ActionBarProtectGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
ActionBarProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, "BLEND")
ActionBarProtectGlobalButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            else
                addItemToList(AVKGlobalProtectTable, dragItemID)
            end
        end
        ClearCursor()
    end
)
ActionBarProtectGlobalButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(clickItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                else
                    addItemToList(AVKGlobalProtectTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)

ActionBarProtectCharacterButton = CreateFrame("Button", "ActionBarProtectCharacterButton", AardvarkActionBar)
ActionBarProtectCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
ActionBarProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, "BLEND")
ActionBarProtectCharacterButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            elseif checkItemOnCharacterProtectList(dragItemID) then
                alreadyListedMessages(AVKCharacterProtectTable, dragItemLink)
            else
                addItemToList(AVKCharacterProtectTable, dragItemID)
            end
        end
        ClearCursor()
    end
)
ActionBarProtectCharacterButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemOnGlobalProtectList(clickItemID) then
                    alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                elseif checkItemOnCharacterProtectList(clickItemID) then
                    alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
                else
                    addItemToList(AVKCharacterProtectTable, clickItemID)
                end
            end
        end
        ClearCursor()
    end
)

ActionBarDestroyGlobalButton = CreateFrame("Button", "ActionBarDestroyGlobalButton", AardvarkActionBar)
ActionBarDestroyGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
ActionBarDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, "BLEND")
ActionBarDestroyGlobalButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if not checkItemValue(dragItemID) then
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, dragItemID)
                end
            else
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                else
                    addItemToList(AVKGlobalSellTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
ActionBarDestroyGlobalButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if not checkItemValue(clickItemID) then
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalDestroyTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalSellTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)

ActionBarDestroyCharacterButton = CreateFrame("Button", "ActionBarDestroyCharacterButton", AardvarkActionBar)
ActionBarDestroyCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
ActionBarDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, "BLEND")
ActionBarDestroyCharacterButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if not checkItemValue(dragItemID) then
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                elseif checkItemOnCharacterDestroyList(dragItemID) then
                    alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                else
                    addItemToList(AVKCharacterDestroyTable, dragItemID)
                end
            else
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                elseif checkItemOnCharacterSellList(dragItemID) then
                    alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                else
                    addItemToList(AVKCharacterSellTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
ActionBarDestroyCharacterButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if not checkItemValue(clickItemID) then
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    elseif checkItemOnCharacterDestroyList(clickItemID) then
                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterDestroyTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    elseif checkItemOnCharacterSellList(clickItemID) then
                        alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterSellTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)

ActionBarSellGlobalButton = CreateFrame("Button", "ActionBarSellGlobalButton", AardvarkActionBar)
ActionBarSellGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
ActionBarSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, "BLEND")
ActionBarSellGlobalButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemValue(dragItemID) then
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                else
                    addItemToList(AVKGlobalSellTable, dragItemID)
                end
            else
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                else
                    addItemToList(AVKGlobalDestroyTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
ActionBarSellGlobalButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemValue(clickItemID) then
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalSellTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKGlobalDestroyTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)

ActionBarSellCharacterButton = CreateFrame("Button", "ActionBarSellCharacterButton", AardvarkActionBar)
ActionBarSellCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
ActionBarSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, "BLEND")
ActionBarSellCharacterButton:SetScript(
    "OnReceiveDrag",
    function()
        dragItemType, dragItemID, dragItemLink = GetCursorInfo()
        if dragItemType ~= "item" then
            notAnItemMessages()
        else
            if checkItemValue(dragItemID) then
                if checkItemOnGlobalSellList(dragItemID) then
                    alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
                elseif checkItemOnCharacterSellList(dragItemID) then
                    alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
                else
                    addItemToList(AVKCharacterSellTable, dragItemID)
                end
            else
                if checkItemOnGlobalDestroyList(dragItemID) then
                    alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
                elseif checkItemOnCharacterDestroyList(dragItemID) then
                    alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
                else
                    addItemToList(AVKCharacterDestroyTable, dragItemID)
                end
            end
        end
        ClearCursor()
    end
)
ActionBarSellCharacterButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            else
                if checkItemValue(clickItemID) then
                    if checkItemOnGlobalSellList(clickItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                    elseif checkItemOnCharacterSellList(clickItemID) then
                        alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterSellTable, clickItemID)
                    end
                else
                    if checkItemOnGlobalDestroyList(clickItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                    elseif checkItemOnCharacterDestroyList(clickItemID) then
                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                    else
                        addItemToList(AVKCharacterDestroyTable, clickItemID)
                    end
                end
            end
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         filter list panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkFilterOptionsPanel = CreateFrame("Frame", "AardvarkFilterOptionsPanel", AardvarkSideFrame)
AardvarkFilterOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkFilterOptionsPanel:SetPoint("TOP", AardvarkSideFrame, "TOP", SizeList.mainFrameMarginGap)
AardvarkFilterOptionsPanel:Hide()

-- ===========================         check & uncheck buttons          ===========================
AardvarkFilterOptionsPanel.CheckAllButton =
    CreateFrame(
    "Button",
    "AardvarkFilterOptionsPanelCheckAllButton",
    AardvarkFilterOptionsPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkFilterOptionsPanel.CheckAllButton:SetSize(SizeList.scrollFrameWidth * .4, SizeList.clearButtonHight)
AardvarkFilterOptionsPanel.CheckAllButton:SetPoint(
    "TOPLEFT",
    AardvarkFilterOptionsPanel,
    13,
    -SizeList.checkboxFilterGapY * 1.1
)
AardvarkFilterOptionsPanel.CheckAllButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkFilterOptionsPanel.CheckAllButton:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkFilterOptionsPanel.CheckAllButton:SetNormalFontObject(FontButton)
AardvarkFilterOptionsPanel.CheckAllButton:SetHighlightFontObject(FontButton)
AardvarkFilterOptionsPanel.CheckAllButton:SetFormattedText("Check All")
AardvarkFilterOptionsPanel.CheckAllButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkFilterOptionsPanelCheckAllButton)
        updateListBasedOnPanel()
    end
)

AardvarkFilterOptionsPanel.UncheckAllButton =
    CreateFrame(
    "Button",
    "AardvarkFilterUncheckAll",
    AardvarkFilterOptionsPanel,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
AardvarkFilterOptionsPanel.UncheckAllButton:SetSize(SizeList.scrollFrameWidth * .4, SizeList.clearButtonHight)
AardvarkFilterOptionsPanel.UncheckAllButton:SetPoint(
    "RIGHT",
    AardvarkFilterOptionsPanelCheckAllButton,
    SizeList.checkboxFilterGapX,
    0
)
AardvarkFilterOptionsPanel.UncheckAllButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkFilterOptionsPanel.UncheckAllButton:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkFilterOptionsPanel.UncheckAllButton:SetNormalFontObject(FontButton)
AardvarkFilterOptionsPanel.UncheckAllButton:SetHighlightFontObject(FontButton)
AardvarkFilterOptionsPanel.UncheckAllButton:SetFormattedText("Uncheck All")
AardvarkFilterOptionsPanel.UncheckAllButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkFilterUncheckAll)
        updateListBasedOnPanel()
    end
)

-- ===========================         item rarity          ===========================
local CB_rarity_poor = CreateFrame("CheckButton", "CB_rarity_poor", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_poor:ClearAllPoints()
CB_rarity_poor:SetPoint("TOPLEFT", AardvarkFilterOptionsPanelCheckAllButton, 0, -SizeList.checkboxFilterGapY * 2)
CB_rarity_poor:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_poor.Text:SetText(ColourList.rarityPoor .. "  Poor")
CB_rarity_poor.Text:SetFontObject(FontFilter)
CB_rarity_poor:SetChecked(true)
CB_rarity_poor:SetScript(
    "OnClick",
    function()
        if FilterList.rarityPoor then
            FilterList.rarityPoor = false
        else
            FilterList.rarityPoor = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_common =
    CreateFrame("CheckButton", "CB_rarity_common", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_common:ClearAllPoints()
CB_rarity_common:SetPoint("BOTTOM", CB_rarity_poor, 0, -SizeList.checkboxFilterGapY)
CB_rarity_common:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_common.Text:SetText(ColourList.rarityCommon .. "  Common")
CB_rarity_common.Text:SetFontObject(FontFilter)
CB_rarity_common:SetChecked(true)
CB_rarity_common:SetScript(
    "OnClick",
    function()
        if FilterList.rarityCommon then
            FilterList.rarityCommon = false
        else
            FilterList.rarityCommon = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_uncommon =
    CreateFrame("CheckButton", "CB_rarity_uncommon", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_uncommon:ClearAllPoints()
CB_rarity_uncommon:SetPoint("BOTTOM", CB_rarity_common, 0, -SizeList.checkboxFilterGapY)
CB_rarity_uncommon:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_uncommon.Text:SetText(ColourList.rarityUncommon .. "  Uncommon")
CB_rarity_uncommon.Text:SetFontObject(FontFilter)
CB_rarity_uncommon:SetChecked(true)
CB_rarity_uncommon:SetScript(
    "OnClick",
    function()
        if FilterList.rarityUncommon then
            FilterList.rarityUncommon = false
        else
            FilterList.rarityUncommon = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_rare = CreateFrame("CheckButton", "CB_rarity_rare", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_rare:ClearAllPoints()
CB_rarity_rare:SetPoint("BOTTOM", CB_rarity_uncommon, 0, -SizeList.checkboxFilterGapY)
CB_rarity_rare:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_rare.Text:SetText(ColourList.rarityRare .. "  Rare")
CB_rarity_rare.Text:SetFontObject(FontFilter)
CB_rarity_rare:SetChecked(true)
CB_rarity_rare:SetScript(
    "OnClick",
    function()
        if FilterList.rarityRare then
            FilterList.rarityRare = false
        else
            FilterList.rarityRare = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_epic = CreateFrame("CheckButton", "CB_rarity_epic", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_epic:ClearAllPoints()
CB_rarity_epic:SetPoint("TOPLEFT", AardvarkFilterUncheckAll, 0, -SizeList.checkboxFilterGapY * 2)
CB_rarity_epic:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_epic.Text:SetText(ColourList.rarityEpic .. "  Epic")
CB_rarity_epic.Text:SetFontObject(FontFilter)
CB_rarity_epic:SetChecked(true)
CB_rarity_epic:SetScript(
    "OnClick",
    function()
        if FilterList.rarityEpic then
            FilterList.rarityEpic = false
        else
            FilterList.rarityEpic = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_legendary =
    CreateFrame("CheckButton", "CB_rarity_legendary", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_legendary:ClearAllPoints()
CB_rarity_legendary:SetPoint("BOTTOM", CB_rarity_epic, 0, -SizeList.checkboxFilterGapY)
CB_rarity_legendary:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_legendary.Text:SetText(ColourList.rarityLegendary .. "  Legendary")
CB_rarity_legendary.Text:SetFontObject(FontFilter)
CB_rarity_legendary:SetChecked(true)
CB_rarity_legendary:SetScript(
    "OnClick",
    function()
        if FilterList.rarityLegendary then
            FilterList.rarityLegendary = false
        else
            FilterList.rarityLegendary = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_artifact =
    CreateFrame("CheckButton", "CB_rarity_artifact", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_artifact:ClearAllPoints()
CB_rarity_artifact:SetPoint("BOTTOM", CB_rarity_legendary, 0, -SizeList.checkboxFilterGapY)
CB_rarity_artifact:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_artifact.Text:SetText(ColourList.rarityArtifact .. "  Artifact")
CB_rarity_artifact.Text:SetFontObject(FontFilter)
CB_rarity_artifact:SetChecked(true)
CB_rarity_artifact:SetScript(
    "OnClick",
    function()
        if FilterList.rarityArtifact then
            FilterList.rarityArtifact = false
        else
            FilterList.rarityArtifact = true
        end
        updateListBasedOnPanel()
    end
)

local CB_rarity_heirloom =
    CreateFrame("CheckButton", "CB_rarity_heirloom", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_heirloom:ClearAllPoints()
CB_rarity_heirloom:SetPoint("BOTTOM", CB_rarity_artifact, 0, -SizeList.checkboxFilterGapY)
CB_rarity_heirloom:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_rarity_heirloom.Text:SetText(ColourList.rarityHeirloom .. "  Heirloom")
CB_rarity_heirloom.Text:SetFontObject(FontFilter)
CB_rarity_heirloom:SetChecked(true)
CB_rarity_heirloom:SetScript(
    "OnClick",
    function()
        if FilterList.rarityHeirloom then
            FilterList.rarityHeirloom = false
        else
            FilterList.rarityHeirloom = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         item equip slot          ===========================
local CB_slot_head = CreateFrame("CheckButton", "CB_slot_head", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_head:ClearAllPoints()
CB_slot_head:SetPoint("BOTTOM", CB_rarity_rare, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_slot_head:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_head.Text:SetText("  Head")
CB_slot_head.Text:SetFontObject(FontFilter)
CB_slot_head:SetChecked(true)
CB_slot_head:SetScript(
    "OnClick",
    function()
        if FilterList.slotHead then
            FilterList.slotHead = false
        else
            FilterList.slotHead = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_neck = CreateFrame("CheckButton", "CB_slot_neck", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_neck:ClearAllPoints()
CB_slot_neck:SetPoint("BOTTOM", CB_slot_head, 0, -SizeList.checkboxFilterGapY)
CB_slot_neck:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_neck.Text:SetText("  Neck")
CB_slot_neck.Text:SetFontObject(FontFilter)
CB_slot_neck:SetChecked(true)
CB_slot_neck:SetScript(
    "OnClick",
    function()
        if FilterList.slotNeck then
            FilterList.slotNeck = false
        else
            FilterList.slotNeck = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_shoulders =
    CreateFrame("CheckButton", "CB_slot_shoulders", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_shoulders:ClearAllPoints()
CB_slot_shoulders:SetPoint("BOTTOM", CB_slot_neck, 0, -SizeList.checkboxFilterGapY)
CB_slot_shoulders:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_shoulders.Text:SetText("  Shoulders")
CB_slot_shoulders.Text:SetFontObject(FontFilter)
CB_slot_shoulders:SetChecked(true)
CB_slot_shoulders:SetScript(
    "OnClick",
    function()
        if FilterList.slotShoulders then
            FilterList.slotShoulders = false
        else
            FilterList.slotShoulders = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_cloak = CreateFrame("CheckButton", "CB_slot_cloak", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_cloak:ClearAllPoints()
CB_slot_cloak:SetPoint("BOTTOM", CB_slot_shoulders, 0, -SizeList.checkboxFilterGapY)
CB_slot_cloak:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_cloak.Text:SetText("  Cloak")
CB_slot_cloak.Text:SetFontObject(FontFilter)
CB_slot_cloak:SetChecked(true)
CB_slot_cloak:SetScript(
    "OnClick",
    function()
        if FilterList.slotCloak then
            FilterList.slotCloak = false
        else
            FilterList.slotCloak = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_chest = CreateFrame("CheckButton", "CB_slot_chest", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_chest:ClearAllPoints()
CB_slot_chest:SetPoint("BOTTOM", CB_slot_cloak, 0, -SizeList.checkboxFilterGapY)
CB_slot_chest:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_chest.Text:SetText("  Chest")
CB_slot_chest.Text:SetFontObject(FontFilter)
CB_slot_chest:SetChecked(true)
CB_slot_chest:SetScript(
    "OnClick",
    function()
        if FilterList.slotChest then
            FilterList.slotChest = false
        else
            FilterList.slotChest = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_shirt = CreateFrame("CheckButton", "CB_slot_shirt", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_shirt:ClearAllPoints()
CB_slot_shirt:SetPoint("BOTTOM", CB_slot_chest, 0, -SizeList.checkboxFilterGapY)
CB_slot_shirt:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_shirt.Text:SetText("  Shirt")
CB_slot_shirt.Text:SetFontObject(FontFilter)
CB_slot_shirt:SetChecked(true)
CB_slot_shirt:SetScript(
    "OnClick",
    function()
        if FilterList.slotShirt then
            FilterList.slotShirt = false
        else
            FilterList.slotShirt = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_tabard = CreateFrame("CheckButton", "CB_slot_tabard", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_tabard:ClearAllPoints()
CB_slot_tabard:SetPoint("BOTTOM", CB_slot_shirt, 0, -SizeList.checkboxFilterGapY)
CB_slot_tabard:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_tabard.Text:SetText("  Tabard")
CB_slot_tabard.Text:SetFontObject(FontFilter)
CB_slot_tabard:SetChecked(true)
CB_slot_tabard:SetScript(
    "OnClick",
    function()
        if FilterList.slotTabard then
            FilterList.slotTabard = false
        else
            FilterList.slotTabard = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_wrists = CreateFrame("CheckButton", "CB_slot_wrists", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_wrists:ClearAllPoints()
CB_slot_wrists:SetPoint("BOTTOM", CB_slot_tabard, 0, -SizeList.checkboxFilterGapY)
CB_slot_wrists:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_wrists.Text:SetText("  Wrists")
CB_slot_wrists.Text:SetFontObject(FontFilter)
CB_slot_wrists:SetChecked(true)
CB_slot_wrists:SetScript(
    "OnClick",
    function()
        if FilterList.slotWrists then
            FilterList.slotWrists = false
        else
            FilterList.slotWrists = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_hands = CreateFrame("CheckButton", "CB_slot_hands", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_hands:ClearAllPoints()
CB_slot_hands:SetPoint("BOTTOM", CB_rarity_heirloom, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_slot_hands:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_hands.Text:SetText("  Gloves")
CB_slot_hands.Text:SetFontObject(FontFilter)
CB_slot_hands:SetChecked(true)
CB_slot_hands:SetScript(
    "OnClick",
    function()
        if FilterList.slotHands then
            FilterList.slotHands = false
        else
            FilterList.slotHands = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_waist = CreateFrame("CheckButton", "CB_slot_waist", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_waist:ClearAllPoints()
CB_slot_waist:SetPoint("BOTTOM", CB_slot_hands, 0, -SizeList.checkboxFilterGapY)
CB_slot_waist:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_waist.Text:SetText("  Belt")
CB_slot_waist.Text:SetFontObject(FontFilter)
CB_slot_waist:SetChecked(true)
CB_slot_waist:SetScript(
    "OnClick",
    function()
        if FilterList.slotWaist then
            FilterList.slotWaist = false
        else
            FilterList.slotWaist = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_legs = CreateFrame("CheckButton", "CB_slot_legs", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_legs:ClearAllPoints()
CB_slot_legs:SetPoint("BOTTOM", CB_slot_waist, 0, -SizeList.checkboxFilterGapY)
CB_slot_legs:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_legs.Text:SetText("  Legs")
CB_slot_legs.Text:SetFontObject(FontFilter)
CB_slot_legs:SetChecked(true)
CB_slot_legs:SetScript(
    "OnClick",
    function()
        if FilterList.slotLegs then
            FilterList.slotLegs = false
        else
            FilterList.slotLegs = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_feet = CreateFrame("CheckButton", "CB_slot_feet", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_feet:ClearAllPoints()
CB_slot_feet:SetPoint("BOTTOM", CB_slot_legs, 0, -SizeList.checkboxFilterGapY)
CB_slot_feet:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_feet.Text:SetText("  Feet")
CB_slot_feet.Text:SetFontObject(FontFilter)
CB_slot_feet:SetChecked(true)
CB_slot_feet:SetScript(
    "OnClick",
    function()
        if FilterList.slotFeet then
            FilterList.slotFeet = false
        else
            FilterList.slotFeet = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_rings = CreateFrame("CheckButton", "CB_slot_rings", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_rings:ClearAllPoints()
CB_slot_rings:SetPoint("BOTTOM", CB_slot_feet, 0, -SizeList.checkboxFilterGapY)
CB_slot_rings:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_rings.Text:SetText("  Rings")
CB_slot_rings.Text:SetFontObject(FontFilter)
CB_slot_rings:SetChecked(true)
CB_slot_rings:SetScript(
    "OnClick",
    function()
        if FilterList.slotRings then
            FilterList.slotRings = false
        else
            FilterList.slotRings = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_trinkets =
    CreateFrame("CheckButton", "CB_slot_trinkets", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_trinkets:ClearAllPoints()
CB_slot_trinkets:SetPoint("BOTTOM", CB_slot_rings, 0, -SizeList.checkboxFilterGapY)
CB_slot_trinkets:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_trinkets.Text:SetText("  Trinkets")
CB_slot_trinkets.Text:SetFontObject(FontFilter)
CB_slot_trinkets:SetChecked(true)
CB_slot_trinkets:SetScript(
    "OnClick",
    function()
        if FilterList.slotTrinkets then
            FilterList.slotTrinkets = false
        else
            FilterList.slotTrinkets = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_mainHand =
    CreateFrame("CheckButton", "CB_slot_mainHand", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_mainHand:ClearAllPoints()
CB_slot_mainHand:SetPoint("BOTTOM", CB_slot_trinkets, 0, -SizeList.checkboxFilterGapY)
CB_slot_mainHand:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_mainHand.Text:SetText("  Main Hand")
CB_slot_mainHand.Text:SetFontObject(FontFilter)
CB_slot_mainHand:SetChecked(true)
CB_slot_mainHand:SetScript(
    "OnClick",
    function()
        if FilterList.slotMainHand then
            FilterList.slotMainHand = false
        else
            FilterList.slotMainHand = true
        end
        updateListBasedOnPanel()
    end
)

local CB_slot_offHand =
    CreateFrame("CheckButton", "CB_slot_offHand", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_slot_offHand:ClearAllPoints()
CB_slot_offHand:SetPoint("BOTTOM", CB_slot_mainHand, 0, -SizeList.checkboxFilterGapY)
CB_slot_offHand:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_slot_offHand.Text:SetText("  Off Hand")
CB_slot_offHand.Text:SetFontObject(FontFilter)
CB_slot_offHand:SetChecked(true)
CB_slot_offHand:SetScript(
    "OnClick",
    function()
        if FilterList.slotOffHand then
            FilterList.slotOffHand = false
        else
            FilterList.slotOffHand = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         item bind          ===========================
local CB_bind_none = CreateFrame("CheckButton", "CB_bind_none", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_bind_none:ClearAllPoints()
CB_bind_none:SetPoint("BOTTOM", CB_slot_wrists, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_none:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_none.Text:SetText("  No Bind")
CB_bind_none.Text:SetFontObject(FontFilter)
CB_bind_none:SetChecked(true)
CB_bind_none:SetScript(
    "OnClick",
    function()
        if FilterList.bindingNone then
            FilterList.bindingNone = false
        else
            FilterList.bindingNone = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_bop = CreateFrame("CheckButton", "CB_bind_bop", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_bind_bop:ClearAllPoints()
CB_bind_bop:SetPoint("BOTTOM", CB_bind_none, 0, -SizeList.checkboxFilterGapY)
CB_bind_bop:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_bop.Text:SetText("  Bind on Pickup")
CB_bind_bop.Text:SetFontObject(FontFilter)
CB_bind_bop:SetChecked(true)
CB_bind_bop:SetScript(
    "OnClick",
    function()
        if FilterList.bindOnPickup then
            FilterList.bindOnPickup = false
        else
            FilterList.bindOnPickup = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_boe = CreateFrame("CheckButton", "CB_bind_boe", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_bind_boe:ClearAllPoints()
CB_bind_boe:SetPoint("BOTTOM", CB_slot_offHand, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_boe:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_boe.Text:SetText("  Bind on Equip")
CB_bind_boe.Text:SetFontObject(FontFilter)
CB_bind_boe:SetChecked(true)
CB_bind_boe:SetScript(
    "OnClick",
    function()
        if FilterList.bindOnEquip then
            FilterList.bindOnEquip = false
        else
            FilterList.bindOnEquip = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_use = CreateFrame("CheckButton", "CB_bind_use", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_bind_use:ClearAllPoints()
CB_bind_use:SetPoint("BOTTOM", CB_bind_boe, 0, -SizeList.checkboxFilterGapY)
CB_bind_use:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_use.Text:SetText("  Bind on Use")
CB_bind_use.Text:SetFontObject(FontFilter)
CB_bind_use:SetChecked(true)
CB_bind_use:SetScript(
    "OnClick",
    function()
        if FilterList.bindOnUse then
            FilterList.bindOnUse = false
        else
            FilterList.bindOnUse = true
        end
        updateListBasedOnPanel()
    end
)

local CB_bind_quest = CreateFrame("CheckButton", "CB_bind_quest", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_bind_quest:ClearAllPoints()
CB_bind_quest:SetPoint("BOTTOM", CB_bind_use, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_bind_quest:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_bind_quest.Text:SetText("  Quest Items")
CB_bind_quest.Text:SetFontObject(FontFilter)
CB_bind_quest:SetChecked(true)
CB_bind_quest:SetScript(
    "OnClick",
    function()
        if FilterList.bindOnQuest then
            FilterList.bindOnQuest = false
        else
            FilterList.bindOnQuest = true
        end
        updateListBasedOnPanel()
    end
)

-- ===========================         other items          ===========================
local CB_otherMounts = CreateFrame("CheckButton", "CB_otherMounts", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_otherMounts:ClearAllPoints()
CB_otherMounts:SetPoint("BOTTOM", CB_bind_bop, 0, -SizeList.checkboxFilterGapY * 1.4)
CB_otherMounts:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherMounts.Text:SetText("  Mounts")
CB_otherMounts.Text:SetFontObject(FontFilter)
CB_otherMounts:SetChecked(true)
CB_otherMounts:SetScript(
    "OnClick",
    function()
        if FilterList.otherMounts then
            FilterList.otherMounts = false
        else
            FilterList.otherMounts = true
        end
        updateListBasedOnPanel()
    end
)

local CB_otherPets = CreateFrame("CheckButton", "CB_otherPets", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_otherPets:ClearAllPoints()
CB_otherPets:SetPoint("BOTTOM", CB_otherMounts, 0, -SizeList.checkboxFilterGapY)
CB_otherPets:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherPets.Text:SetText("  Pets")
CB_otherPets.Text:SetFontObject(FontFilter)
CB_otherPets:SetChecked(true)
CB_otherPets:SetScript(
    "OnClick",
    function()
        if FilterList.otherPets then
            FilterList.otherPets = false
        else
            FilterList.otherPets = true
        end
        updateListBasedOnPanel()
    end
)

local CB_otherBags = CreateFrame("CheckButton", "CB_otherBags", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_otherBags:ClearAllPoints()
CB_otherBags:SetPoint("BOTTOM", CB_otherPets, 0, -SizeList.checkboxFilterGapY)
CB_otherBags:SetSize(SizeList.checkboxFilterSize, SizeList.checkboxFilterSize)
CB_otherBags.Text:SetText("  Bags")
CB_otherBags.Text:SetFontObject(FontFilter)
CB_otherBags:SetChecked(true)
CB_otherBags:SetScript(
    "OnClick",
    function()
        if FilterList.otherBags then
            FilterList.otherBags = false
        else
            FilterList.otherBags = true
        end
        updateListBasedOnPanel()
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         special add panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkSpecialAddPanel = CreateFrame("Frame", "AardvarkSpecialAddPanel", AardvarkSideFrame)
AardvarkSpecialAddPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight / 2
)
AardvarkSpecialAddPanel:SetPoint("TOP", AardvarkSideFrame, "TOP", SizeList.mainFrameMarginGap)

-- ===========================         special add panel title          ===========================
local AardvarkSpecialAddPanelTitle = CreateFrame("Frame", "AardvarkSpecialAddPanelTitle", AardvarkSpecialAddPanel)
AardvarkSpecialAddPanelTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialAddPanelTitle:SetPoint("TOP", AardvarkSpecialAddPanel, 0, -SizeList.mainPanelElementGap)
AardvarkSpecialAddPanelTitleText = AardvarkSpecialAddPanelTitle:CreateFontString("AardvarkSpecialAddPanelTitleText")
AardvarkSpecialAddPanelTitleText:SetJustifyH("CENTER")
AardvarkSpecialAddPanelTitleText:SetJustifyV("CENTER")
AardvarkSpecialAddPanelTitleText:SetAllPoints(AardvarkSpecialAddPanelTitle)
AardvarkSpecialAddPanelTitleText:SetFontObject(FontCheckBoxBig)
AardvarkSpecialAddPanelTitleText:SetText(ColourList.textBlue .. "Special Add")
-- special add item by ID title
local AardvarkSpecialAddItemByIDTitle = CreateFrame("Frame", "AardvarkSpecialAddItemByIDTitle", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemByIDTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialAddItemByIDTitle:SetPoint("TOP", AardvarkSpecialAddPanelTitle, 0, -SizeList.mainPanelElementGap * 2)
AardvarkSpecialAddItemByIDTitleText =
    AardvarkSpecialAddItemByIDTitle:CreateFontString("AardvarkSpecialAddItemByIDTitleText")
AardvarkSpecialAddItemByIDTitleText:SetPoint("CENTER", 0, 0)
AardvarkSpecialAddItemByIDTitleText:SetFontObject(FontContent)
AardvarkSpecialAddItemByIDTitleText:SetText("Enter Item ID")
-- item ID text outline border
AardvarkSpecialAddOutlineBorderFrame =
    CreateFrame(
    "Frame",
    "AardvarkSpecialAddOutlineBorderFrame",
    AardvarkSpecialAddPanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkSpecialAddOutlineBorderFrame:SetPoint(
    "CENTER",
    AardvarkSpecialAddItemByIDTitle,
    "CENTER",
    0,
    SizeList.scrollTitlePointY * 1.5
)
AardvarkSpecialAddOutlineBorderFrame:SetSize(135, 30)
AardvarkSpecialAddOutlineBorderFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSpecialAddOutlineBorderFrame:SetBackdropBorderColor(0, 1, 1, 1)
-- item ID text box
AardvarkSpecialAddTextBox =
    CreateFrame("EditBox", "AardvarkSpecialAddTextBox", AardvarkSpecialAddPanel, "AutoCompleteEditBoxTemplate")
AardvarkSpecialAddTextBox:SetPoint("CENTER", AardvarkSpecialAddOutlineBorderFrame, "CENTER", 2, 0)
AardvarkSpecialAddTextBox:SetFontObject(FontContent)
AardvarkSpecialAddTextBox:SetText("")
AardvarkSpecialAddTextBox:SetNumeric(true)
AardvarkSpecialAddTextBox:SetSize(110, 20)
AardvarkSpecialAddTextBox:SetScale(1.1)
AardvarkSpecialAddTextBox:SetAutoFocus(false)
AardvarkSpecialAddTextBox:SetMaxLetters(15)

-- ===========================         special add global destroy button          ===========================
AardvarkSpecialAddItemDestroyGlobalButton =
    CreateFrame("Button", "AardvarkSpecialAddItemDestroyGlobalButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemDestroyGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemDestroyGlobalButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialAddTextBox,
    0,
    SizeList.scrollTitlePointY * 3.5
)
AardvarkSpecialAddItemDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
AardvarkSpecialAddItemDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, "BLEND")
AardvarkSpecialAddItemDestroyGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalDestroyList(dragItemID) then
                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
            else
                addItemToList(AVKGlobalDestroyTable, dragItemID)
            end
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialAddItemDestroyGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalDestroyList(clickItemID) then
                alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
            else
                addItemToList(AVKGlobalDestroyTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalDestroyList(textItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKGlobalDestroyTable, textItemID)
                    end
                end
            )
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)
-- special add character destroy button
AardvarkSpecialAddItemDestroyCharacterButton =
    CreateFrame("Button", "AardvarkSpecialAddItemDestroyCharacterButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemDestroyCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemDestroyCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialAddItemDestroyGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialAddItemDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
AardvarkSpecialAddItemDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, "BLEND")
AardvarkSpecialAddItemDestroyCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalDestroyList(dragItemID) then
                alreadyListedMessages(AVKGlobalDestroyTable, dragItemLink)
            elseif checkItemOnCharacterDestroyList(dragItemID) then
                alreadyListedMessages(AVKCharacterDestroyTable, dragItemLink)
            else
                addItemToList(AVKCharacterDestroyTable, dragItemID)
            end
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialAddItemDestroyCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalDestroyList(clickItemID) then
                alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
            elseif checkItemOnCharacterDestroyList(clickItemID) then
                alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
            else
                addItemToList(AVKCharacterDestroyTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalDestroyList(textItemID) then
                        alreadyListedMessages(AVKGlobalDestroyTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    elseif checkItemOnCharacterDestroyList(textItemID) then
                        alreadyListedMessages(AVKCharacterDestroyTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKCharacterDestroyTable, textItemID)
                    end
                end
            )
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)

-- ===========================         special add global sell button          ===========================
AardvarkSpecialAddItemSellGlobalButton =
    CreateFrame("Button", "AardvarkSpecialAddItemSellGlobalButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemSellGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemSellGlobalButton:SetPoint(
    "LEFT",
    AardvarkSpecialAddItemDestroyGlobalButton,
    SizeList.scrollTitlePointY * 4,
    0
)
AardvarkSpecialAddItemSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
AardvarkSpecialAddItemSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, "BLEND")
AardvarkSpecialAddItemSellGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalSellList(dragItemID) then
                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
            else
                addItemToList(AVKGlobalSellTable, dragItemID)
            end
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialAddItemSellGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalSellList(clickItemID) then
                alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
            else
                addItemToList(AVKGlobalSellTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalSellList(textItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKGlobalSellTable, textItemID)
                    end
                end
            )
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)

-- ===========================         special add character sell button          ===========================
AardvarkSpecialAddItemSellCharacterButton =
    CreateFrame("Button", "AardvarkSpecialAddItemSellCharacterButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemSellCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemSellCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialAddItemSellGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialAddItemSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
AardvarkSpecialAddItemSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, "BLEND")
AardvarkSpecialAddItemSellCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalSellList(dragItemID) then
                alreadyListedMessages(AVKGlobalSellTable, dragItemLink)
            elseif checkItemOnCharacterSellList(dragItemID) then
                alreadyListedMessages(AVKCharacterSellTable, dragItemLink)
            else
                addItemToList(AVKCharacterSellTable, dragItemID)
            end
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialAddItemSellCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalSellList(clickItemID) then
                alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
            elseif checkItemOnCharacterSellList(clickItemID) then
                alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
            else
                addItemToList(AVKCharacterSellTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalSellList(textItemID) then
                        alreadyListedMessages(AVKGlobalSellTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    elseif checkItemOnCharacterSellList(textItemID) then
                        alreadyListedMessages(AVKCharacterSellTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKCharacterSellTable, textItemID)
                    end
                end
            )
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)

-- ===========================         special add global protect button          ===========================
AardvarkSpecialAddItemProtectGlobalButton =
    CreateFrame("Button", "AardvarkSpecialAddItemProtectGlobalButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemProtectGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemProtectGlobalButton:SetPoint(
    "RIGHT",
    AardvarkSpecialAddItemDestroyGlobalButton,
    -SizeList.scrollTitlePointY * 4,
    0
)
AardvarkSpecialAddItemProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
AardvarkSpecialAddItemProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, "BLEND")
AardvarkSpecialAddItemProtectGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            else
                addItemToList(AVKGlobalProtectTable, dragItemID)
            end
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialAddItemProtectGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalProtectList(clickItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
            else
                addItemToList(AVKGlobalProtectTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalProtectList(textItemID) then
                        alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKGlobalProtectTable, textItemID)
                    end
                end
            )
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)

-- ===========================         special add character protect button          ===========================
AardvarkSpecialAddItemProtectCharacterButton =
    CreateFrame("Button", "AardvarkSpecialAddItemProtectCharacterButton", AardvarkSpecialAddPanel)
AardvarkSpecialAddItemProtectCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialAddItemProtectCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialAddItemProtectGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialAddItemProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
AardvarkSpecialAddItemProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, "BLEND")
AardvarkSpecialAddItemProtectCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalProtectList(dragItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, dragItemLink)
            elseif checkItemOnCharacterProtectList(dragItemID) then
                alreadyListedMessages(AVKCharacterProtectTable, dragItemLink)
            else
                addItemToList(AVKCharacterProtectTable, dragItemID)
            end
        end
        avkUpdateCharacterProtectList()
        ClearCursor()
    end
)
AardvarkSpecialAddItemProtectCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
            elseif checkItemOnGlobalProtectList(clickItemID) then
                alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
            elseif checkItemOnCharacterProtectList(clickItemID) then
                alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
            else
                addItemToList(AVKCharacterProtectTable, clickItemID)
            end
        else
            textItemID = AardvarkSpecialAddTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if checkItemOnGlobalProtectList(textItemID) then
                        alreadyListedMessages(AVKGlobalProtectTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    elseif checkItemOnCharacterProtectList(textItemID) then
                        alreadyListedMessages(AVKCharacterProtectTable, clickItemLink)
                        AardvarkSpecialAddTextBox:SetText("")
                    else
                        addItemToList(AVKCharacterProtectTable, textItemID)
                        if not AardvarkProtectPanel:IsVisible() then
                            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
                        else
                            avkUpdateCharacterProtectList()
                        end
                    end
                end
            )
        end
        ClearCursor()
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         special remove panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local AardvarkSpecialRemovePanel = CreateFrame("Frame", "AardvarkSpecialRemovePanel", AardvarkSideFrame)
AardvarkSpecialRemovePanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight / 2
)
AardvarkSpecialRemovePanel:SetPoint("TOP", AardvarkSpecialAddPanel, "BOTTOM", SizeList.mainFrameMarginGap)
-- special remove panel title
local AardvarkSpecialRemovePanelTitle =
    CreateFrame("Frame", "AardvarkSpecialRemovePanelTitle", AardvarkSpecialRemovePanel)
AardvarkSpecialRemovePanelTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialRemovePanelTitle:SetPoint("TOP", AardvarkSpecialRemovePanel, 0, SizeList.mainPanelElementGap)
AardvarkSpecialRemovePanelTitleText =
    AardvarkSpecialRemovePanelTitle:CreateFontString("AardvarkSpecialRemovePanelTitleText")
AardvarkSpecialRemovePanelTitleText:SetJustifyH("CENTER")
AardvarkSpecialRemovePanelTitleText:SetJustifyV("CENTER")
AardvarkSpecialRemovePanelTitleText:SetAllPoints(AardvarkSpecialRemovePanelTitle)
AardvarkSpecialRemovePanelTitleText:SetFontObject(FontCheckBoxBig)
AardvarkSpecialRemovePanelTitleText:SetText(ColourList.textBlue .. "Special Remove")
-- special remove item by ID title
local AardvarkSpecialRemoveItemByIDTitle =
    CreateFrame("Frame", "AardvarkSpecialRemoveItemByIDTitle", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemByIDTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSpecialRemoveItemByIDTitle:SetPoint(
    "TOP",
    AardvarkSpecialRemovePanelTitle,
    0,
    -SizeList.mainPanelElementGap * 2
)
AardvarkSpecialRemoveItemByIDTitleText =
    AardvarkSpecialRemoveItemByIDTitle:CreateFontString("AardvarkSpecialRemoveItemByIDTitleText")
AardvarkSpecialRemoveItemByIDTitleText:SetPoint("CENTER", 0, 0)
AardvarkSpecialRemoveItemByIDTitleText:SetFontObject(FontContent)
AardvarkSpecialRemoveItemByIDTitleText:SetText("Enter Item ID")
-- item ID text outline border
AardvarkSpecialRemoveOutlineBorderFrame =
    CreateFrame(
    "Frame",
    "AardvarkSpecialRemoveOutlineBorderFrame",
    AardvarkSpecialRemovePanel,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
AardvarkSpecialRemoveOutlineBorderFrame:SetPoint(
    "CENTER",
    AardvarkSpecialRemoveItemByIDTitle,
    "CENTER",
    0,
    SizeList.scrollTitlePointY * 1.5
)
AardvarkSpecialRemoveOutlineBorderFrame:SetSize(135, 30)
AardvarkSpecialRemoveOutlineBorderFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSpecialRemoveOutlineBorderFrame:SetBackdropBorderColor(0, 1, 1, 1)
-- item ID text box
AardvarkSpecialRemoveTextBox =
    CreateFrame("EditBox", "AardvarkSpecialRemoveTextBox", AardvarkSpecialRemovePanel, "AutoCompleteEditBoxTemplate")
AardvarkSpecialRemoveTextBox:SetPoint("CENTER", AardvarkSpecialRemoveOutlineBorderFrame, "CENTER", 2, 0)
AardvarkSpecialRemoveTextBox:SetFontObject(FontContent)
AardvarkSpecialRemoveTextBox:SetText("")
AardvarkSpecialRemoveTextBox:SetNumeric(true)
AardvarkSpecialRemoveTextBox:SetSize(110, 20)
AardvarkSpecialRemoveTextBox:SetScale(1.1)
AardvarkSpecialRemoveTextBox:SetAutoFocus(false)
AardvarkSpecialRemoveTextBox:SetMaxLetters(15)

-- ===========================         special remove global destroy button          ===========================
AardvarkSpecialRemoveItemDestroyGlobalButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemDestroyGlobalButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemDestroyGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemDestroyGlobalButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialRemoveTextBox,
    0,
    SizeList.scrollTitlePointY * 3.5
)
AardvarkSpecialRemoveItemDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
AardvarkSpecialRemoveItemDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, "BLEND")
AardvarkSpecialRemoveItemDestroyGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalDestroyList(dragItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalDestroyTable, dragItemLink)
            end
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemDestroyGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalDestroyList(clickItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalDestroyTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        notAnItemMessages()
                        textBoxRemoveInvalidMessages()
                    elseif not checkItemOnGlobalDestroyList(textItemID) then
                        textBoxRemoveNotListedMessages()
                    else
                        removeItemFromList(AVKGlobalDestroyTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)

-- ===========================         special remove character destroy button          ===========================
AardvarkSpecialRemoveItemDestroyCharacterButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemDestroyCharacterButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemDestroyCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemDestroyCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialRemoveItemDestroyGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialRemoveItemDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
AardvarkSpecialRemoveItemDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, "BLEND")
AardvarkSpecialRemoveItemDestroyCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnCharacterDestroyList(dragItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKCharacterDestroyTable, dragItemLink)
            end
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemDestroyCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnCharacterDestroyList(clickItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKCharacterDestroyTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        notAnItemMessages()
                        textBoxRemoveInvalidMessages()
                    elseif not checkItemOnCharacterDestroyList(textItemID) then
                        textBoxRemoveNotListedMessages()
                    else
                        removeItemFromList(AVKCharacterDestroyTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkDestroyPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelDestroyButton)
        end
        ClearCursor()
    end
)

-- ===========================         special remove global sell button          ===========================
AardvarkSpecialRemoveItemSellGlobalButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemSellGlobalButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemSellGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemSellGlobalButton:SetPoint(
    "LEFT",
    AardvarkSpecialRemoveItemDestroyGlobalButton,
    SizeList.scrollTitlePointY * 4,
    0
)
AardvarkSpecialRemoveItemSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
AardvarkSpecialRemoveItemSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, "BLEND")
AardvarkSpecialRemoveItemSellGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalSellList(dragItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalSellTable, dragItemLink)
            end
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemSellGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalSellList(clickItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalSellTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        notAnItemMessages()
                        textBoxRemoveInvalidMessages()
                    elseif not checkItemOnGlobalSellList(textItemID) then
                        textBoxRemoveNotListedMessages()
                    else
                        removeItemFromList(AVKGlobalSellTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)

-- ===========================         special remove character sell button          ===========================
AardvarkSpecialRemoveItemSellCharacterButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemSellCharacterButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemSellCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemSellCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialRemoveItemSellGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialRemoveItemSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
AardvarkSpecialRemoveItemSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, "BLEND")
AardvarkSpecialRemoveItemSellCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnCharacterSellList(dragItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKCharacterSellTable, dragItemLink)
            end
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemSellCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnCharacterSellList(clickItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKCharacterSellTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        notAnItemMessages()
                        textBoxRemoveInvalidMessages()
                    elseif not checkItemOnCharacterSellList(textItemID) then
                        textBoxRemoveNotListedMessages()
                    else
                        removeItemFromList(AVKCharacterSellTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkSellPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelSellButton)
        end
        ClearCursor()
    end
)
-- ===========================         special remove global protect button          ===========================
AardvarkSpecialRemoveItemProtectGlobalButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemProtectGlobalButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemProtectGlobalButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemProtectGlobalButton:SetPoint(
    "RIGHT",
    AardvarkSpecialRemoveItemDestroyGlobalButton,
    -SizeList.scrollTitlePointY * 4,
    0
)
AardvarkSpecialRemoveItemProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
AardvarkSpecialRemoveItemProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, "BLEND")
AardvarkSpecialRemoveItemProtectGlobalButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalProtectList(dragItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalProtectTable, dragItemLink)
            end
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemProtectGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                notAnItemMessages()
                textBoxRemoveInvalidMessages()
            elseif not checkItemOnGlobalProtectList(clickItemID) then
                textBoxRemoveNotListedMessages()
            else
                removeItemFromList(AVKGlobalProtectTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        notAnItemMessages()
                        textBoxRemoveInvalidMessages()
                    elseif not checkItemOnGlobalProtectList(textItemID) then
                        textBoxRemoveNotListedMessages()
                    else
                        removeItemFromList(AVKGlobalProtectTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)

-- ===========================         special remove character protect button          ===========================
local AardvarkSpecialRemoveItemProtectCharacterButton =
    CreateFrame("Button", "AardvarkSpecialRemoveItemProtectCharacterButton", AardvarkSpecialRemovePanel)
AardvarkSpecialRemoveItemProtectCharacterButton:SetSize(
    SizeList.mainFrameNavigationButtonSize,
    SizeList.mainFrameNavigationButtonSize
)
AardvarkSpecialRemoveItemProtectCharacterButton:SetPoint(
    "BOTTOM",
    AardvarkSpecialRemoveItemProtectGlobalButton,
    0,
    SizeList.scrollTitlePointY * 4
)
AardvarkSpecialRemoveItemProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
AardvarkSpecialRemoveItemProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, "BLEND")
AardvarkSpecialRemoveItemProtectCharacterButton:SetScript(
    "OnReceiveDrag",
    function(self, button)
        if GetCursorInfo() then
            dragItemType, dragItemID, dragItemLink = GetCursorInfo()
            if dragItemType ~= "item" then
                textBoxRemoveInvalidMessages()
                print("not an item")
            elseif not checkItemOnCharacterProtectList(dragItemID) then
                textBoxRemoveNotListedMessages()
                print("item not found", textItemID)
            else
                removeItemFromList(AVKCharacterProtectTable, dragItemLink)
            end
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)
AardvarkSpecialRemoveItemProtectCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            local clickItemType, clickItemID, clickItemLink = GetCursorInfo()
            if clickItemType ~= "item" then
                textBoxRemoveInvalidMessages()
                print("not an item")
            elseif not checkItemOnCharacterProtectList(clickItemID) then
                textBoxRemoveNotListedMessages()
                print("item not found", clickItemID)
            else
                removeItemFromList(AVKCharacterProtectTable, clickItemLink)
            end
        else
            local textItemID = AardvarkSpecialRemoveTextBox:GetNumber()
            local textItemName, textItemLink = GetItemInfo(textItemID)
            C_Timer.After(
                VariableList.sellDelay,
                function(self)
                    if textItemID ~= "item" then
                        textBoxRemoveInvalidMessages()
                        print("not an item", textItemID)
                    elseif not checkItemOnCharacterProtectList(textItemID) then
                        textBoxRemoveNotListedMessages()
                        print("item not found", textItemID)
                    else
                        removeItemFromList(AVKCharacterProtectTable, textItemLink)
                    end
                end
            )
        end
        if not AardvarkProtectPanel:IsVisible() then
            toggleAVKPanels(AardvarkNavigationPanelProtectButton)
        end
        ClearCursor()
    end
)

-- ===========================         special add/remove text          ===========================
local AardvarkSpecialAddRemoveTextBox = CreateFrame("Frame", "AardvarkSpecialAddRemoveTextBox", AardvarkSpecialAddPanel)
AardvarkSpecialAddRemoveTextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight / 4 - SizeList.mainPanelElementGap
)
AardvarkSpecialAddRemoveTextBox:SetPoint("BOTTOM", AardvarkSideFrame, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkSpecialAddRemoveTextBox.Text =
    AardvarkSpecialAddRemoveTextBox:CreateFontString("AardvarkSpecialAddRemoveTextBoxText")
AardvarkSpecialAddRemoveTextBox.Text:SetJustifyH("BOTTOM")
AardvarkSpecialAddRemoveTextBox.Text:SetJustifyV("BOTTOM")
AardvarkSpecialAddRemoveTextBox.Text:SetAllPoints(AardvarkSpecialAddRemoveTextBox)
AardvarkSpecialAddRemoveTextBox.Text:SetFontObject(FontContent)
AardvarkSpecialAddRemoveTextBox.Text:SetText(TextList.avkSpecialAddRemove)
